DECLARE FUNCTION FileString$ (Pointer&)
DECLARE SUB Intro ()
DECLARE SUB Main ()
DECLARE SUB GetChoice (choice%)
DECLARE SUB InitializeData ()

TYPE animal
   yes AS LONG
   no AS LONG
   animal AS LONG
END TYPE

CONST cAssign = 1
CONST cRetrieve = 2

CONST False = 0
CONST True = NOT False

Intro
DO: K$ = INKEY$: LOOP UNTIL LEN(K$)
DO UNTIL K$ = CHR$(27)
   VIEW PRINT 5 TO 25
   Main
   VIEW PRINT 1 TO 25
   Intro
   DO: K$ = INKEY$: LOOP UNTIL LEN(K$)
LOOP

FUNCTION FileString$ (Pointer&)
    GET 1, Pointer&, StrLen%
    TempString$ = SPACE$(StrLen$)
    GET 1, Pointer&, TempString$
    FileString$ = TempString$
END FUNCTION

DEFINT A-Z
SUB G (A$) : SHARED C$: FOR Q = 2 TO 9: DO: S = INSTR(A$, CHR$(Q + 38))
IF S THEN A$ = LEFT$(A$, S - 1) + STRING$(Q, 97) + MID$(A$, S + 1)
LOOP WHILE S: NEXT: C$ = C$ + A$: END SUB

DEFSNG A-Z
SUB GetChoice (choice%)
'gets a y/n response from the user and returns it as -1 (for y) or 0 (for n)

LOCATE , , 1

DO
   K$ = INKEY$
LOOP WHILE UCASE$(K$) <> "Y" AND UCASE$(K$) <> "N"
choice% = (UCASE$(K$) = "Y")
PRINT K$;

LOCATE , , 0

END SUB

SUB InitializeData
'initializes file #1 to include one question and two animals.

DIM animal AS animal    'the question/animals

animal.animal = "Does your animal swim a lot?"
animal.yes = 2
animal.no = 3
PUT #1, 1, animal

animal.animal = "goldfish"
animal.yes = -1
animal.no = -1
PUT #1, 2, animal

animal.animal = "cat"
animal.yes = -1
animal.no = -1
PUT #1, 3, animal

END SUB

SUB Intro

CLS
PRINT TAB(37); "Animal"
PRINT TAB(34); "by Jim Little"
PRINT
PRINT
PRINT "Think of an animal, and I will attempt to guess it.  As you play, I will"
PRINT "learn more animals.  Eventually, I will know every common animal."
PRINT
PRINT "Press any key when you've thought of an animal, or ESC to quit."

END SUB

SUB Main
'This is the main program driver.

DIM animalnum&       'animal/question being checked/asked
DIM animal AS animal
DIM usersanimal$     'the user's animal/question
DIM companimal$      'the computer's animal/question
DIM newanimal AS animal  'new animal being added to data
DIM choice%          'yes or no response from user (yes is -1,  no is 0)
DIM records&         'number of records in ANIMAL.DAT

OPEN "AIDB.DAT" FOR RANDOM AS #1 LEN = LEN(animal)
IF LOF(1) = 0 THEN
   InitializeData
END IF

CLS
animalnum& = 1
GET #1, animalnum&, animal
companimal$ = RTRIM$(FileString$(animal.animal))
DO
   IF animal.yes <> -1 THEN 'question, not animal
      PRINT companimal$; " ";
      GetChoice choice%
      PRINT : PRINT
      IF choice% THEN  'choice = 'YES'
         animalnum& = animal.yes
      ELSE  'choice = 'NO'
         animalnum& = animal.no
      END IF
   END IF
   GET #1, animalnum&, animal
   companimal$ = RTRIM$(FileString$(animal.animal))
LOOP UNTIL animal.yes = -1

PRINT "Is your animal a "; companimal$; "? ";
GetChoice choice%
PRINT : PRINT
IF choice% THEN
   PRINT "Wow, I'm smart!"
   PRINT "(Press a key)"
   DO: LOOP UNTIL LEN(INKEY$)
ELSE
   LINE INPUT "What was your animal? ", useranimal$
   PRINT
   PRINT "Please type a yes/no question that differentiates a"
   PRINT useranimal$; " from a "; companimal$; ": ";
   LINE INPUT "", NewQuestion$
   PRINT
   PRINT "If your animal was a "; useranimal$; ", how would you answer"
   PRINT "the above question? ";
   GetChoice choice%
   records& = LOF(1) \ LEN(animal)
   newanimal.yes = records& + 1
   newanimal.no = records& + 2
   PUT #1, animalnum& , LEN(NewQuestion$)
   PUT #1, animalnum& + 2, NewQuestion$
   newanimal.animal = useranimal$
   newanimal.yes = -1
   newanimal.no = -1
   IF choice% THEN
      PUT #1, records& + 1, newanimal
      PUT #1, records& + 2, animal
   ELSE
      PUT #1, records& + 1, animal

      PUT #1, records& + 2, newanimal
   END IF
END IF

CLOSE #1

END SUB

