'
'                    OOO       OOO   OOOOOOO   OOOOOOO
'                    OOO       OOO   OOOOOOO   OOOOOOO
'                    OOO       OOO   OOO       OOO
'                    OOO       OOO   OOOOOOO   OOOOOOO
'                    OOO       OOO   OOOOOOO   OOOOOOO
'                    OOO       OOO   OOO       OOO
'                    OOOOOOO   OOO   OOO       OOOOOOO
'                    OOOOOOO   OOO   OOO       OOOOOOO
'
'---===REPEATING PATTERNS===------------------------------------------------
'                                                  OO
'        OOO            O                          OO
'          O            O              OOO           OO
'         O             O             OOO            OO
'                                                 
'     traveller      spinner       clappers      blinkers      others???
'
'---===STABLE PATTERNS===---------------------------------------------------
'                        OO       O             OO          O
'       O               O  O     O O     OO     O O        O O
'      O O       OO     O  O    O  O    O  O     O O        O O
'       O        OO      OO      OO      OO       O O        O O
'                                                  OO         O
'    diamond   square   ring  triangle  oval  closed tube  open tube  + more
'
'---------------------------------------------------------------------------


'  by David Karlov
'
' For any questions, comments, etc. or to send me interesting patterns you
' make with LIFEEDIT, email to:
'  dkarlov@acs.itd.uts.edu.au
'  dkarlov@rocketmail.com
'
'
' Use LIFEEDIT to create your own starting positions, then use this program
' to see them `evolve'.....
'
'
' Edit the values in the life.cfg file to change some variables:
'  Scale:      Scale to use when drawing grid, 1 = tiny cells, 10 = big cells
'  Delay:      Minimum delay in 10ths of a second, -1 = wait for keypress
'  Colour1:    Colour of one type of life cell
'  Colour2:    Colour of second type of life cell
'  Wraparound: Screen wraps around, 1 = true, 0 = false
'  InitNum:    Number of random cells to create when no data file is specified
'
' Look in SUB UpdatePoint for a description of the algorithm used for
' updating the life cells.
'
' Compile for best performance.


' Now, time for a blatant plug ;)
'
' ==== * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ====
' === * NEW * * * * NEW * * * * NEW * * * * NEW * * * * NEW * * * * NEW * ===
' ==== * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ====
' ===                                                                     ===
' ===    .... if you're into QB, then u have to check this out:           ===
' ===                                                                     ===
' ===  >>>>>    ftp.cdrom.com/pub/games/dos/arcade/starfire.zip    <<<<<  ===
' ===                                                                     ===
' ===    One of the best QB games, download it and see for yourself!!!!!  ===
' ===                                                                     ===
' ==== * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ====
' === * NEW * * * * NEW * * * * NEW * * * * NEW * * * * NEW * * * * NEW * ===
' ==== * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ====


DEFINT A-Z
DECLARE SUB GetConfig ()
DECLARE SUB Init ()
DECLARE SUB spset (x1, y1, c1)
DECLARE SUB UpdatePoint (x1%, y1%)
DECLARE SUB DrawPoints ()

ON ERROR GOTO Er1

CONST ShowNums = 0

DIM SHARED Scale AS INTEGER
DIM SHARED Delay AS INTEGER
DIM SHARED Wraparound AS INTEGER
DIM SHARED InitNum AS INTEGER
DIM SHARED Col(1 TO 2) AS INTEGER

DIM SHARED MX AS INTEGER, MY AS INTEGER
DIM SHARED G AS INTEGER, NumDots(1 TO 2) AS INTEGER

DIM SHARED NoFile AS INTEGER
DIM SHARED Stat AS INTEGER

DIM SHARED XMin AS INTEGER, XMax AS INTEGER

GetConfig
MX = 640 / Scale: MY = 350 / Scale
FreeMem& = (FRE(-1)) / 4 - 10000
' max. possible number of elements in one Dots array

' If Scale = 1, then it is likely you will not have enough conventional RAM
' to make a grid the size of the whole screen, so here we will find the
' biggest size you can make it....
DO
r1! = ((MX + 2!) * (MY + 2!) / FreeMem&)
IF r1! >= .95 THEN 'not enough memory
' Make the biggest arrays possible while keeping x:y ratio approximately 16:9.
   r1! = r1! + .05
   MX = MX / SQR(r1!): MY = MY / SQR(r1!)
   r1! = ((MX + 2!) * (MY + 2!) / FreeMem&)
END IF
LOOP UNTIL r1! < .95

DIM SHARED Dots(-1 TO MX, -1 TO MY)  AS INTEGER
DIM SHARED Dots2(-1 TO MX, -1 TO MY)   AS INTEGER
DIM SHARED YMin(0 TO MX - 1) AS INTEGER, YMax(0 TO MX - 1) AS INTEGER
DIM SHARED YMin2(0 TO MX - 1) AS INTEGER, YMax2(0 TO MX - 1) AS INTEGER

Init

SCREEN 9, , 1 - p1, p1: CLS

DrawPoints  ' draw the initial screen setup.

DO
   Oldt! = TIMER
   G = G + 1
   ' Use page flipping so it looks like the whole
   ' grid is updated all at once.  p1 is the current page number.
   p1 = 1 - p1
   SCREEN , , 1 - p1, p1: CLS
   xx1 = MX: xx2 = 0
   NumDots(1) = 0: NumDots(2) = 0
   
   FOR xa = XMin - 1 TO XMax + 1
      x1 = (xa + MX) MOD MX
      YMin2(x1) = MY + 11: YMax2(x1) = -11
      YM1 = YMin(x1): YM2 = YMax(x1)
      xt = (x1 - 1 + MX) MOD MX
      IF YMin(xt) > -10 AND YMin(xt) < YM1 THEN YM1 = YMin(xt)
      IF YMax(xt) < MY + 10 AND YMax(xt) > YM2 THEN YM2 = YMax(xt)
      xt = (x1 + 1) MOD MX
      IF YMin(xt) > -10 AND YMin(xt) < YM1 THEN YM1 = YMin(xt)
      IF YMax(xt) < MY + 10 AND YMax(xt) > YM2 THEN YM2 = YMax(xt)
      FOR ya = YM1 - 1 TO YM2 + 1
         y1 = (ya + MY) MOD MY
         IF Dots(x1, y1) THEN
            NumDots(Dots(x1, y1)) = NumDots(Dots(x1, y1)) + 1
            IF x1 < xx1 THEN xx1 = x1
            IF x1 > xx2 THEN xx2 = x1
            IF y1 < YMin2(x1) THEN YMin2(x1) = y1
            IF y1 > YMax2(x1) THEN YMax2(x1) = y1
         END IF
         UpdatePoint x1, y1
      NEXT ya
     
      YMin(x1) = YMin2(x1) - 1
      YMax(x1) = YMax2(x1) + 1

   NEXT xa

   XMin = xx1 - 1: XMax = xx2 + 1
   DrawPoints

   IF Delay = -1 THEN
      WHILE INKEY$ = "": WEND
   ELSE
      DO: LOOP UNTIL Oldt! > TIMER OR TIMER > Oldt! + Delay / 10
   END IF

LOOP UNTIL INKEY$ <> ""

WIDTH 80: SCREEN 0, 0, 0: CLS : END


Er1:
IF ERR = 53 AND Stat = 1 THEN NoFile = 1: RESUME NEXT
SCREEN 0, 0, 0: WIDTH 80
PRINT "Error"; ERR
PRINT "Press any key to quit . . ."
DO: LOOP WHILE INKEY$ = ""
CLS : END

SUB DrawPoints

   ' Use the data in Dots2() to draw the dots on the screen, and copy
   ' this data into Dots()
  
   FOR xa = XMin - 1 TO XMax + 1
      x = (xa + MX) MOD MX
      YM1 = YMin(x): YM2 = YMax(x)
      x1 = (x - 1 + MX) MOD MX
      IF YMin(x1) > -10 AND YMin(x1) < YM1 THEN YM1 = YMin(x1)
      IF YMax(x1) < MY + 10 AND YMax(x1) > YM2 THEN YM2 = YMax(x1)
      x1 = (x + 1) MOD MX
      IF YMin(x1) > -10 AND YMin(x1) < YM1 THEN YM1 = YMin(x1)
      IF YMax(x1) < MY + 10 AND YMax(x1) > YM2 THEN YM2 = YMax(x1)
      FOR ya = YM1 - 1 TO YM2 + 1
         y = (ya + MY) MOD MY
         Dots(x, y) = Dots2(x, y)
         IF Dots(x, y) THEN
            spset x, y, Col(Dots(x, y))
            IF y < YMin(x) THEN YMin(x) = y
            IF y > YMax(x) THEN YMax(x) = y
         END IF
      NEXT ya
   NEXT xa

   IF ShowNums THEN
      COLOR Col(1): LOCATE 1, 1: PRINT LTRIM$(RTRIM$(STR$(NumDots(1))));
      COLOR Col(2): LOCATE 1, 81 - LEN(LTRIM$(RTRIM$(STR$(NumDots(2))))): PRINT LTRIM$(RTRIM$(STR$(NumDots(2))));
   END IF

END SUB

SUB GetConfig

Stat = 1
OPEN "life.cfg" FOR INPUT AS #1
' If this file is not found, the error handler will set NoFile to 1 and
' resume execution....
IF NoFile THEN
   NoFile = 0
   ' Create the default configuration file.
   Scale = 5
   Delay = 1
   Wraparound = 1
   Col(1) = 14
   Col(2) = 9
   InitNum = 100
 
   CLOSE
   OPEN "life.cfg" FOR OUTPUT AS #1
   PRINT #1, "Scale =" + STR$(Scale)
   PRINT #1, "Delay =" + STR$(Delay)
   PRINT #1, "Wraparound =" + STR$(Wraparound)
   PRINT #1, "Colour1 =" + STR$(Col(1))
   PRINT #1, "Colour2 =" + STR$(Col(2))
   PRINT #1, "InitNum =" + STR$(InitNum)
ELSE
   INPUT #1, a$
   Scale = VAL(RIGHT$(RTRIM$(a$), 2))
   IF Scale <= 0 THEN Scale = 1
   INPUT #1, a$
   Delay = VAL(RIGHT$(RTRIM$(a$), 2)) ' in 1/10ths of a second
   INPUT #1, a$
   Wraparound = VAL(RIGHT$(RTRIM$(a$), 2))
   INPUT #1, a$
   Col(1) = VAL(RIGHT$(RTRIM$(a$), 2)) MOD 16
   INPUT #1, a$
   Col(2) = VAL(RIGHT$(RTRIM$(a$), 2)) MOD 16
   INPUT #1, a$
   InitNum = VAL(RIGHT$(RTRIM$(a$), 3))
END IF
CLOSE
Stat = 0

END SUB

SUB Init

SCREEN 0, 0, 0: WIDTH 80: CLS

' initialise YMax & YMin points for each X
FOR x1 = 0 TO MX - 1
   YMax(x1) = -10: YMin(x1) = MY + 10
   YMax2(x1) = -10: YMin2(x1) = MY + 10
NEXT x1

' Check if a valid filename was passed into COMMAND$....
a$ = COMMAND$
IF a$ = "" THEN  ' ask user for filename....
   PRINT "Enter .LIF file to process, or nothing for random life cells:"
   INPUT a$
   a$ = LEFT$(LTRIM$(a$), 8)
END IF

IF a$ = "" THEN
   NoFile = 1
ELSE
   IF INSTR(a$, ".") = 0 THEN a$ = a$ + ".LIF"
   Stat = 1
   OPEN a$ FOR INPUT AS #1
   CLOSE
   Stat = 0
END IF

IF NoFile = 0 THEN
   ' Use the file passed in COMMAND$ for our initial setup....
   OPEN a$ FOR BINARY AS #1
   DIM Temp(1 TO 3, 1 TO 10000) AS INTEGER
   xl = 32767: yl = 32767: xb = -32768: yb = -32768
   c = 0
   DO
      c = c + 1
      GET 1, , x1
      GET 1, , y1
      GET 1, , c1
      IF EOF(1) THEN EXIT DO
      Temp(1, c) = x1: Temp(2, c) = y1: Temp(3, c) = c1
      IF x1 < xl THEN xl = x1
      IF x1 > xb THEN xb = x1
      IF y1 < yl THEN yl = y1
      IF y1 > yb THEN yb = y1
   LOOP 'UNTIL EOF(1)
   CLOSE #1
   ' Find max & min x & y positions, then put all cells into the grid
   ' so that their centre is at the centre of the screen.
   xm = CINT((xl + xb) / 2)
   ym = CINT((yl + yb) / 2)
   FOR t = 1 TO c
      xx = Temp(1, t) - xm + CINT((MX - 1) / 2)
      yy = Temp(2, t) - ym + CINT((MY - 1) / 2)
      IF xx >= 0 AND xx < MX AND yy >= 0 AND yy < MY THEN Dots2(xx, yy) = Temp(3, t)
   NEXT t
   ' Set up the initial edges of the region containing live cells.
   ' (We only need to process the grid here, thus saving time).
   XMin = INT(MX / 2) - xm + xl
   XMax = INT(MX / 2) - xm + xb
   IF XMin < 0 THEN XMin = 0
   IF XMax > MX - 1 THEN XMax = MX - 1
   FOR t = XMin TO XMax
      YMin(t) = CINT((MY - 1) / 2) - ym + yl
      YMax(t) = CINT((MY - 1) / 2) - ym + yb
      IF YMin(t) < 0 THEN YMin(t) = 0
      IF YMax(t) > MY - 1 THEN YMax(t) = MY - 1
   NEXT t
ELSE
   ' Initialise grid with InitNum random cells.
   RANDOMIZE TIMER
   FOR t = 1 TO InitNum
      x1 = INT((RND * 2! - 1!) * 10!)
      y1 = INT((RND * 2! - 1!) * 6!)
      x1 = x1 + INT(MX * .5): y1 = y1 + INT(MY * .5)
      Dots2(x1, y1) = INT(RND * 2) + 1
   NEXT t
   XMin = CINT((MX - 1) / 2) - 10: XMax = CINT((MX - 1) / 2) + 10
   FOR t = XMin TO XMax
      YMin(t) = CINT((MY - 1) / 2) - 6
      YMax(t) = CINT((MY - 1) / 2) + 6
   NEXT t
END IF

END SUB

SUB spset (x1, y1, c1)
' Scaled PSET

LINE (x1 * Scale, y1 * Scale)-((x1 + 1) * Scale - 1, (y1 + 1) * Scale - 1), c1, BF

END SUB

SUB UpdatePoint (x1, y1)

' For the point (x1, y1), work out whether to create a new cell there;
' or if one exists already, whether to kill it, by checking how many cells
' are in the 8 positions surrounding it.
' If there is a cell here, then it will die if:
'     (1)   There is one or less other cells surrounding it (isolation) or
'     (2)   There are 4 or more other cells surrounding it (overcrowding).
' If there is no cell here, a cell will be born if there are exactly 3 cells
' surrounding this empty cell.  The new cell's colour will the same as most
' (2 or 3) of the surrounding cells are.

DIM t2(1 TO 2) AS INTEGER

IF Wraparound THEN
   FOR x = x1 - 1 TO x1 + 1
      FOR y = y1 - 1 TO y1 + 1
         t3 = Dots((x + MX) MOD MX, (y + MY) MOD MY)
         IF t3 THEN
            t1 = t1 + 1
            t2(t3) = t2(t3) + 1
         END IF
      NEXT y
   NEXT x
ELSE
   FOR x = x1 - 1 TO x1 + 1
      FOR y = y1 - 1 TO y1 + 1
         t3 = Dots(x, y)
         IF t3 THEN
            t1 = t1 + 1
            t2(t3) = t2(t3) + 1
         END IF
      NEXT y
   NEXT x
END IF

IF t1 = 3 THEN
   Dots2(x1, y1) = 1 - (t2(2) >= 2)
ELSEIF t1 < 3 OR t1 > 4 THEN
   Dots2(x1, y1) = 0
ELSE
   Dots2(x1, y1) = Dots(x1, y1)
END IF

END SUB

