DEFINT A-Z

DECLARE SUB DoReply ()

DECLARE FUNCTION ElizaFindKeyword% (UserInput AS STRING)

DECLARE SUB Eliza.Editor ()

DECLARE SUB Eliza.Save (Filename$)
DECLARE SUB Keyword.Add ()
DECLARE SUB Keyword.Delete ()
DECLARE SUB Keyword.Edit ()
DECLARE SUB Keyword.Viewer ()
DECLARE SUB Reply.Add ()
DECLARE SUB Reply.Delete ()
DECLARE SUB Reply.Edit ()
DECLARE SUB Reply.Viewer ()

DECLARE SUB Eliza.Load (Filename$)
DECLARE SUB Screen.Board1 ()
DECLARE SUB Screen.Board2 ()
DECLARE SUB Screen.Center (Row%, TEXT$)
DECLARE SUB Screen.PrintAt (Row%, Column%, TEXT$)
DECLARE SUB Screen.PrintField (Row%, Column%, TEXT$, Length%)
DECLARE SUB Screen.PrintReply (TEXT$)
DECLARE SUB Screen.Sides ()
DECLARE SUB String.RemoveCharacter (Char$)
DECLARE FUNCTION String.Input$ (InputField$, Row%, Column%, Length%, Foreground%, Background%, ValidCharacters$, ReturnMode%, EntryMode%, CaseMode%)

COMMON SHARED /ElizaData/ NumberOfKeywords AS INTEGER, Keyword() AS STRING, NumberOfReplies() AS INTEGER, Reply() AS STRING
COMMON SHARED /ConjugationData/ NumberOfConjugations AS INTEGER, Conjugate() AS STRING, Conjugation() AS STRING

COMMON SHARED SelectedKeyword AS INTEGER
COMMON SHARED SelectedReply AS INTEGER
COMMON SHARED ComputersReply AS STRING
COMMON SHARED UserInput AS STRING

StartProgram:
DIM SHARED UsedReplies(400)
DIM SHARED NumberOfReplies(400) AS INTEGER

DIM SHARED Keyword(400) AS STRING
DIM SHARED Reply(400, 9) AS STRING
DIM SHARED Conjugate(7)  AS STRING
DIM SHARED Conjugation(7) AS STRING



'CLEAR


Eliza.Load "ELIZA.ELZ"

'UsedReplies(NumberOfKeywords) = INT(RND * NumberOfReplies(NumberOfKeywords)) + 1

Initialization:
KEY 1, "> Help" + CHR$(13)
KEY 2, "> Editor" + CHR$(13)
KEY 3, "> Restart" + CHR$(13)
KEY 31, "> Quit" + CHR$(13)

CLS
SCREEN 0
WIDTH 80

VIEW PRINT
Screen.Board1
VIEW PRINT 3 TO 23
UserInput = "INTRODUCTION"
GOTO ElizaStart
'Screen.PrintAt CSRLIN, 4, ComputersReply

UserInput:
PRINT
Screen.Sides
UserInput = String.Input$("", CSRLIN, 2, 78, 1, 11, "", 4, 2, 1)
  IF INSTR(UserInput, "> Help") THEN
    Screen.PrintReply "Not until version 10.1... :-("
    GOTO UserInput
  ELSEIF INSTR(UserInput, "> Editor") THEN
    Eliza.Editor
  ELSEIF INSTR(UserInput, "> Restart") THEN
    GOTO Initialization
  ELSEIF INSTR(UserInput, "> Quit") THEN
    GOTO Quit
  ELSE
    UserInput = " " + UCASE$(UserInput) + "  "
  END IF

' This section takes out punctuation characters that can get in the way
String.RemoveCharacter "'!.,?~`:;"
ElizaStart:
' This section finds the keyword it wants to use to select reply.
' It's pretty primitive, but better than some others
   S = ElizaFindKeyword(UserInput)
  
        T = INSTR(UserInput, Keyword(SelectedKeyword))
        ComputersReply = Keyword(SelectedKeyword)
   
IF S > 0 THEN
  SelectedKeyword = S
  L = T
  GOTO SearchHere
END IF
SelectedKeyword = NumberOfKeywords
GOTO Screen.PrintReply
REM WE DIDN'T FIND ANY KEYWORDS

' If a keyword was selected, changes conjugates just in case computer
' repeats part of the users speech
SearchHere:
    C$ = " " + RIGHT$(UserInput, LEN(UserInput) - LEN(ComputersReply) - L + 1) + " "
    FOR X = 1 TO NumberOfConjugations
      S$ = Conjugate(X)
      r$ = Conjugation(X)
      FOR L = 1 TO LEN(C$)
        IF L + LEN(S$) > LEN(C$) THEN GOTO XTemp
        IF MID$(C$, L, LEN(S$)) <> S$ THEN GOTO XTemp
        C$ = LEFT$(C$, L - 1) + r$ + RIGHT$(C$, LEN(C$) - L - LEN(S$) + 1)
        L = L + LEN(r$)
       GOTO LLoop
XTemp:
       IF L + LEN(r$) > LEN(C$) THEN GOTO LLoop
       IF MID$(C$, L, LEN(r$)) <> r$ THEN GOTO LLoop
       C$ = LEFT$(C$, L - 1) + S$ + RIGHT$(C$, LEN(C$) - L - LEN(r$) + 1)
       L = L + LEN(S$)
LLoop:
    NEXT L
    NEXT X
    IF MID$(C$, 2, 1) = " " THEN C$ = RIGHT$(C$, LEN(C$) - 1): REM ONLY ONE SPACE
    FOR L = 1 TO LEN(C$)
    DO WHILE MID$(C$, L, 1) = "!"
        C$ = LEFT$(C$, L - 1) + RIGHT$(C$, LEN(C$) - L)
    LOOP
    NEXT L

'Prints the reply to the user, resets used replies for a keyword if used up
Screen.PrintReply:
ComputersReply = Reply(SelectedKeyword, UsedReplies(SelectedKeyword))
UsedReplies(SelectedKeyword) = UsedReplies(SelectedKeyword) + 1

IF UsedReplies(SelectedKeyword) > NumberOfReplies(SelectedKeyword) THEN
    UsedReplies(SelectedKeyword) = 1
END IF

IF RIGHT$(ComputersReply, 1) = "*" THEN
    ComputersReply = LEFT$(ComputersReply, LEN(ComputersReply) - 1) + RTRIM$(LCASE$(C$))
END IF
DoReply
GOTO UserInput

Quit:
VIEW PRINT 1 TO 25
COLOR 7, 0: CLS
SYSTEM

'ConjugateData:
'DATA " ARE ", " AM "
'DATA "WHERE ","WAS "
'DATA " YOU "," I "
'DATA "YOUR ","MY "
'DATA " IVE "," YOUVE "
'DATA " IM "," YOURE "
'DATA " ME "," YOU "

SUB DoReply
    SELECT CASE ComputersReply
    CASE "> Editor"
      Eliza.Editor
    CASE "> Quit"
      END
    CASE ELSE
      Screen.PrintReply ComputersReply
    END SELECT
END SUB

SUB Eliza.Editor
SelectedKeyword = 1
SelectedReply = 1

EInitialization:
Screen.Board2

Eliza.EditorLoop:
Keyword.Viewer

  DO
    KeyPress$ = UCASE$(INKEY$)
  LOOP UNTIL KeyPress$ <> ""

  SELECT CASE KeyPress$
  CASE CHR$(0) + CHR$(72) 'Go Up'
    SelectedKeyword = SelectedKeyword - 1
    IF SelectedKeyword = 0 THEN SelectedKeyword = 1
    GOTO Eliza.EditorLoop
  CASE CHR$(0) + CHR$(80) 'Go Down'
    SelectedKeyword = SelectedKeyword + 1
    IF SelectedKeyword > NumberOfKeywords THEN SelectedKeyword = NumberOfKeywords
    GOTO Eliza.EditorLoop
  CASE CHR$(0) + CHR$(71) 'Home'
    SelectedKeyword = 1
    GOTO Eliza.EditorLoop
  CASE CHR$(0) + CHR$(79) 'End'
    SelectedKeyword = NumberOfKeywords
    GOTO Eliza.EditorLoop
  CASE CHR$(0) + CHR$(73) 'PageUp'
    SelectedKeyword = SelectedKeyword - 10
    IF SelectedKeyword <= 0 THEN SelectedKeyword = 1
    GOTO Eliza.EditorLoop
  CASE CHR$(0) + CHR$(81) 'PageDown'
    SelectedKeyword = SelectedKeyword + 10
    IF SelectedKeyword > NumberOfKeywords THEN SelectedKeyword = NumberOfKeywords
    GOTO Eliza.EditorLoop
  CASE CHR$(13) 'Move to Replies'
    SelectedReply = 1
    Reply.Viewer
    GOTO Eliza.EditorLoop
  CASE CHR$(0) + CHR$(82) 'INS'ert a new keyword
    Keyword.Add
    Reply.Add
    GOTO EInitialization
  CASE CHR$(0) + CHR$(83) 'DEL'ete a new keyword
    Keyword.Delete
    GOTO Eliza.EditorLoop
CASE CHR$(9) 'Edit keyword'
    Keyword.Edit
    GOTO Eliza.EditorLoop
CASE CHR$(27), " " 'Exit'
    GOTO EQuit
CASE ELSE
END SELECT
GOTO Eliza.EditorLoop

EQuit:
    VIEW PRINT 1 TO 25
    COLOR 7, 0: CLS
Eliza.Save "ELIZA.ELZ"
    EXIT SUB
END SUB

FUNCTION ElizaFindKeyword% (UserInput AS STRING)
  S = 0
  FOR SelectedKeyword = 1 TO NumberOfKeywords
    'IF S <> 0 AND INT(RND * 100) > 50 THEN
    'ELSE
      IF INSTR(UserInput, " " + Keyword(SelectedKeyword) + " ") > 0 THEN
        S = SelectedKeyword
        EXIT FOR
      END IF
    'END IF
  NEXT SelectedKeyword
  ElizaFindKeyword% = S
END FUNCTION

SUB Keyword.Add

'Create an empty reply
IF NumberOfKeywords = 400 THEN BEEP: EXIT SUB

'Create an empty keyword
NumberOfKeywords = NumberOfKeywords + 1
FOR X = NumberOfKeywords TO SelectedKeyword STEP -1
    Keyword(X) = Keyword(X - 1)
    FOR C = 1 TO 9
        Reply(X, C) = Reply(X - 1, C)
    NEXT C
    NumberOfReplies(X) = NumberOfReplies(X - 1)
NEXT X

Keyword(SelectedKeyword) = ""
FOR C = 1 TO 9
    Reply(SelectedKeyword, C) = ""
NEXT C
NumberOfReplies(SelectedKeyword) = 0

    COLOR 15, 3
    Screen.PrintAt 25, 1, "Keyword: "

UserInput$ = Keyword(SelectedKeyword)
UserInput$ = String.Input$(UserInput$, 25, 10, 15, 1, 11, "", 4, 4, 2)
Keyword(SelectedKeyword) = UserInput$

END SUB

SUB Keyword.Delete

IF SelectedKeyword = NumberOfKeywords THEN BEEP: EXIT SUB

'Deletes a keyword
NumberOfKeywords = NumberOfKeywords - 1
FOR X = SelectedKeyword TO NumberOfKeywords
    Keyword(X) = Keyword(X + 1)
    FOR C = 1 TO 9
        Reply(X, C) = Reply(X + 1, C)
    NEXT C
    NumberOfReplies(X) = NumberOfReplies(X + 1)
NEXT X

IF SelectedKeyword > NumberOfKeywords THEN
    SelectedKeyword = NumberOfKeywords
END IF

END SUB

SUB Keyword.Edit

COLOR 31, 1
    Screen.PrintField 3, 2, "", 1

Keyword(SelectedKeyword) = String.Input$(Keyword(SelectedKeyword), 3, 3, 15, 15, 1, "", 4, 4, 2)

END SUB

SUB Keyword.Viewer

LOCATE , , 0
T = SelectedKeyword
FOR X = 3 TO 13
    IF T <= NumberOfKeywords AND T <> SelectedKeyword THEN
        COLOR 15, 0
        Screen.PrintField X, 2, " " + Keyword(T), 16
    ELSEIF T = SelectedKeyword THEN
        COLOR 15, 1
        Screen.PrintField 3, 2, "" + Keyword(T), 16
        COLOR 15, 0
        Screen.PrintField 15, 2, "" + Reply(T, 1), 78
        FOR Tm = 2 TO 9
            Screen.PrintField 14 + Tm, 3, Reply(T, Tm), 77
        NEXT Tm
    ELSE
        COLOR 15, 0
        Screen.PrintField X, 2, "", 16
    END IF
    T = T + 1
NEXT X

COLOR 0, 3
Screen.PrintAt 3, 18, ""
FOR X = 4 TO 12
    Screen.PrintAt X, 18, ""
NEXT X
Screen.PrintAt 13, 18, ""
Screen.PrintAt INT(8 * (SelectedKeyword / NumberOfKeywords)) + 4, 18, ""

COLOR 15, 0
    Screen.PrintAt 2, 2, STR$(SelectedKeyword) + " "

IF NumberOfReplies(SelectedKeyword) - 1 >= 9 THEN
    Screen.PrintAt 24, 77, "  "
ELSE
    Screen.PrintAt 24, 77, ""
END IF
Screen.PrintAt 14, 77, ""

COLOR 15, 3
Screen.PrintField 25, 1, "", 80

END SUB

SUB Reply.Add

'Create an empty reply
IF NumberOfReplies(SelectedKeyword) = 9 THEN BEEP: EXIT SUB

NumberOfReplies(SelectedKeyword) = NumberOfReplies(SelectedKeyword) + 1
FOR X = NumberOfReplies(SelectedKeyword) TO SelectedReply STEP -1
    Reply(SelectedKeyword, X) = Reply(SelectedKeyword, X - 1)
NEXT X

Reply(SelectedKeyword, SelectedReply) = ""

COLOR 15, 3
    Screen.PrintAt 25, 1, "Reply: "

UserInput$ = Reply(SelectedKeyword, SelectedReply)
UserInput$ = String.Input$(UserInput$, 25, 8, 71, 1, 11, "", 4, 4, 1)
Reply(SelectedKeyword, SelectedReply) = UserInput$

END SUB

SUB Reply.Delete

IF NumberOfReplies(SelectedKeyword) = 1 THEN BEEP: EXIT SUB
IF SelectedReply = NumberOfReplies(SelectedKeyword) THEN BEEP: EXIT SUB

'Deletes a reply
Reply(SelectedKeyword, SelectedReply) = ""

NumberOfReplies(SelectedKeyword) = NumberOfReplies(SelectedKeyword) - 1
FOR X = SelectedReply TO NumberOfReplies(SelectedKeyword)
    Reply(SelectedKeyword, X) = Reply(SelectedKeyword, X + 1)
NEXT X

Reply(SelectedKeyword, NumberOfReplies(SelectedKeyword) + 1) = ""

END SUB

SUB Reply.Edit

COLOR 31, 1
    Screen.PrintField 15, 2, "", 1

Reply(SelectedKeyword, SelectedReply) = String.Input$(Reply(SelectedKeyword, SelectedReply), 15, 3, 77, 15, 1, "", 4, 4, 1)

END SUB

SUB Reply.Viewer

Reply.Viewer.Loop:
GOSUB View.Replies
DO
    KeyPress$ = UCASE$(INKEY$)
LOOP UNTIL KeyPress$ <> ""

SELECT CASE KeyPress$
CASE CHR$(0) + CHR$(72): 'Go Up'
    SelectedReply = SelectedReply - 1
    IF SelectedReply = 0 THEN SelectedReply = 1
    GOTO Reply.Viewer.Loop
CASE CHR$(0) + CHR$(80): 'Go Down'
    SelectedReply = SelectedReply + 1
    IF SelectedReply > NumberOfReplies(SelectedKeyword) THEN SelectedReply = NumberOfReplies(SelectedKeyword)
    GOTO Reply.Viewer.Loop
CASE CHR$(0) + CHR$(71): 'Home'
    SelectedReply = 1
    GOTO Reply.Viewer.Loop
CASE CHR$(0) + CHR$(79): 'End'
    SelectedReply = NumberOfReplies(SelectedKeyword)
    GOTO Reply.Viewer.Loop
CASE CHR$(0) + CHR$(82): 'INS'ert a new reply
    Reply.Add
    GOTO Reply.Viewer.Loop
CASE CHR$(0) + CHR$(83): 'DEL'ete a reply
    Reply.Delete
    GOTO Reply.Viewer.Loop
CASE CHR$(9): 'Edit reply'
    Reply.Edit
    GOTO Reply.Viewer.Loop
CASE CHR$(27), " ": 'Exit'
    EXIT SUB
CASE ELSE
END SELECT
GOTO Reply.Viewer.Loop

SLEEP
SYSTEM

View.Replies:
LOCATE , , 0
T = SelectedReply
FOR X = 1 TO 9
    IF T <= NumberOfReplies(SelectedKeyword) AND T <> SelectedReply THEN
        COLOR 15, 0
        Screen.PrintField 14 + X, 3, Reply(SelectedKeyword, T), 77
    ELSEIF T = SelectedReply THEN
        COLOR 15, 1
        Screen.PrintField 15, 2, "" + Reply(SelectedKeyword, T), 77
    ELSE
        COLOR 15, 0
        Screen.PrintField 14 + X, 2, "", 77
    END IF
    T = T + 1
NEXT X

COLOR 15, 3
Screen.PrintField 25, 1, "", 80

RETURN

END SUB

SUB Screen.Board1

LOCATE , , 0

COLOR 15, 3
    Screen.PrintField 1, 1, "", 80
    Screen.Center 1, "ELIZA: Computer Conversation AI"
    Screen.PrintField 25, 1, " <F2=Editor>  <F1=Help> <F3=Restart> <F12=Exit>", 80
COLOR 15, 1
    Screen.PrintAt 2, 1, "" + STRING$(78, "") + ""
    FOR Y = 3 TO 23
        Screen.PrintAt Y, 1, ""
        Screen.PrintField Y, 2, "", 78
        Screen.PrintAt Y, 80, ""
    NEXT Y
    Screen.PrintAt 24, 1, "" + STRING$(78, "") + ""
END SUB

SUB Screen.Board2
    VIEW PRINT
COLOR 15, 3
    CLS
    Screen.Center 1, "ELIZA Keyword Editor"
COLOR 15, 0
    LOCATE 2, 1
    PRINT "Ŀ";
    PRINT "                   I'm not good at writing instuctions, so I'll just give   ";
    PRINT "                  you the list of keys you might need.                       ";
    PRINT "                                                                             ";
    PRINT "                    -- Keyword Window --          -- Replies Window --       ";
    PRINT "                    <INS> = Adds keyword          <INS> = Adds reply         ";
    PRINT "                    <DEL> = Deletes keyword       <DEL> = Deletes reply      ";
    PRINT "                    <ESC> = Back to Eliza         <ESC> = Back to keywords   ";
    PRINT "                   <ENTER>= Moves to replies                                 ";
    PRINT "                    <TAB> = Edit's keyword        <TAB> = Edits reply        ";
    PRINT "                                                                             ";
    PRINT "                  Note: An asterisk at the end of a reply adds user input.   ";
    PRINT "Ĵ";
    PRINT "                                                                             ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "                                                                              ";
    PRINT "";

END SUB

SUB Screen.Box (Row1, Col1, Row2, Col2, TEXT$, Foreground, Background, TitleColor)

COLOR Foreground, Background
Screen.BoxWidth = Col2 - Col1 + 1

Screen.PrintAt Row1, Col1, "" + STRING$(Screen.BoxWidth - 2, "") + ""

FOR A = Row1 + 1 TO Row2 - 1
        Screen.PrintAt A, Col1, "" + SPACE$(Screen.BoxWidth - 2) + ""
NEXT A

Screen.PrintAt Row2, Col1, "" + STRING$(Screen.BoxWidth - 2, "") + ""

COLOR 1, 0
FOR X = Row1 + 1 TO Row2 + 1
    Screen.PrintAt X, Col2 + 1, CHR$(176)
NEXT X
Screen.PrintAt Row2 + 1, Col1 + 1, STRING$(Screen.BoxWidth, CHR$(176))

IF TEXT$ <> "" THEN
    COLOR TitleColor, Background
    Screen.PrintAt Row1, INT((Col1 + Col2) / 2) - ((LEN(TEXT$) + 2) / 2), " " + TEXT$ + " "
END IF

END SUB

SUB Screen.Center (Row%, TEXT$)
    LOCATE Row%, 41 - LEN(TEXT$) / 2
    PRINT TEXT$;
END SUB

SUB Screen.PrintAt (Row, Column, TEXT$)
    LOCATE Row, Column
    PRINT (TEXT$);
END SUB

SUB Screen.PrintField (Row, Column, TEXT$, Length)
    VIEW PRINT
    LOCATE Row, Column
    PRINT TEXT$ + SPACE$(Length - LEN(TEXT$));
END SUB

SUB Screen.PrintReply (TEXT$)

COLOR 15, 1
PRINT
Screen.Sides
LOCATE CSRLIN, 4
PRINT TEXT$;

END SUB

SUB Screen.ScrollBar (Length, Selected, Maximum, Row, Column)

COLOR 0, 3

Screen.PrintAt Row, Column, ""
FOR X = Row + 1 TO Row + Length
    Screen.PrintAt X, Column, ""
NEXT X
Screen.PrintAt Row + Length + 1, Column, ""

COLOR 9, 9

X = INT((Length - 1) * (Selected / Maximum)) + Row + 1
Screen.PrintAt 1, 1, STR$(X)
Screen.PrintAt X, Column, ""

END SUB

SUB Screen.Sides

ty = CSRLIN
tx = POS(0)

FOR Y = 3 TO 23
    Screen.PrintAt Y, 1, ""
    Screen.PrintAt Y, 80, ""
NEXT Y

LOCATE ty, tx

END SUB

FUNCTION String.Input$ (InputField$, Row%, Column%, Length%, Foreground%, Background%, ValidCharacters$, ReturnMode%, EntryMode%, CaseMode%)
    
    True% = 1                             ' logical true
    False% = 0                            ' logical false

    EnterKey$ = CHR$(13)                  ' signifies end of entry
    Escape$ = CHR$(27)                    ' emergency exit from function
    EraseToEOReply$ = CHR$(20)                ' ^T erase from cursor to EOF
    RestoreField$ = CHR$(18)              ' ^UsedReplies restore original field
    EraseField$ = CHR$(25)                ' ^Y erase entire field
    BackSpace$ = CHR$(8)                  ' dragging, destructive backspace
    RightArrow$ = "M"                     ' input cursor right
    LeftArrow$ = "K"                      ' input cursor left
    InsertKey$ = "R"                      ' insert mode toggle
    DeleteKey$ = "S"                      ' character delete
    HomeKey$ = "G"                        ' input cursor start of field
    EndKey$ = "O"                         ' input cursor after last char

    InputFinished% = False%               ' set to true on enter or escape
    InsertMode% = False%                  ' start off in insert off mode

    InputField$ = SPACE$(Length%)
    OriginalField$ = InputField$          ' for ^UsedReplies restore original field
    Length% = LEN(InputField$)            ' total input field length
    CurrentColumn% = Column%              ' cursor at first entry column
    CursorPosition% = 1                   ' 1st position in entry string
    EndColumn% = Column% + Length% - 1    ' last column in entry string

    COLOR Foreground%, Background%        ' set specified colors
    LOCATE Row%, Column%, 0               ' locate cursor
    PRINT InputField$;                    ' display original field
    LOCATE Row%, Column%, 1, 6, 7         ' locate at first character

    WHILE InputFinished% = False%         ' main loop

       InputKey$ = INKEY$                 ' get a keystroke if present
       EditKey$ = MID$(InputKey$, 2, 1)   ' editing key pressed?

       IF EditKey$ <> "" THEN
          SELECT CASE EditKey$
          CASE RightArrow$
            IF CurrentColumn% <= EndColumn% THEN
              CurrentColumn% = CurrentColumn% + 1
              CursorPosition% = CursorPosition% + 1
              LOCATE Row%, CurrentColumn%, 1
            END IF

          CASE LeftArrow$
            IF CurrentColumn% > Column% THEN
              CurrentColumn% = CurrentColumn% - 1
              CursorPosition% = CursorPosition% - 1
              LOCATE Row%, CurrentColumn%, 1
            END IF

            CASE InsertKey$
              IF InsertMode% = True% THEN
                LOCATE Row%, CurrentColumn%, 1, 6, 7
                InsertMode% = False%
              ELSE
                LOCATE Row%, CurrentColumn%, 1, 3, 7
                   InsertMode% = True%
                END IF

             CASE DeleteKey$
                IF CurrentColumn% <= EndColumn% THEN
                   FOR Index% = CursorPosition% TO Length% - 1
                       MID$(InputField$, Index%, 1) = MID$(InputField$, Index% + 1, 1)
                   NEXT Index%
                   MID$(InputField$, Length%, 1) = " "
                   LOCATE Row%, Column%, 0
                   PRINT InputField$;
                   LOCATE Row%, CurrentColumn%, 1
                END IF

             CASE HomeKey$
                IF CursorPosition% > 1 THEN
                   CurrentColumn% = Column%
                   CursorPosition% = 1
                   LOCATE Row%, CurrentColumn%, 1
                END IF

             CASE EndKey$
                IF CursorPosition% < Length% THEN
                   FOR Index% = Length% TO 1 STEP (-1)
                       IF MID$(InputField$, Index%, 1) <> " " THEN
                          EXIT FOR
                       END IF
                   NEXT Index%
                   CursorPosition% = Index% + 1
                   CurrentColumn% = Column% + Index%
                   LOCATE Row%, CurrentColumn%, 1
                END IF

          END SELECT

       ELSE 'Editkey$=""

          SELECT CASE InputKey$
          CASE Escape$
                InputField$ = SPACE$(Length%)
                LOCATE Row%, Column%, 0
                PRINT InputField$;
                CursorPosition% = 1
                CurrentColumn% = Column%
                LOCATE Row%, Column%, 1

             CASE BackSpace$
                IF CurrentColumn% > Column% THEN
                   N$ = ""
                   FOR Index% = 1 TO CursorPosition% - 2
                       N$ = N$ + MID$(InputField$, Index%, 1)
                   NEXT Index%
                   FOR Index% = CursorPosition% TO Length%
                       N$ = N$ + MID$(InputField$, Index%, 1)
                   NEXT Index%
                   InputField$ = LEFT$(N$ + SPACE$(Length%), Length%)
                   CurrentColumn% = CurrentColumn% - 1
                   CursorPosition% = CursorPosition% - 1
                   LOCATE Row%, Column%, 0
                   PRINT InputField$;
                   LOCATE Row%, CurrentColumn%, 1
                END IF

             CASE EraseField$
                InputField$ = SPACE$(Length%)
                LOCATE Row%, Column%, 0
                PRINT InputField$;
                CursorPosition% = 1
                CurrentColumn% = Column%
                LOCATE Row%, Column%, 1

             CASE EraseToEOReply$
                IF CurrentColumn% <= EndColumn% THEN
                   MID$(InputField$, CursorPosition%, Length% - CursorPosition% + 1) = SPACE$(Length% - CursorPosition% + 1)
                   LOCATE Row%, Column%
                   PRINT InputField$;
                   LOCATE Row%, CurrentColumn%, 1
                END IF

             CASE RestoreField$
                InputField$ = OriginalField$
                LOCATE Row%, Column%, 0
                PRINT InputField$;
                CursorPosition% = 1
                CurrentColumn% = Column%
                LOCATE Row%, Column%, 1

             CASE EnterKey$
                InputFinished% = True%

             CASE ELSE

                ValidKey% = False%
'               null string for valid characters means all input accepted
                IF ValidCharacters$ = "" OR INSTR(ValidCharacters$, UCASE$(InputKey$)) > 0 THEN
                  
                   ValidKey% = True%
                END IF
              
                IF ValidKey% = True% AND InputKey$ <> "" AND CurrentColumn% <= EndColumn% THEN
                                        
                   SELECT CASE CaseMode%
                      CASE 1
                         ' do nothing, accept as entered
                      CASE 2
                         InputKey$ = UCASE$(InputKey$)
                      CASE 3
                         InputKey$ = LCASE$(InputKey$)
                   END SELECT

                   SELECT CASE InsertMode%
                      CASE True%
                         InputField$ = LEFT$(InputField$, CursorPosition% - 1) + InputKey$ + RIGHT$(InputField$, Length% - CursorPosition% + 1)
                         InputField$ = LEFT$(InputField$, Length%)
                         LOCATE Row%, Column%
                         PRINT InputField$;
                      CASE False%
                         PRINT InputKey$;
                         MID$(InputField$, CursorPosition%, 1) = InputKey$
                   END SELECT

                   CursorPosition% = CursorPosition% + 1
                   CurrentColumn% = CurrentColumn% + 1
                   LOCATE Row%, CurrentColumn%, 1

'                  check entry mode to see if end of field entry terminates entry
                   IF CurrentColumn% > EndColumn% AND EntryMode% = 2 THEN
                      InputFinished% = True%
                   END IF

                END IF

          END SELECT

       END IF

    WEND

'   return entered string appropriately

    SELECT CASE ReturnMode%

       CASE 1     ' return entire field
          String.Input$ = InputField$

       CASE 2     ' return field less any trailing blanks
          String.Input$ = RTRIM$(InputField$)

       CASE 3     ' return field less any leading blanks
          String.Input$ = LTRIM$(InputField$)

       CASE 4     ' return field less both leading and trailing blanks
          String.Input$ = LTRIM$(RTRIM$(InputField$))

       CASE 5     ' return field with all blanks removed
          N$ = ""
          FOR Index% = 1 TO Length%
              IF MID$(InputField$, Index%, 1) <> " " THEN
                 N$ = N$ + MID$(InputField$, Index%, 1)
              END IF
          NEXT Index%
          String.Input$ = N$

       CASE 6     ' left justify and kill blanks between 1st and last char
          N$ = ""
          FOR Index% = 1 TO Length%
              IF MID$(InputField$, Index%, 1) <> " " THEN
                 N$ = N$ + MID$(InputField$, Index%, 1)
              END IF
          NEXT Index%
          String.Input$ = RIGHT$(N$ + SPACE$(Length%), Length%)

       CASE 7     ' right justify and kill inner blanks
          N$ = ""
          FOR Index% = 1 TO Length%
              IF MID$(InputField$, Index%, 1) <> " " THEN
                 N$ = N$ + MID$(InputField$, Index%, 1)
              END IF
          NEXT Index%
          String.Input$ = RIGHT$(SPACE$(Length%) + N$, Length%)

    END SELECT

END FUNCTION

SUB String.RemoveCharacter (Char$)


FOR C = 1 TO LEN(Char$)
    FOR L = 1 TO LEN(UserInput)
        DO WHILE MID$(UserInput, L, 1) = MID$(Char$, C, 1)
            UserInput = LEFT$(UserInput, L - 1) + RIGHT$(UserInput, LEN(UserInput) - L)
        LOOP
    NEXT L
NEXT C


END SUB

