'==============================================================
' Written by Brian McLaughlin. Released into public domain 1/1/94.
'
'  CLAUDE.BAS         TYPES DECLARED
'==============================================================

TYPE Leng16
  Word AS STRING * 16
END TYPE
                                
TYPE Leng32
  Word AS STRING * 32
END TYPE
                                
TYPE Leng64
  Word AS STRING * 64
END TYPE

TYPE Leng128
  Word AS STRING * 128
END TYPE

'===========================================
'      SUBS DECLARED
'===========================================

DECLARE SUB LoadAllArrays ()
DECLARE SUB LoadFixed16 (Array() AS Leng16, HowLong%)
DECLARE SUB LoadFixed32 (Array() AS Leng32, HowLong%)
DECLARE SUB LoadFixed64 (Array() AS Leng64, HowLong%)
DECLARE SUB LoadFixed128 (Array() AS Leng128, HowLong%)
DECLARE SUB LoadArray (Array$(), HowLong%)
DECLARE SUB LoadDoubArray (Array$(), HowLong%, HowLong2%)
DECLARE SUB LoadIntArray (IntArray%(), HowLong%)

DECLARE SUB SetRegScreen ()
DECLARE SUB SetColor ()
DECLARE SUB ColorMenu ()
DECLARE SUB TitleUp ()
DECLARE SUB Twiddlesound ()
DECLARE SUB Opening ()
DECLARE SUB SayBye ()
DECLARE SUB EndScreen ()

DECLARE SUB HelpControl ()
DECLARE SUB MenuPrint (TopRow%, LeftEdge%, BotRow%, RightEdge%)
DECLARE SUB PrintHelpWin (Choice%)
DECLARE SUB PrnWarning ()
DECLARE SUB MemCopy (FromSeg%, ToSeg%, NumWords%)
DECLARE SUB PopWindow (Left%, Top%, Rght%, Bot%, Msg$)

DECLARE SUB Response1stPart ()
DECLARE SUB RespondToNoInput ()
DECLARE SUB RespondToProfanity ()
DECLARE SUB RespondToNoSense ()
DECLARE SUB QuesAnswer ()
DECLARE SUB OneWordQuery (Word$)
DECLARE SUB WhyHowQuery (First$, Next$)
DECLARE SUB EasyAnswer (First$, Next$)
DECLARE SUB OtherAnswer ()
DECLARE SUB TestFirstWords ()
DECLARE SUB TestUserAnswer ()
DECLARE SUB ImpAnswer (Imp$, Other$, Third$)
DECLARE SUB MakeAnswer (Pron$, Vb$, Test%)
DECLARE SUB NextAnswer (Pron$, Infinitive%, Third$, Count%)
DECLARE SUB FdNounAnswer ()
DECLARE SUB AdvAnswer ()
DECLARE SUB CheckAdj ()
DECLARE SUB EchoLastWord ()
DECLARE SUB EchoBigWord (BigWord$)
DECLARE SUB BadHearing ()
DECLARE SUB Distract ()
DECLARE SUB Phone ()
DECLARE SUB DoorKnock ()

DECLARE SUB Response2ndPart ()
DECLARE SUB Response3rdPart ()
DECLARE SUB SetNewWords (NNum%)
DECLARE SUB ChooseSb (NNum%)
DECLARE SUB ChooseSbWords (Num%)
DECLARE SUB ChooseOb (VNum%)
DECLARE SUB ChooseVb (Subj%)
DECLARE SUB ChooseOther ()
DECLARE SUB FlagReset ()
DECLARE SUB NullAll ()
DECLARE SUB NullOb ()
DECLARE SUB WrapPrint (Target$)

DECLARE SUB GetInput (Row%, Col%, EndCol%)
DECLARE SUB BreakUp ()
DECLARE SUB TestVowelRatio (Test$)
DECLARE SUB TestObscenity (Test$)
DECLARE SUB TestForNoun ()
DECLARE SUB TestAllPunc ()
DECLARE SUB GetLastSent ()
DECLARE SUB BreakUpLast (LastSent%)
DECLARE SUB ShrinkWords ()

'=============================
'  FUNCTIONS DECLARED
'=============================

DECLARE FUNCTION GetColor% (Choice%, OldColor%)
DECLARE FUNCTION FindPad% (Start%)
DECLARE FUNCTION Cap$ (Word$)
DECLARE FUNCTION AdC$ (Sent$)
DECLARE FUNCTION AdP$ (Sent$)
DECLARE FUNCTION AdQ$ (Sent$)
DECLARE FUNCTION AdX$ (Sent$)
DECLARE FUNCTION StrTok$ (Srce$, Delim$)
DECLARE FUNCTION ExpndCont$ (Cont$)
DECLARE FUNCTION TestWhyHow% (First$)
DECLARE FUNCTION GetBig$ ()
DECLARE FUNCTION EvalNum% (Test$)
DECLARE FUNCTION EvalPro% (Word$)
DECLARE FUNCTION EvalVb% (Word$)
DECLARE FUNCTION EvalWord% (Word$)
DECLARE FUNCTION PrnChk% ()

DECLARE FUNCTION GetObject% (ObCode%)
DECLARE FUNCTION GetGerund$ (Subj%)
DECLARE FUNCTION GetAdj$ (NounNum%)
DECLARE FUNCTION GetSupAdj$ (Adject%)
DECLARE FUNCTION GetCmpAdj$ (Adject%)
DECLARE FUNCTION GetVerb% (Subj%)
DECLARE FUNCTION Plur$ (Word%)
DECLARE FUNCTION IrrPlur$ (Word%)
DECLARE FUNCTION GetPast$ (Passed%)
DECLARE FUNCTION Get3rdPerson$ (Passed%)
DECLARE FUNCTION GetIng$ (Passed%)
DECLARE FUNCTION GetPastPerf$ (Passed%)

DECLARE FUNCTION Answer1$ ()
DECLARE FUNCTION Answer2$ ()
DECLARE FUNCTION Answer3$ ()
DECLARE FUNCTION Answer4$ ()
DECLARE FUNCTION Answer5$ ()
DECLARE FUNCTION Answer6$ ()
DECLARE FUNCTION Answer7$ ()
DECLARE FUNCTION Answer8$ ()
DECLARE FUNCTION Answer9$ ()
DECLARE FUNCTION Answer10$ ()
DECLARE FUNCTION Answer11$ ()
DECLARE FUNCTION Answer12$ ()
DECLARE FUNCTION Answer13$ ()
DECLARE FUNCTION Answer14$ ()
DECLARE FUNCTION Answer15$ ()
DECLARE FUNCTION Answer16$ ()
DECLARE FUNCTION Answer17$ ()
DECLARE FUNCTION Answer18$ ()
DECLARE FUNCTION Answer19$ ()
DECLARE FUNCTION Answer20$ ()
DECLARE FUNCTION Answer21$ ()
DECLARE FUNCTION Answer22$ ()
DECLARE FUNCTION Answer23$ ()
DECLARE FUNCTION Answer24$ ()
DECLARE FUNCTION Answer25$ ()

'==================================
'   GLOBAL VARIABLES
'==================================

'- WORD VARIABLES -           ---- EXAMPLES ---

DIM SHARED InfVb$             '(to) go/ be         -infinitive
DIM SHARED IngVb$             'going/ being        -participle
DIM SHARED SPresVb$           'go                  -present singular
DIM SHARED PPresVb$           '(they) go /are      -present plural
DIM SHARED SPastVb$           'went /was           -past singular
DIM SHARED PPastVb$           '(they) went /were   -past plural
DIM SHARED PPerfVb$           'have gone           -past perfect
DIM SHARED S3PerVb$           '(it) goes           -third person singular
DIM SHARED P3PerVb$           '(they) go           -third person plural
DIM SHARED WInfVb$            'want (to go)          (with an infinitive)
DIM SHARED PWInfVb$           'wanted to go          (past with infinitive)
DIM SHARED AuxVb$             'can (go)              ("auxilliary" verb)
DIM SHARED AuxNeg$            'can't (go)            ("auxilliary" negative)
 
DIM SHARED Sb$                'dog                  -subject noun
DIM SHARED SbPlur$            'dogs                 -subject plural
DIM SHARED SbAdj$             'good (dog)           -adjective (subject's)
DIM SHARED SbCmp$             'better (dog)         -comparative adj. (subj)
DIM SHARED SbSup$             'best (dog)           -superlative adj. (subj)
DIM SHARED SbAmt$             'many (dogs)           (amount or number)
DIM SHARED SbWho$             'that /who        
DIM SHARED SbEvry$            'every (dog)/ all (money)

DIM SHARED Ob$                'hand                 -object noun
DIM SHARED ObPlur$            'hands                -object noun plural
DIM SHARED ObAdj$             'dirty (hand)         -adjective (object's)
DIM SHARED ObCmp$             'dirtier              -comparative adj. (obj)
DIM SHARED ObSup$             'dirtiest             -superlative adj. (obj)
DIM SHARED ObAm$              'two (hands)           (amount or number)
DIM SHARED ObWho$             'that or who (because a hand is not a who)

DIM SHARED Frq$               'often                -adverb (frequency)
DIM SHARED Int$               'very                 -adverb (intensifier)
DIM SHARED Exclam$            'Oh!                  -exclamation
DIM SHARED Plac$              'Tulsa                -proper noun (place name)
DIM SHARED Man$               'Bob                  -proper noun (man's name)
DIM SHARED Woman$             'Sheila               -proper noun (woman name)
DIM SHARED Bridg$             '-however,              (a bridging phrase)
DIM SHARED AsAs$              '-as good as gold       (a phrase)
DIM SHARED Prov$              '                       (a proverb)
DIM SHARED TimPas$            'next                   (passage of time)
DIM SHARED TimDur$            'a long time            (length of time)

DIM SHARED SbA$               'a (dog)              -article
DIM SHARED SbPro$             'it (went)            -nominative pronoun
DIM SHARED SbPPro$            'its                  -possessive pronoun
DIM SHARED SbAPro$            '(to) it              -accusative pronoun
DIM SHARED SbAre$             '(they) are / (money) is
DIM SHARED SbWere$            '(they) were / (money) was
DIM SHARED SbThey$            'they (or it)

DIM SHARED ObA$               'a (hand)             -article
DIM SHARED ObPro$             'it                   -nominative pronoun
DIM SHARED ObPPro$            'its                  -possessive pronoun
DIM SHARED ObAPro$            '(to) it              -accusative pronoun
DIM SHARED ObAre$             '(they) are/ (money) is
DIM SHARED ObWere$            '(they) were/ (money) was
DIM SHARED ObThey$            'they (or it, for collective nouns)

DIM SHARED UserName$          'User's name (as input by user)
DIM SHARED UserInput$         'holds user input as one string

'  -- FLAGS --               ----- USES ------

DIM SHARED NoInput%         'set TRUE if input Nul or all spaces
DIM SHARED Obscene%          'set TRUE when an obscene/compound word found
DIM SHARED NoSense%         'set TRUE when nonsense answer detected
DIM SHARED NonSense$        'saves string that set NoSense% as TRUE
DIM SHARED Question%        'set TRUE in TestAllPunc, if question-mark at end
DIM SHARED AllRespMade%     'set TRUE when Response2 and 3 should be skipped
DIM SHARED NoResp2%         'set TRUE when Response2 should be skipped
DIM SHARED NoOb%            'set TRUE when verb takes no object
DIM SHARED SubHuman%        'set TRUE when subject noun is human
DIM SHARED SbCollect%       'set TRUE when subject a collective noun
DIM SHARED SbPair%          'set TRUE when subject a "paired" noun
DIM SHARED MultiSent%       'set TRUE when multiple sentances detected
DIM SHARED Lpt%             'set TRUE%/FALSE% according to printout mode
DIM SHARED AskedUser%       'set TRUE when CLAUDE asks User a question
DIM SHARED R2Q%             'set TRUE when Response2 asks a question
DIM SHARED Phony%           'set TRUE when FoundNoun% is randomly set

'---- POINTERS -----  (Array indexes: not real pointers, as in C)

DIM SHARED Verb%            'points to current verb
DIM SHARED SbNum%           'points to current subject-noun
DIM SHARED ObNum%           'points to current object noun, if any
DIM SHARED FoundNoun%       'points to first noun found in user input
DIM SHARED Adverb%          'points to any adverb found in UserWords
DIM SHARED Adject%          'points to adjective last chosen by GetAdj%


DIM SHARED TRUE AS INTEGER
DIM SHARED FALSE AS INTEGER
TRUE = 1
FALSE = 0

'======================
'  STRING CONSTANTS
'======================

CONST Spac$ = " "
CONST Nul$ = ""
CONST S$ = "s "
CONST ES$ = "es "
CONST That$ = "that "
CONST This$ = "this "
CONST They$ = "they "
CONST Those$ = "those "
CONST And$ = "and "
CONST Are$ = "are "
CONST Is$ = "is "
CONST Was$ = "was "
CONST Were$ = "were "
CONST When$ = "when "
CONST But$ = "but "

'===================================================
' NUMERICAL CONSTANTS (USED TO DIMENSION ARRAYS)
'===================================================

'-- used to DIM Verb Arrays --

CONST HumIrr% = 175
CONST AnimIrr% = HumIrr% + 50
CONST BodIrr% = AnimIrr% + 12
CONST ObjIrr% = BodIrr% + 9
CONST ClothIrr% = ObjIrr% + 10
CONST FoodIrr% = ClothIrr% + 13
CONST LiqIrr% = FoodIrr% + 2
CONST IrrDim% = LiqIrr%

CONST HumReg% = IrrDim% + 85
CONST AnimReg% = HumReg% + 43
CONST BodReg% = AnimReg% + 10
CONST ObjReg% = BodReg% + 20
CONST ClothReg% = ObjReg% + 5
CONST FoodReg% = ClothReg% + 18
CONST LiqReg% = FoodReg% + 23
CONST VbDim% = LiqReg%

CONST WInfinDim% = 27
CONST AuxVerbDim% = 12

' -- used to DIM Noun Arrays --

CONST People% = 175
CONST Animals% = People% + 50
CONST BodyParts% = Animals% + 45
CONST Objects% = BodyParts% + 150
CONST Containers% = Objects% + 37
CONST Clothes% = Containers% + 55
CONST Edibles% = Clothes% + 105
CONST Potables% = Edibles% + 45
CONST Liquids% = Potables% + 28
CONST Locations% = Liquids% + 50
CONST Cities% = Locations% + 50
CONST NDim% = Cities%

' -- used to DIM other word and phrase arrays --

CONST GenAdjDim% = 75
CONST PersonAdjDim% = GenAdjDim% + 100
CONST FoodAdjDim% = PersonAdjDim% + 25
CONST AdjDim% = FoodAdjDim%
CONST IrrAdjDim% = 3

CONST FrqDim% = 20
CONST IntDim% = 40
CONST AmDim% = 25
CONST ProvDim% = 15
CONST ExDim% = 30
CONST BrdgDim% = 26
CONST InitDim% = 12
CONST AsDim% = 10
CONST BoyDim% = 25
CONST GirlDim% = 25
CONST EZPhraseDim% = 6
CONST TimePassDim% = 10
CONST TimeDurDim% = 10
CONST Resp2Dim% = 22
CONST ColorDim% = 10
CONST EndDim% = 20

'-- used to DIM evaluation data arrays --

CONST CodeNum% = 6       'DIMs PronArt$()
CONST PronList% = 4      'DIMs PronArt$()
CONST MaxUser% = 27      'DIMs UserWords$()
CONST TestVbDim% = 37    'DIMs TestVb()
CONST TestProDim% = 9    'DIMs TestPro()
CONST WhyHowDim% = 7     'DIMs WhyHow()
CONST NotNDim% = 20      'DIMs NotNoun$()
CONST PadDim% = 22       'DIMs PadWord()

'===================================
'    ARRAYS DIMENSIONED
'===================================

 'These arrays will be stored in DGROUP (near memory) for fast access

DIM SHARED Nouns$(1 TO NDim%)
DIM SHARED PronArt$(1 TO CodeNum%, 1 TO PronList%)
DIM SHARED NotNoun$(1 TO NotNDim%)       'used in TestForNoun SUB
DIM SHARED Response$(1 TO 3)             'holds begin/mid/end of response
DIM SHARED EachSent$(6)                  'holds seperated sentances/questions
DIM SHARED LastWords$(1 TO MaxUser%)     'holds each "word" of last sentance
DIM SHARED UserWords$(1 TO MaxUser%)     'holds each "word" of user's input

 'These arrays will be stored in FAR HEAP

REM $DYNAMIC

DIM SHARED VbInfin(1 TO VbDim%) AS Leng16
DIM SHARED VbInsep(1 TO VbDim%) AS Leng32
DIM SHARED VbIrrPast(1 TO IrrDim%) AS Leng16
DIM SHARED VbIrrParticiple(1 TO IrrDim%) AS Leng16
DIM SHARED WInfinitive(1 TO WInfinDim%) AS Leng16
DIM SHARED WInfinitivePast(1 TO WInfinDim%) AS Leng16
DIM SHARED AuxilliaryVb(1 TO AuxVerbDim%) AS Leng16

DIM SHARED Adjective(1 TO AdjDim%) AS Leng16
DIM SHARED IrrCmp(1 TO IrrAdjDim%) AS Leng16
DIM SHARED IrrSup(1 TO IrrAdjDim%) AS Leng16
DIM SHARED Frequency(1 TO FrqDim%) AS Leng16
DIM SHARED Intensifier(1 TO IntDim%) AS Leng16
DIM SHARED BoyName(1 TO BoyDim%) AS Leng16
DIM SHARED GirlName(1 TO GirlDim%) AS Leng16
DIM SHARED Exclamation(1 TO ExDim%) AS Leng32
DIM SHARED Bridge(1 TO BrdgDim%) AS Leng32
DIM SHARED NumberAmount(1 TO AmDim%) AS Leng16
DIM SHARED Proverb(1 TO ProvDim%) AS Leng64
DIM SHARED InitResp(1 TO InitDim%) AS Leng64
DIM SHARED AsPhrase(1 TO AsDim%) AS Leng64
DIM SHARED TimePass(1 TO TimePassDim%) AS Leng16
DIM SHARED TimeDur(1 TO TimeDurDim%) AS Leng32

DIM SHARED EZPhrase(1 TO EZPhraseDim%) AS Leng16   'used in EasyAnswer SUB
DIM SHARED TestVb(1 TO TestVbDim%) AS Leng16       'used in QuesAnswer SUB
DIM SHARED TestPro(1 TO TestProDim%) AS Leng16     'used in QuesAnswer SUB
DIM SHARED WhyHow(1 TO WhyHowDim%) AS Leng16       'used in WhyHowQuery SUB
DIM SHARED PadWord(1 TO PadDim%) AS Leng16         'used in TestFirstWord SUB

DIM SHARED MenuWinText(1 TO 6) AS Leng16
DIM SHARED HelpWinText(1 TO 20) AS Leng64

DIM SHARED NoInp(1 TO 6) AS Leng128
DIM SHARED Obscen(1 TO 5) AS Leng64
DIM SHARED Gibber(1 TO 15) AS Leng128

DIM SHARED WHowAns(1 TO 22) AS Leng64
DIM SHARED ImpAns(1 TO 6) AS Leng64
DIM SHARED Resp2(1 TO Resp2Dim%) AS Leng64
DIM SHARED ByePhrase(1 TO 5) AS Leng64
DIM SHARED EndMessage(1 TO EndDim%) AS Leng64
DIM SHARED SetColorMenu(1 TO ColorDim%) AS Leng64
DIM SHARED ColorPrompt(1 TO 6) AS Leng64

DIM SHARED VbObjCode%(1 TO VbDim%)
DIM SHARED PronArtCode%(1 TO NDim%)
DIM SHARED AdjCode%(1 TO AdjDim%)

DIM SHARED UnderMenu(1 TO 4000) AS INTEGER
DIM SHARED UnderHelp(1 TO 4000) AS INTEGER

'======================
'  DEF FNRndNum
'======================
'  DEF FN makes less code per call, and this is called a lot!
'  When this was a FUNCTION, CLAUDE used 350 more bytes of code.
'  The random series generated by this code slightly disfavors
'  returning the first number in the sequence (Lower%)

DEF FNRndNum% (Lower%, Upper%)
   IF Lower% = Upper% THEN
      X% = Lower%
   ELSE
      X% = CINT(RND * (Upper% - Lower%))
      X% = X% + Lower%
   END IF
   FNRndNum% = X%
END DEF

'=====================================
'   SET SCREEN COLORS / PRINT TITLE
'=====================================

DIM SHARED Fore%
DIM SHARED Back%
DIM SHARED MenuFore%
DIM SHARED MenuBack%
DIM SHARED HelpFore%
DIM SHARED HelpBack%
DIM SHARED Mono%          'a flag set when screen colors are B&W
DIM SHARED MonSeg%        'points to the video memory segment

RANDOMIZE (TIMER)         'CLAUDE uses lots of random numbers

CALL LoadFixed64(SetColorMenu(), ColorDim%)
CALL LoadFixed64(ColorPrompt(), 6)
CALL SetColor       'detects color/mono monitor, and sets screen colors

COLOR Fore%, Back%  'set colors for title screen
CALL TitleUp        'prints CLAUDE's title screen and shows it
                    '    while the arrays are loaded, below.

'==========================
'  ARRAYS LOADED
'==========================

 CALL LoadAllArrays               'this SUB does just what its name says

'====================================
'  OPENING SCREEN / GET USER NAME
'====================================

CLS

CALL Opening     'sets screen; gets user name; greets user
GOTO IntoLoop    'now, enter MAIN LOOP and bypass Response1stPart

'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'   START OF MAIN LOOP
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

DO                            'the end of this LOOP is about 45 lines below

  Response$(1) = Nul$         'the next SUB needs to test this for null
  CALL Response1stPart        'generate first portion of CLAUDE's response
  CALL NullAll                'resets all word variables to null strings
IntoLoop:                     'target of a jump from about 10 lines above

IF AllRespMade% THEN          'flag set when no further response needed
  Response$(2) = Nul$         'erase these so they won't
  Response$(3) = Nul$         'carry over to next trip around the loop
ELSE
  IF FoundNoun% = FALSE THEN
     CALL Response2ndPart
  ELSE                        'if FoundNoun% there's no need for RespPart2
     Response$(2) = Nul$
  END IF
     CALL Response3rdPart
END IF

Respond$ = Response$(1) + Response$(2) + Response$(3)

CALL WrapPrint(RTRIM$(Respond$))
CALL FlagReset                'sets flags to FALSE, erases some string arrays

'===========================================
'   GET USER INPUT / TEST INPUT
'===========================================

Cursor% = CSRLIN              'GetInput SUB must know cursor's line
CALL GetInput(Cursor%, 1, 79)

CALL BreakUp                  'BreakUp calls to other procedures
  IF NoSense% = TRUE OR NoInput% = TRUE OR Obscene% = TRUE THEN GOTO ByPass
CALL TestAllPunc              'evaluates punctuation
  IF NoSense% THEN GOTO ByPass
CALL TestForNoun              'tests UserWords$() against Nouns$()
                              'and sets FoundNoun% pointer to first noun found
ByPass:                       'jump here to bypass time-consuming TestForNoun
                              '   when it isn't strictly neccesary
CALL ShrinkWords              'compresses UserWords$() down to final sentance

'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'  END OF MAIN LOOP
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

LOOP                          'Loops back to a DO, about 45 lines above


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'                         END CODE SECTION
'                        BEGIN DATA SECTION
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'==================
' COLORMENU DATA
'==================

DATA ""
DATA "   Black ... 0        Gray ............ 8"
DATA "   Blue .... 1        Light Blue ...... 9"
DATA "   Green ... 2        Light Green .... 10 "
DATA "   Cyan .... 3        Light Cyan ..... 11 "
DATA "   Red ..... 4        Light Red ...... 12 "
DATA "   Magenta . 5        Light Magenta .. 13"
DATA "   Brown ... 6        Yellow ......... 14 "
DATA "   White ... 7        Intense White .. 15"
DATA ""

'========================
' Color Prompt DATA
'========================

DATA "            Enter CLAUDE's new foreground:"
DATA "            Enter CLAUDE's new background:"
DATA "           Enter new Help Menu foreground:"
DATA "           Enter new Help Menu background:"
DATA "         Enter new Help Window foreground:"
DATA "         Enter new Help Window background:"

'=========================
'   INFINITIVES
'=========================

DATA put, put, put, put, put
DATA get, get, get, get, get
DATA get, get, get, get, put
DATA make, make, make, understand, think
DATA think, have, have, have, have

DATA have, have, do, do, do
DATA give, give, go, go, go
DATA get, go, go, keep, keep
DATA keep, keep, let, let, go
DATA see, see, take, take, take

DATA take, take, take, know, know
DATA know, know, draw, draw, draw
DATA ride, ride, swear, swear, spit
DATA spit, hurt, hide, shake, grow
DATA grow, grow, send, send, feed

DATA fly, fly, fall, fall, fall
DATA stand, stand, stand, stand, stand
DATA find, find, write, write, write
DATA read, read, read, lose, lose
DATA win, buy, buy, sell, sell

'  101 - 175 (HUMAN) IRR INFINITIVES

DATA pay, pay, pay, pay, meet
DATA meet, meet, say, say, tell
DATA tell, tell, hear, hear, hear
DATA hang, hang, hang, eat, partake
DATA wear, wear, steal, steal, shoot

DATA fight, fight, speak, speak, sing
DATA sing, get, get, get, get
DATA make, make, come, come, come
DATA come, run, run, run, run
DATA run, run, sit, sit, sit

DATA feel, feel, bring, bring, throw
DATA throw, throw, catch, catch, catch
DATA hold, hold, hold, hold, dig
DATA make, hit, hit, break, bend
DATA put, get, make, keep, see

'  (ANIMAL) IRREGULAR INFINITIVES 176 - 225

DATA get, get, get, get, put
DATA make, have, have, do, give
DATA give, go, keep, see, take
DATA take, know, know, go, hide
DATA hide, grow, fall, fall, fall

DATA stand, find, find, lose, lose
DATA win, hang, eat, drink, bite
DATA fight, get, sleep, stink, become
DATA get, make, go, run, run
DATA sit, catch, catch, break, bite

'  (BODY) IRR INFINITIVES 226 - 237

DATA hurt, run, grow, feel, get
DATA get, take, do, stink, get
DATA get, get

'  (OBJ) IRR INFINITIVES 238 - 246

DATA get, get, get, get, get
DATA fall, sit, wear, do

'  (CLOTHES) IRR INFINITIVES 247 - 256

DATA tear, fall, get, get, get
DATA get, catch, get, hang, stink

'  (FOOD) IRR INFINITIVES 257 - 269

DATA get, get, get, stink, make
DATA get, get, go, get, get
DATA get, feed, fall

'  (LIQUID) IRR INFINITIVES 270 - 271

DATA get, fall


'  (HUMAN) REG INFINITIVES  272 - 357

DATA yawn, laugh, laugh, smile, laugh
DATA dance, yell, imagine, explain, wink
DATA sigh, ask, lie, insult, work
DATA rob, drop, hug, travel, travel
DATA paint, care, care, cheat, smoke

DATA tease, agree, look, thank, argue
DATA argue, flirt, help, prattle, tickle
DATA wad, sweat, carry, visit, pick
DATA push, shove, pretend, pose, settle
DATA fry, wash, dress, fit, stain

DATA tug, own, pitch, scratch, cover
DATA kiss, spill, injure, bruise, bump
DATA shave, pinch, soak, sip, guzzle
DATA swig, consume, imbibe, down, pour
DATA admire, praise, save, save, change

DATA deliver, bawl, patch, detest, frighten
DATA whistle, ruin, shout, burn, pursue

'  (ANIMAL) REG INFINITIVES

DATA dream, sneeze, play, like, love
DATA hate, hunt, look, look, listen
DATA limp, walk, walk, walk, smell
DATA smell, fetch, slobber, want, avoid
DATA trip, gnaw, choke, chew, gobble

DATA wolf, gulp, swallow, lap, devour
DATA lick, live, live, live, watch
DATA jump, snack, sniff, paw, snack
DATA stop, fake, stop

'  (BODY) REG INFINITIVES

DATA touch, bump, sweat, rub, itch
DATA excite, tremble, age, heal, belong

'  (OBJECT) REG INFINITIVES

DATA gather, break, astonish, appeal, bother
DATA look, interest, intrigue, fascinate, confuse
DATA excite, attract, frighten, disgust, burn
DATA belong, trip, injure, shock, smell

'  (CLOTHES) REG INFINITIVES

DATA rip, cover, rub, clothe, smell

'  (FOOD) REG INFINITIVES

DATA spoil, rot, smell, taste, taste
DATA tempt, cause, entice, appeal, smell
DATA decay, mold, turn, turn, choke
DATA surprise, disgust, kill

'  (LIQUID) REG INFINITIVES

DATA squirt, squirt, dribble, flow, drip
DATA spill, spill, spill, pour, trickle
DATA gush, soak, drench, spurt, escape
DATA splash, pour, stain, ruin, pool
DATA trickle, squirt, sop

'=========================
'      INSEPS
'=========================

DATA on, away, in a good word for, one over on, a high value on
DATA excited about, lost on the way to, in trouble over, one up on, sentimental about
DATA taken to the cleaners by, serious about, "", together with, an end to
DATA a big deal out of, a mess of, big plans for, "", about
DATA deeply about, "", it out with, doubts about, qualms about

DATA it in for, a fit about, nothing about, it up brown, a lot for
DATA away, in to, places, along with, to
DATA into, for broke, the extra mile for, out of, an eye on
DATA a secret from, "", bygones be bygones, go of, easy on
DATA eye to eye with, no future in, exception to, off, a stand against

DATA a licking, up with, a tip from, all about, what to do with
DATA nothing about, when to quit, pictures of, conclusions about, a crowd
DATA roughshod over, herd on, a blue streak, at, at
DATA on, "", "", "", up in
DATA up, up with, flowers to, greetings to, ""

DATA over, into a rage over, against, out with, under the spell of
DATA up against, up, the world on its ear, next to, to inherit
DATA out about, fault with, to, about, a book about
DATA about, aloud to, the riot act to, "", out to
DATA "", "", a used car from, a used car to, ""

'  101 - 175 (HUMAN) IRR INSEPS

DATA good money for, attention to, off, a compliment to, ""
DATA up with, a ghost in, a good word about, nothing about, lies about
DATA secrets to, stories about, strange noises in, all about, ""
DATA onto, up on, up, like, of
DATA "", out, "", things from, holes in

DATA "", over, well of, at length about, ""
DATA songs about, all broken up about, confused about, out of, sunburned on
DATA a fool out of, stupid remarks about, out against, to admire, to a dire conclusion about
DATA into a fortune, out of, over, "", circles around
DATA true to form, into problems with, with, next to, down

DATA "", bad about, up, out the best in, ""
DATA out, away, "", on to, cold
DATA "", onto, out against, a grudge against, up some dirt on
DATA "", "", the roof at the mention of, up with, over backwards to please
DATA off, on with, up for, on, no point in

' (ANIMAL) IRR INSEPS

DATA along with, along without, a charge out of, away from, up with
DATA friends with, a grudge against, no truck with, without, up on
DATA the slip to, everywhere with, away from, "", a shine to
DATA on, more than, "", crazy over, in
DATA from, fond of, down, over, in love with

DATA up to, "", pleasure in, patience with, a taste for
DATA the heart of, around with, "", "", into
DATA with, into fights over, "", "", obsessed with
DATA into trouble over, a dash for, nuts over, away from, after
DATA on, up with, hell from, "", ""

' (BODY) IRR INSEPS

DATA "", into, old, bad, kissed by
DATA hurt by, a licking from, nothing at all, "", sunburned
DATA soaked in, dirty

' (OBJ) IRR INSEPS

DATA lost by, thrown at, dropped by, bought by, given to
DATA over, next to, out, nothing at all

' (CLOTHES) IRR INSEPS

DATA apart, onto, stained with, washed, dirty
DATA worn by, on, outdated, up to dry, ""

'  (FOOD) IRR INSEPS

DATA eaten by, spilled on, devoured by, "", someone hungry
DATA tasted by, slobbered on by, bad, soaked with, thrown out by
DATA mislaid by, "", on

'  (LIQUID) IRR INSEPS

DATA all over, onto


'  (HUMAN) REG INSEPS

DATA "", about, at, at, ""
DATA like, at, "", things to, at
DATA "", about, about, "", like
DATA "", "", "", to, with
DATA pictures of, for, about, "", cigars

DATA "", with, after, "", about
DATA with, with, out, on and on about, ""
DATA up, "", "" , "", up
DATA "", "", to be, as, for
DATA "", "", in, into, ""

DATA at, "", a fit over, "", up
DATA "", food on, "", "", ""
DATA "", "", "", "", ""
DATA "", "", "", "", ""
DATA "", "" , up for, "", into

DATA "", out, up, "", ""
DATA at, "", at, a hole in, ""

'  (ANIMAL) REG INSEPS

DATA about, "", with, "", ""
DATA "", for, for, at, to
DATA "", into, away from, through, bad
DATA "", "", on, "", ""
DATA over, on, on, on, up

DATA down, down, "", up, ""
DATA "", with, next door to, in, ""
DATA over, on, "", at, on
DATA "", "", ""

'  (BODY) REG INSEPS

DATA "", into, "", against, ""
DATA "", "", "", "", to

'  (OBJECT) REG INSEPS

DATA dust, "", "", to, ""
DATA interesting to, "", "", "", ""
DATA "", "", "", "", ""
DATA to, "", "", "", funny

'  (CLOTHES) REG INSEPS

DATA "", up, against, "", odd

'  (FOOD) REG INSEPS

DATA "", "", good to, good to, awful to
DATA "", a bellyache, "", to, awful to
DATA "", "", stale, bad, ""
DATA "", "", the appetite of

'  (LIQUID) REG INSEPS

DATA onto, at, onto, out of, onto
DATA "", out of, onto, out of, onto
DATA out of, "", "", onto, from
DATA out of, into, "", "", under
DATA out of, out of, ""

'=========================
'   OBJCODES
'=========================

DATA 64, 96, 2, 2, 1013
DATA 2047, 3072, 1013, 2, 2047
DATA 2, 2047, 84, 2, 5
DATA 2047, 65, 7, 2046, 2047
DATA 2047, 220, 2, 3, 471

DATA 6, 5, 23, 0, 6
DATA 1012, 2, 0, 3, 3072
DATA 64, 0, 2, 3072, 1012
DATA 2, 20, 0, 246, 2
DATA 2, 2047, 7, 64, 3

DATA 0, 2, 2, 2047, 756
DATA 2047, 0, 254, 2047, 0
DATA 2, 6, 0, 6, 6
DATA 254, 12, 244, 80, 3072
DATA 0, 6, 2, 2, 6

DATA 3072, 1012, 22, 2, 2
DATA 3, 0, 0, 52, 52
DATA 2047, 1023, 2, 4095, 4095
DATA 1023, 2, 2, 116, 2
DATA 116, 116, 2, 2, 1012

'   101 - 175  (HUMAN) IRR OBJCODES

DATA 1012, 2046, 2, 2, 2
DATA 6, 1024, 4095, 4095, 4095
DATA 6, 4095, 1024, 1012, 6
DATA 118, 2, 64, 6, 384
DATA 64, 80, 1012, 2, 48

DATA 6, 1014, 1012, 4095, 0
DATA 4095, 127, 127, 3072, 8
DATA 2, 4095, 366, 14, 2526
DATA 0, 768, 84, 0, 6
DATA 0, 854, 6, 6, 0

DATA 94, 7, 6, 6, 944
DATA 944, 944, 52, 2, 0
DATA 118, 126, 6, 2054, 2
DATA 496, 6, 223, 2, 6
DATA 1, 1, 1, 1, 1

'  (ANIMAL) IRR OBJCODES

DATA 6, 509, 2047, 3078, 118
DATA 6, 6, 2047, 466, 1022
DATA 6, 22, 3078, 2046, 390
DATA 6, 4, 6, 391, 1024
DATA 6, 471, 0, 48, 118

DATA 6, 144, 144, 6, 384
DATA 2, 6, 128, 256, 128
DATA 6, 1014, 0, 0, 4095
DATA 23, 1024, 2047, 3078, 6
DATA 16, 6, 2, 56, 2

'  (BODY) IRR OBJCODES

DATA 0, 16, 0, 0, 2
DATA 52, 18, 0, 0, 0
DATA 768, 0

'  (OBJ) IRR OBJCODES

DATA 2, 182, 2, 2, 2
DATA 0, 1040, 0, 0

'  (CLOTHES) IRR OBJCODES

DATA 0, 150, 768, 0, 0
DATA 2, 16, 0, 0, 0

' (FOOD) IRR OBJCODES

DATA 6, 92, 6, 0, 0
DATA 6, 4, 0, 256, 2
DATA 2, 6, 80

'  (LIQUID) IRR OBJCODES

DATA 214, 1168

'  (HUMAN) REG OBJCODES

DATA 0, 127, 6, 6, 0
DATA 6, 6, 408, 2, 2
DATA 0, 1023, 4095, 6, 6
DATA 2, 112, 6, 2048, 6
DATA 3326, 6, 6, 2, 0

DATA 6, 2, 6, 2, 1009
DATA 2, 2, 6, 4094, 10
DATA 64, 0, 112, 3078, 80
DATA 2, 2, 6, 6, 416
DATA 128, 76, 64, 1088, 64

DATA 72, 2036, 29, 14, 24
DATA 6, 76, 8, 8, 14
DATA 12, 10, 64, 256, 256
DATA 256, 384, 256, 256, 768
DATA 14, 6, 112, 6, 64

DATA 112, 6, 64, 3071, 6
DATA 6, 240, 6, 64, 6

'  (ANIMAL) REG OBJCODES

DATA 1023, 0, 6, 511, 511
DATA 511, 246, 246, 1022, 2
DATA 0, 1024, 1026, 3072, 0
DATA 390, 240, 194, 1012, 3078
DATA 112, 192, 192, 208, 128

DATA 128, 384, 384, 256, 128
DATA 136, 6, 6, 3072, 22
DATA 52, 128, 390, 240, 128
DATA 1, 1, 1

'  (BODY) REG OBJCODES

DATA 54, 48, 0, 208, 0
DATA 6, 0, 0, 0, 2

'  (OBJECT) REG OBJCODES

DATA 0, 0, 6, 2, 6
DATA 6, 6, 6, 6, 6
DATA 4, 6, 6, 6, 0
DATA 2, 6, 6, 2, 0

'  (CLOTHES) REG OBJCODES

DATA 0, 8, 148, 2, 0

'  (FOOD) REG OBJCODES

DATA 0, 0, 6, 6, 6
DATA 6, 0, 6, 2, 6
DATA 0, 0, 0, 0, 6
DATA 2, 6, 6

'  (LIQUID) REG OBJCODES

DATA 78, 22, 214, 32, 214
DATA 0, 32, 214, 32, 212
DATA 32, 64, 64, 88, 32
DATA 32, 32, 64, 144, 16
DATA 32, 32, 64

'=============================
'   IRREGULAR PAST TENSES
'=============================

DATA put, put, put, put, put
DATA got, got, got, got, got
DATA got, got, got, got, put
DATA made, made, made, understood, thought
DATA thought, had, had, had, had

DATA had, had, did, did, did
DATA gave, gave, went, went, went
DATA got, went, went, kept, kept
DATA kept, kept, let, let, went
DATA saw, saw, took, took, took

DATA took, took, took, knew, knew
DATA knew, knew, drew, drew, drew
DATA rode, rode, swore, swore, spat
DATA spat, hurt, hid, shook, grew
DATA grew, grew, sent, sent, fed

DATA flew, flew, fell, fell, fell
DATA stood, stood, stood, stood, stood
DATA found, found, wrote, wrote, wrote
DATA read, read, read, lost, lost
DATA won, bought, bought, sold, sold

'  101 - 175  (HUMAN) IRR PAST TENSE

DATA paid, paid, paid, paid, met
DATA met, met, said, said, told
DATA told, told, heard, heard, heard
DATA hung, hung, hung, ate, partook
DATA wore, wore, stole, stole, shot

DATA fought, fought, spoke, spoke, sang
DATA sang, got, got, got, got
DATA made, made, came, came, came
DATA came, ran, ran, ran, ran
DATA ran, ran, sat, sat, sat

DATA felt, felt, brought, brought, threw
DATA threw, threw, caught, caught, caught
DATA held, held, held, held, dug
DATA made, hit, hit, broke, bent
DATA put, got, made, kept, saw

'  (ANIMAL) IRR PAST TENSE

DATA got, got, got, got, put
DATA made, had, had, did, gave
DATA gave, went, kept, saw, took
DATA took, knew, knew, went, hid
DATA hid, grew, fell, fell, fell

DATA stood, found, found, lost, lost
DATA won, hung, ate, drank, bit
DATA fought, got, slept, stank, became
DATA got, made, went, ran, ran
DATA sat, caught, caught, broke, bit

'  (BODY) IRR PAST TENSE

DATA hurt, ran, grew, felt, got
DATA got, took, did, stank, got
DATA got, got

'  (OBJ) IRR PAST TENSE

DATA got, got, got, got, got
DATA fell, sat, wore, did

'  (CLOTHES) IRR PAST TENSE

DATA tore, fell, got, got, got
DATA got, caught, got, hung, stank

'  (FOOD) IRR PAST TENSE

DATA got, got, got, stank, made
DATA got, got, went, got, got
DATA got, fed, fell

'  (LIQUID) IRR PAST TENSE

DATA got, fell

'=================================
'  IRREGULAR PAST PARTICIPLES
'=================================

DATA put, put, put, put, put
DATA gotten, gotten, gotten, gotten, gotten
DATA gotten, gotten, gotten, gotten, put
DATA made, made, made, understood, thought
DATA thought, had, had, had, had

DATA had, had, done, done, done
DATA given, given, gone, gone, gone
DATA gotten, gone, gone, kept, kept
DATA kept, kept, let, let, gone
DATA seen, seen, taken, taken, taken

DATA taken, taken, taken, known, known
DATA known, known, drawn, drawn, drawn
DATA ridden, ridden, sworn, sworn, spat
DATA spat, hurt, hidden, shaken, grown
DATA grown, grown, sent, sent, fed

DATA flown, flown, fallen, fallen, fallen
DATA stood, stood, stood, stood, stood
DATA found, found, written, written, written
DATA read, read, read, lost, lost
DATA won, bought, bought, sold, sold

' 101 - 175  (HUMAN) IRR PAST PARTICIPLES

DATA paid, paid, paid, paid, met
DATA met, met, said, said, told
DATA told, told, heard, heard, heard
DATA hung, hung, hung, eaten, partaken
DATA worn, worn, stolen, stolen, shot

DATA fought, fought, spoken, spoken, sung
DATA sung, gotten, gotten, gotten, gotten
DATA made, made, come, come, come
DATA come, run, run, run, run
DATA run, run, sat, sat, sat

DATA felt, felt, brought, brought, thrown
DATA thrown, thrown, caught, caught, caught
DATA held, held, held, held, dug
DATA made, hit, hit, broken, bent
DATA put, gotten, made, kept, seen

' (ANIMAL) IRR PAST PARTICIPLES

DATA gotten, gotten, gotten, gotten, put
DATA made, had, had, done, given
DATA given, gone, kept, seen, taken
DATA taken, known, known, gone, hidden
DATA hidden, grown, fallen, fallen, fallen

DATA stood, found, found, lost, lost
DATA won, hung, eaten, drunk, bitten
DATA fought, gotten, slept, stunk, become
DATA gotten, made, gone, run, run
DATA sat, caught, caught, broken, bitten

' (BODY) IRR PAST PARTICIPLES

DATA hurt, run, grown, felt, gotten
DATA gotten, taken, done, stunk, gotten
DATA gotten, gotten

' (OBJ) IRR PAST PARTICIPLES

DATA gotten, gotten, gotten, gotten, gotten
DATA fallen, sat, worn, done

' (CLOTHES) IRR PAST PARTICIPLES

DATA torn, fallen, gotten, gotten, gotten
DATA gotten, caught, gotten, hung, stunk

' (FOOD) IRR PAST PARTICIPLES

DATA gotten, gotten, gotten, stunk, made
DATA gotten, gotten, gone, gotten, gotten
DATA gotten, fed, fallen

'  (LIQUID) IRR PAST PARTICIPLES

DATA gotten, fallen

'==============================
'  AUXILLIARY VERBS
'==============================

' WITH-INFINITIVE PRESENT TENSE

DATA begin, forget, choose, get, appear
DATA want, need, wish, decide, try
DATA like, ask, agree, hope, deserve
DATA intend, expect, seem, plan, start
DATA used, refuse, set out, propose, know how
DATA manage, know better than

'   WITH-INFINITIVE PAST TENSE

DATA began, forgot, chose, got, appeared
DATA wanted, needed, wished, decided, tried
DATA liked, asked, agreed, hoped, deserved
DATA intended, expected, seemed, planned, started
DATA used, refused, set out, proposed, knew how
DATA managed, knew better than

' AUXILLIARY PRESENT/PAST TENSES

DATA must, can, will, should, could, would
DATA must not, can't, won't, shouldn't, couldn't, wouldn't


'=========================
'     NOUNS
'=========================

DATA thief, man, woman, madman, boy
DATA dad, mom, wife, barber, ex-wife
DATA sister, brother, mother, father, son
DATA daughter, niece, nephew, aunt, uncle
DATA grandmother, grandfather, cousin, cousin, neighbor

DATA landlady, bookie, idiot, maniac, oaf
DATA nincompoop, yahoo, prude, hero, wheeler dealer
DATA bible thumper, pencil pusher, media mogul, egghead, hack writer
DATA teacher's pet, southern belle, pill pusher, mama's boy, fan dancer
DATA creep, palooka, born loser, hayseed, jerk

DATA gambler, burglar, purse snatcher, horse player, jockey
DATA blabbermouth, stoolie, bank president, bank teller, disc jockey
DATA bum, butcher, bookkeeper, musician, telephone operator
DATA fire fighter, gardener, heavy equipment operator, sculptor, upholsterer
DATA hairdresser, bartender, bouncer, husband, shopkeeper

DATA machinist, poet, novelist, composer, engineer
DATA beauty queen, cheerleader, receptionist, law clerk, beekeeper
DATA sales clerk, chauvinist pig, cop, private detective, yuppie
DATA sap, airhead, golfer, pinhead, nonentity
DATA reporter, loudmouth, inspector, factory worker, bonehead

'   101 - 160  (PEOPLE) NOUNS

DATA grump, grouch, wimp, pipe smoker, wrestler
DATA drunkard, scientist, individual, junk dealer, fussbudget
DATA complainer, jet setter, nebbish, stripper, comedian
DATA actor, actress, embezzler, electrician, accountant
DATA architect, editor, babysitter, teenager, teenager

DATA intellectual, bus driver, prison guard, janitor, football coach
DATA stockbroker, sheriff's deputy, truck driver, park ranger, pole vaulter
DATA computer programmer, carpenter, house painter, priest, nun
DATA minister, preacher, panhandler, pawnbroker, pickpocket
DATA politician, yokel, short order cook, waiter, waitress

DATA piano teacher, teacher, teacher, doctor, doctor
DATA lawyer, lawyer, secretary, nurse, stewardess
DATA librarian, student, student, lumberjack, cowboy
DATA kid, kid, guy, geek, slob
DATA policeman, mailman, repairman, girl, salesman

'  (ANIMALS) NOUNS

DATA mouse, cat, dog, cow, horse
DATA pig, poodle, lap dog, fox terrier, sheepdog
DATA labrador retriever, hound dog, german shepard, dachshund, puppy
DATA cocker spaniel, coyote, bulldog, mongrel, chihuahua
DATA schnauzer, irish wolfhound, ferret, golden retriever, scotch terrier

DATA thoroughbred horse, mink, fox, weasel, sow
DATA stoat, boar, hare, rabbit, dalmatian
DATA greyhound, bloodhound, irish setter, siberian husky, mutt
DATA bear, raccoon, porcupine, jersey cow, mule
DATA chimpanzee, chipmunk, collie, gerbil, squirrel

'  (BODY PARTS) NOUNS

DATA foot, big toe, toe, heel, ankle
DATA knee, leg, thigh, hip, belly
DATA stomach, backside, fanny, sole, chest
DATA shoulder, arm, thumb, finger, hand
DATA wrist, forearm, elbow, neck, armpit

DATA knuckle, chin, cheek, head, ear
DATA earlobe, nose, forehead, lip, mouth
DATA hair, face, eyebrow, eyelid, shoulder blade
DATA navel, belly button, moustache, shin, pelvis

'  (OBJECTS) NOUNS

DATA knife, fireplace tongs, tweezers, scissors, pliers
DATA fork, plate, napkin, tablecloth, chair
DATA lamp, toy, houseplant, lid, potholder
DATA refrigerator magnet, picture frame, photo album, book, dictionary
DATA steno tablet, clock, record album, cassette tape, newspaper

DATA calendar, railroad timetable, shoelace, road map, telephone
DATA letter, frying pan, corkscrew, candle, spatula
DATA wooden spoon, pine cone, fireplace poker, egg beater, skewer
DATA bib, baby bottle, pill bottle, cork, tray
DATA broom, lamp, lightbulb, guitar, coffee table

DATA paper bag, pillow, baseball, basketball, baseball bat
DATA stapler, checkbook, bookmark, typewriter, whatchamacallit
DATA paper, garbage, gravel, dirt, money
DATA cash, trash, stuff, soap, masking tape
DATA string, thread, rope, calculator, thumbtack

DATA dime, nickel, penny, dollar, blanket
DATA bedsheet, pen, pencil, crayon, paintbrush
DATA stick, hammer, chisel, flashlight, screwdriver
DATA key, doorknob, nail, screw, stone
DATA rock, pebble, brick, shovel, rake

'  101- 150 (OBJECTS) NOUNS

DATA hoe, oar, ladder, spool, mirror
DATA radio, tape player, dustpan, globe, matchbook
DATA fishing rod, flower pot, hairbrush, toothbrush, razor
DATA cookbook, thermometer, briefcase, slide projector, fan
DATA wastebasket, teddy bear, clock radio, suitcase, clothes hamper

DATA bathmat, garden hose, trowel, board game, purse
DATA necklace, rubber ducky, hat rack, trumpet, wedding ring
DATA potato masher, mop, volleyball, toolbox, ruler
DATA yardstick, mallet, handsaw, doll, magazine
DATA throw rug, drill bit, rubber band, toothpick, cereal box

'  (CONTAINERS) NOUNS

DATA glass, cup, mug, bottle, jar
DATA thermos bottle, carafe, gravy boat, spoon, measuring cup
DATA bucket, barrel, steel drum, thimble, shot glass
DATA ladle, teacup, saucer, dish, pan
DATA saucepan, pitcher, soupcan, pot, bowl

DATA vase, tea kettle, teapot, coffee pot, tablespoon
DATA teaspoon, jug, sink, spittoon, tub
DATA washbasin, pail

'  (CLOTHES) NOUNS

DATA scarf, handkerchief, bra, sport coat, sport jacket
DATA shirt, sweatshirt, coat, raincoat, black leather jacket
DATA sweater, mask, cloak, shower cap, towel
DATA garter belt, belt, skirt, dress, blouse
DATA jacket, robe, bathrobe, bandana, hat

DATA baseball cap, t-shirt, stocking cap, fur coat, cowboy hat
DATA fedora, overcoat, apron, underwear, panty hose
DATA bloomers, shorts, pedal pushers, slacks, high heels
DATA boots, cowboy boots, trousers, suspenders, mittens
DATA hip waders, overalls, shoes, socks, gloves

DATA pants, blue jeans, sandals, earmuffs, clothes

' (EDIBLES) NOUNS

DATA food, bread, rice, cheese, meat
DATA fruit, flour, candy, salt, bacon
DATA spinach, lettuce, garlic, butter, syrup
DATA honey, sugar, corn, lard, gravy
DATA jam, mustard, ketchup, mashed potatos, ice cream

DATA chocolate, jelly, cole slaw, potato salad, corn flakes
DATA oatmeal, mush, cornbread, gum, beef stew
DATA liver, tofu, pepper, cottage cheese, yoghurt
DATA celery, peanut butter, spaghetti, ham, beef
DATA chicken, pork, salad, salmon, corn meal

DATA cookie, trout, pizza, shrimp cocktail, biscuit
DATA taco, burrito, enchilada, oyster, ice cream cone
DATA candy bar, peanut, walnut, doughnut, pickle
DATA beet, bean, turnip, cracker, eggplant
DATA hamburger, ham sandwich, meatball, potato chip, french fry

DATA pork chop, t-bone steak, apple pie, artichoke, orange
DATA tuna casserole, muffin, carrot, radish, cucumber
DATA tomato, vegetable, baked potato, fried egg, peach
DATA pear, lemon, grape, melon, cherry
DATA banana, tangerine, strawberry, raspberry, raisin

DATA onion, apple, olive, almond, yam

'  (POTABLES) NOUNS

DATA wine, coffee, beer, tea, milk
DATA herbal tea, cream, soda pop, coke, champagne
DATA water, vodka, whiskey, gin, brandy
DATA sparkling water, sloe gin, tequila, ice water, soup
DATA instant coffee, espresso, steamed milk, gazpacho, iced tea

DATA wine, bourbon, fruit juice, hot chocolate, orange juice
DATA apple juice, grape juice, cranberry juice, lemonade, scotch whiskey
DATA prune juice, koolaid, cider, hard cider, gravy
DATA liquor, ale, tomato juice, chicken soup, buttermilk

'  (LIQUIDS) NOUNS

DATA liquid, water, dishwater, bathwater, rain water
DATA gasoline, motor oil, spit, ink, paint
DATA shampoo, paint thinner, hot water, drool, hair oil
DATA sweat, perfume, cologne, hand lotion, aftershave lotion
DATA furniture polish, shellac, varnish, hot candlewax, fluid

DATA lighter fluid, blood, turpentine

'  (LOCATIONS) NOUNS

DATA window seat, bathroom, kitchen, basement, laundry room
DATA bedroom, garage, gazebo, house, living room
DATA library, closet, garden, stairwell, yard
DATA backyard, driveway, attic, road, supermarket
DATA bank, jail, hardware store, bed, shed

DATA playroom, rumpus room, guest room, shower stall, treehouse
DATA clubhouse, school, schoolyard, playground, park
DATA swimming pool, fishpond, linen closet, toll booth, restaurant
DATA tent, liquor store, factory, pantry, fireplace
DATA street, car, parking lot, bathtub, office

'  (CITIES) NOUNS

DATA Albuquerque, Kalamazoo, Scranton, Sandusky, Peoria
DATA Keokuk, Shreveport, Joplin, Estacada, Yreka
DATA Pensacola, Abilene, Laramie, Boise, Lubbock
DATA Trenton, Macon, Tuscaloosa, Tallahassee, Raleigh
DATA Paducah, Bangor, Brattleboro, Kankakee, Providence

DATA Oshkosh, Duluth, Bismarck, Omaha, Tupelo
DATA Natchez, Tulsa, Rapid City, Muscatine, Tuscon
DATA Ogden, Kalispell, Modesto, Yakima, Fresno
DATA Wenatchee, Witchita, Savannah, Altoona, Cheyenne
DATA Ashtabula, Hoquiam, Utica, Juneau, Honolulu

'========================================
'  PRONOUN/ARTICLE CODES FOR NOUNS
'========================================

DATA 3, 3, 5, 3, 3
DATA 3, 5, 5, 3, 6
DATA 5, 3, 5, 3, 3
DATA 5, 5, 3, 6, 4
DATA 5, 3, 5, 3, 3

DATA 5, 3, 4, 3, 4
DATA 3, 3, 5, 3, 3
DATA 3, 3, 3, 4, 3
DATA 5, 5, 3, 3, 5
DATA 3, 3, 3, 3, 3

DATA 3, 3, 3, 3, 5
DATA 3, 3, 3, 5, 5
DATA 3, 3, 5, 5, 5
DATA 3, 3, 3, 3, 6
DATA 5, 3, 3, 3, 3

DATA 3, 5, 5, 3, 4
DATA 5, 5, 5, 5, 3
DATA 5, 3, 3, 3, 3
DATA 3, 4, 3, 3, 3
DATA 5, 5, 6, 5, 3

'  101 - 175  (PEOPLE) PRONCODES

DATA 3, 3, 3, 3, 3
DATA 3, 3, 4, 3, 5
DATA 3, 5, 3, 5, 3
DATA 4, 6, 4, 4, 6
DATA 4, 4, 5, 3, 5

DATA 4, 5, 3, 5, 3
DATA 5, 3, 3, 3, 3
DATA 3, 3, 3, 3, 5
DATA 3, 3, 3, 3, 3
DATA 5, 3, 3, 3, 5

DATA 3, 3, 5, 3, 5
DATA 3, 5, 5, 5, 5
DATA 5, 3, 5, 3, 3
DATA 5, 3, 3, 3, 3
DATA 3, 3, 3, 5, 3

'  (ANIMALS) PRONCODES

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 2, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 2, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

'  (BODY PARTS) PRONCODES

DATA 1, 1, 1, 1, 2
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 2, 1, 1, 1
DATA 1, 1, 2, 1, 2

DATA 1, 1, 1, 1, 2
DATA 2, 1, 1, 1, 1
DATA 7, 1, 2, 2, 1
DATA 1, 1, 1, 1, 1

'  (OBJECTS) PRONCODES

DATA 1, 8, 8, 8, 8
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 2, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

' 101-150 (OBJECTS) PRONCODES

DATA 1, 2, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

'  (CONTAINERS) PRONCODES

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1

'  (CLOTHES) PRONCODES

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 2, 2, 8, 8
DATA 8, 8, 8, 8, 8
DATA 8, 8, 8, 8, 8
DATA 8, 8, 8, 8, 8

DATA 8, 8, 8, 8, 7

'  (EDIBLES) PRONCODES

DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7

DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7

DATA 1, 1, 1, 1, 1
DATA 1, 1, 2, 2, 2
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 2
DATA 1, 1, 1, 1, 1

DATA 1, 1, 2, 2, 2
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1

' 101-105 (EDIBLES) PRONCODES

DATA 2, 2, 2, 2, 1

'  (POTABLES) PRONCODES

DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7

DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7

'  (LIQUIDS) PRONCODES

DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7
DATA 7, 7, 7, 7, 7

DATA 7, 7, 7

'  (LOCATIONS) PRONCODES

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 2, 1, 1
DATA 1, 1, 1, 1, 1

DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 2

'  (CITIES) PRONCODES

DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0

DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0

'==================
'   ADJECTIVES
'==================

 'GENERAL ADJ   1 - 75

DATA good, bad, nice, typical, ordinary
DATA rotten, lousy, peculiar, unusual, ridiculous
DATA great, insufferable, boring, charming, useful
DATA dubious, annoying, tawdry, questionable, pleasant
DATA admirable, adorable, appealing, astonishing, bizarre

DATA abnormal, banal, dreadful, preposterous, excellent
DATA delightful, frightful, noteworthy, likable, indescribable
DATA darling, corny, forgettable, disappointing, bogus-looking
DATA unbelievable, laughable, silly-looking, damnable, dismal
DATA engaging, disreputable, distasteful, exciting, nifty

DATA loathsome, exceptional, obnoxious, pitiful, disgusting
DATA authentic, horrid, fashionable, mediocre, inspiring
DATA fine, lovable, odd, strange, exasperating
DATA stupifying, awful, terrible, unimportant, conventional
DATA unsightly, disgraceful, passive, average, grotesque

 'PERSONS ADJ   76 - 175

DATA ugly, drunk, goofy, moody, dull
DATA loud, dishonest, lamebrained, clumsy, pretentious
DATA idiotic, fatuous, handsome, petty, smelly
DATA incoherent, chubby, skinny, curious, gossipy
DATA brilliant, brainless, sexy, bashful, adroit

DATA absent-minded, astute, skillful, thoughtful, capable
DATA blonde, friendly, blasphemous, confused, cheerful
DATA careless, clumsy, stupid, cantankerous, pompous
DATA cockeyed, whacky, old, daffy, solemn
DATA intelligent, loony, dizzy, cranky, debonair

DATA acrobatic, inventive, trustworthy, awkward, opinionated
DATA sneaky, ambitious, audacious, brave, courageous
DATA musical, happy, sad, easy-going, flippant
DATA foolish, clever, snide, strong, plug-ugly
DATA unlucky, arrogant, reasonable, self-righteous, lazy

DATA dumb, dumpy, cunning, creative, bad-tempered
DATA eager, affectionate, ugly, dull-witted, knock-kneed
DATA obtuse, creepy, gloomy, dirty, sweet-tempered
DATA unpardonable, rude, prudish, suave, lucky
DATA pea-brained, uncontrollable, crude, cultured, purposeful

' FOOD ADJ   176 - 200

DATA indigestible, tasty, delicious, moldy, rancid
DATA unappetizing, bad smelling, insipid, tasteless, gross
DATA nauseating, rotten smelling, flavorful, putrid, greasy
DATA oily, bilious, bland, inedible, yummy
DATA succulent, juicy, gassy, colorless, unappealing

'===========================================================
'  ADJECTIVE CODES  - How to form comparative/superlative
'===========================================================

   '-- General AdjCodes --

DATA 2, 3, 0, 1, 1
DATA 0, 0, 1, 1, 1
DATA 0, 1, 1, 1, 1
DATA 1, 1, 0, 1, 0
DATA 1, 1, 1, 1, 0

DATA 1, 1, 1, 1, 1
DATA 1, 1, 0, 1, 1
DATA 1, 0, 1, 1, 1
DATA 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 0

DATA 1, 1, 1, 1, 1
DATA 1, 0, 1, 1, 1
DATA 0, 1, 0, 0, 1
DATA 1, 1, 1, 0, 1
DATA 0, 1, 1, 1, 1

  '-- Person AdjCodes --

DATA 0, 0, 0, 0, 0
DATA 0, 1, 1, 0, 1
DATA 1, 1, 0, 0, 0
DATA 1, 0, 0, 1, 1
DATA 1, 1, 0, 1, 1

DATA 1, 1, 1, 1, 1
DATA 0, 0, 1, 1, 1
DATA 1, 0, 0, 1, 1
DATA 1, 0, 0, 0, 0
DATA 1, 0, 0, 0, 1

DATA 1, 1, 0, 0, 1
DATA 0, 1, 1, 0, 1
DATA 1, 0, 4, 1, 1
DATA 1, 0, 0, 0, 0
DATA 0, 1, 1, 1, 0

DATA 0, 0, 1, 1, 1
DATA 0, 1, 0, 1, 1
DATA 1, 0, 0, 0, 1
DATA 1, 0, 1, 0, 0
DATA 1, 1, 0, 1, 1

  '-- Food AdjCodes --

DATA 1, 0, 1, 0, 0
DATA 1, 1, 0, 1, 0
DATA 1, 1, 1, 0, 0
DATA 0, 1, 0, 1, 0
DATA 1, 0, 0, 1, 1

'==========================================
' IRREGULAR COMPARATIVES & SUPERLATIVES
'==========================================

DATA better, worse, sadder
DATA best, worst, saddest

'==================================
' FRQ  (ADVERBS OF FREQUENCY)
'==================================

DATA often, seldom, always, never, sometimes
DATA occasionally, frequently, rarely, usually, commonly
DATA already, probably, normally, still, generally
DATA constantly, seldom, always, never, sometimes

'===================================
' INT  (ADVERBS OF INTENSITY)
'===================================

DATA very, completely, absolutely, somewhat, perfectly
DATA very, really, almost, merely, entirely
DATA sort of, clearly, totally, very, fairly
DATA altogether, very, pretty, awfully, utterly
DATA mostly, mighty, rather, very, kind of

DATA positively, really, relatively, very, more or less
DATA just about, barely, nearly, very, uncommonly
DATA unmistakably, exceedingly, evidently, pretty much, dreadfully

'===========================
'   NUMBER OR AMOUNT
'===========================

DATA tons of, lots of, plenty of, gobs of, some
DATA some, lots of, more than enough, a bunch of, loads of
DATA three, a dozen, twenty, a few, a couple of
DATA zillions of, two, six, seven, ten
DATA hundreds of, five, four, dozens of, eleven

'===========================
'  PRONOUNS AND ARTICLES
'===========================

DATA a,it,its,it,  an,it,its,it
DATA a,he,his,him,  an,he,his,him
DATA a,she,her,her,  an,she,her,her

'=================================
'  EXCLAMATIONS / INTERJECTIONS
'==================================

DATA "Dear me! ","Holy smokes! ","Dang it! "
DATA "Heck! " ,"Lordy! ", "Sheesh! "
DATA "Holy cow! ", "For Pete's sake! ", "Lord love a duck! "
DATA "Jumping Jehosaphat! ", "Holy Toledo! ", "For crying out loud! "
DATA "Sweet jumping Jesus! ", "Gosh! ", "Holy moley! "

DATA "Zowie! ", "For land's sake! ", "Dag nab it! "
DATA "Great Scott! ", "Golly! ", "Shoot! "
DATA "Gee whiz! " , "Criminy Christmas! ", "Hell's bells! "
DATA "Great Caesar's ghost! ", "Cripes! ", "Gee whilikers! "
DATA "Holy mackerel! ", "Goodness gracious! ", "Heavens to Betsy! "

'===============================
'  WHOLE PHRASES / "BRIDGES"
'===============================

DATA the thing is, so anyway
DATA anyway, now as I was about to say
DATA come to think of it, you know
DATA it might interest you to know, of course
DATA let me tell you, then again

DATA curiously enough, as I recall
DATA I should warn you, when you get right down to it
DATA funny thing , just between you and me
DATA if you ask me, seems to me
DATA oddly enough, strictly speaking

DATA why, to put it in a nutshell
DATA actually, seriously now
DATA the whole problem is, as a matter of fact

'=======================================
' WHOLE PHRASES / "INITIAL RESPONSES"
'=======================================

DATA "I guess so.", "You can say that again!"
DATA "Don't make me laugh!", "Whatever you say."
DATA "Are you kidding me?", "Sure thing."
DATA "If you insist.", "You must be pulling my leg."
DATA "If you say so.", "I suppose you could look at it like that."
DATA "You're telling me!", "I can't argue with you there."

'========================================
' WHOLE PHRASES / "AS ... AS"
'========================================

DATA "as good as all-get-out", "as slick as snot"
DATA "as fine as a gnat's eyelash", "as sweet as sunshine"
DATA "as nice as can be", "as easy as falling off a log"
DATA "as nice as pie", "as fine as frog's hair"
DATA "as simple as dirt", "as slick as a snake's belly"

'=======================================
'  WHOLE PHRASES  / PROVERBS
'=======================================

DATA "Rome wasn't built in a tray."
DATA "It's not whether you have warts, it's where."
DATA "No one kills mosquitos for the meat."
DATA "God didn't ask to be born, either."
DATA "A sharp pencil looks a lot like a dull one."
DATA "It's better to be bored stiff than stiff as a board."
DATA "Give me liberty or give me depth."
DATA "No one knows when tomorrow may come."
DATA "A new prune sweeps clean."
DATA "It's a long worm that has no turning."

DATA "Life isn't all whiney women and song."
DATA "A fool and his mommy are soon parted."
DATA "If you dress in the dark, stay there."
DATA "Be careful what you ask for: you might get it!"
DATA "There are two sides to every beef."

'============================
' NAMES / BOY'S
'============================

DATA Arnold, Vincent, Oliver, Junior, Buck
DATA Leo, Spencer, Barney, Ancil, Buddy
DATA Herbert, Killer, Harold, Bertram, Cyrus
DATA Tyler, Louis, Kyle, Virgil, Big Tom
DATA Horace, Happy, Rock, Tab, Slim

'============================
' NAMES / GIRL'S
'============================

DATA Gertrude, Doris, Matilda, Hilda, Sally
DATA Claudette, Ruthie, Zelda, Polly, Gretel
DATA Greta, Stella, Prudence, Hillary, Mazie Sue
DATA Lola, Portia, Tiffany, Louina, Winnie
DATA Rachel, Martha, Jane, Mona, Frannie
'===============================
'  PHRASES  / PASSAGE OF TIME
'===============================

DATA then, a little later, later, next, after that
DATA afterwards, a while later, the next day, all of a sudden, then

'================================
'  PHRASES  /DURATION OF TIME
'================================

DATA all day long, from dawn to dusk, for hours and hours
DATA as long as you please, darn near forever, until the cows come home
DATA from now to doomsday, forever, for days, until you say the word

'==============================
'  PHRASES / for EasyAnswer SUB
'==============================

DATA it's clear to me, i'm pretty sure, as far as I know
DATA of course, obviously, maybe


'==========================================================================
'    DATA USED TO EVALUATE USER RESPONSES
'==========================================================================

   'TEST VERBS

DATA is, was, do, did, does, might, must, are, has
DATA could, will, would, have, shall, should, were, can, am
DATA isn't, wasn't, don't, didn't, doesn't, mightn't, musn't, aren't, hasn't
DATA couldn't, won't, wouldn't, haven't, shan't, shouldn't, weren't, can't
DATA cannot, ain't

   'TEST PRONOUNS

DATA you, he, she, it, they, we, that, this, i

   'WHY/HOW

DATA why, how, when, where, who, what, whose

'   --- NOT-NOUNS ---

DATA not, you, she, they, was
DATA are, isn't, were, that, aren't
DATA will, won't, this, wasn't, it's
DATA that's, weren't, i'll, they're, i'm

'    -- PAD WORDS --

DATA oh, so, well, ok, but, now, just, maybe, perhaps, ah, and, or, since
DATA gee, claude, however, yes, no, then, all, please, then

       '------ TEXT IN MENU WINDOW -------

DATA " How To Start", " Editing Keys", " Useful Hints"
DATA " How To Print", " A Few Rules", " Exit Help"

           '--- HELP WINDOW TEXT ---

DATA "    Type your answer(s) or question(s) carefully."
DATA "    When you are done answering CLAUDE, press <ENTER> key."
DATA "    Your answer can't go past the end of the shaded line."
DATA "    Find out how to fix typing errors under EDITING KEYS."

DATA "   Use the <DEL> key to erase what's underneath the cursor."
DATA "   Use the <BACKSPACE> key to erase moving left."
DATA "   The <ARROW> keys move the cursor without erasing."
DATA "   <HOME> and <END> jump the cursor to the start or the end."

DATA "     ALWAYS put a question mark <?> after questions."
DATA "     Try to spell words the way Claude spells them."
DATA "     Type carefully and fix any mistakes you make."
DATA "     Don't tell CLAUDE `goodbye' unless you want to quit."

DATA "   F5 is a printing ON-OFF switch:  [] = ON and [ ] = OFF."
DATA "   Always turn your printer ON when F5 is ON."
DATA "   If CLAUDE finds a problem with your printer, it beeps."
DATA "   If you can't fix the problem, turn F5 OFF at once!"

DATA "    NO obscenity!  NO spitting on the floor!"
DATA "    NO talking with your mouth full!"
DATA "    NO nose-picking! But, you CAN make faces."
DATA "    Insults and smart-alec answers are allowed."

'==============================================
'  CANNED PHRASES USED IN RESPONSE-1ST-PART
'==============================================

   '--NoInput--

DATA "What's the matter? Cat got your tongue? I can't do all the talking around here by myself. "
DATA "Not talking, huh? That's not exactly fair to me, you know. "
DATA "Giving me the silent treatment, huh? I don't like that. "
DATA "You want me to talk while you just sit there, huh? Well it won't work. "
DATA "I refuse to sit here talking to myself. If this happens again I quit. "
DATA "No answer? Again?? Listen, look me up when you're ready to talk. Goodbye."

   '--Obscenity--

DATA "Hey! Stop using those filthy words or I'll get mad."
DATA "You've got one very foul mouth. Put a lid on it."
DATA "Give me a break and put a lid on that obscenity crap."
DATA "If you don't stop talking garbage I'm leaving. I mean it."
DATA "I'm not listening to any more filth. I QUIT !!"

   '--NoSense--

DATA "Let me have that again, OK? I can't make heads or tails out of what you said that time. "
DATA "Are you talking with your mouth full? Remember, that's against the rules. "
DATA "Whatever you're trying to say, I'll be hanged if I can figure it out. "
DATA "That was about as clear as mud to me. "
DATA "I'm not so sure I caught your drift that time. "

DATA "Could you translate that for me into plain English? "
DATA "I'll be honest with you. That sounded like nonsense to me. "
DATA "Say something I can understand! "
DATA "I'm trying as hard as I can, but I just don't catch what you're trying to say there. "
DATA "You're typing like there's grease on the keys or something. "

DATA "Do us both a favor and stick to plain English. I don't have a fancy education. "
DATA "Am I just dumb, or are there some serious misspellings in your last answer?"
DATA "Did they teach you to talk that way in school or did you make that up all by yourself?"
DATA "I hate it when you type with a hammer. "
DATA "I asked you not to let the dog type your answers with his nose. It gums up the keyboard something awful. "

   '---WhyHowQuery--

DATA "I never bothered to find out."
DATA "Why not?"
DATA "How should I know?"
DATA "About how you'd expect."
DATA "When? When pigs fly. That's when."
DATA "I don't keep track of such things. Sometime or other."
DATA "Oh, not far from my house."
DATA "You wouldn't know the place."
DATA "It was somebody. But I can't remember the name."
DATA "I can't say. Everyone looks pretty much alike to me."
DATA "Think about it."
DATA "Come on. What do you think?"
DATA "I never was too clear about that myself. Somebody, I guess."
DATA "Not mine, that's for sure. Beyond that I don't care."
DATA "Less than you might think."
DATA "More than you'll ever know."
DATA "Whole bunches and bunches."
DATA "I can't say exactly. But it would have to be a lot."
DATA "A very long time."
DATA "Longer than you might think."
DATA "Obviously, you don't!"
DATA "Did it ever occur to you that I might?"

    '-- Imperative Answers --

DATA "Try to make me!"
DATA "Not now. Maybe later."
DATA "I might, but only if you do it first."
DATA "No. I refuse to do any such thing."
DATA "I will, first thing tomorrow morning."
DATA "I don't have to. You're not my mother."

    '-- Resp2 Answers --

DATA "What can I say?"
DATA "Do you know what else?"
DATA "So what else is new?"
DATA "But I wouldn't want that to get out in public. OK?"
DATA "But that can be our little secret. Right?"

DATA "That reminds me of something."
DATA "But that's not the half of it."
DATA "But that's nothing. "
DATA "Anyhow, I have bigger fish to fry."
DATA "Anyway, I'll leave that for you to figure out."

DATA "Things could be worse, you know."
DATA "But I wouldn't worry about it if I were you."
DATA "Of course, it's all relative, you know."
DATA "However, I can't be bothered with that."
DATA "Actually, I make up a lot of this stuff."

DATA "But there's more to it than that."
DATA "That's all there is to it, really."
DATA "Guess what!"
DATA "But I wouldn't swear to it."
DATA "Then again, maybe I didn't hear you correctly."

DATA "But it doesn't make sense to dwell on it."
DATA "And it wouldn't take a genius to figure that out."

'  BYE-PHRASE

DATA "It's been swell talking with you."
DATA "I'll see you in the funny papers."
DATA "Don't take any wooden nickels."
DATA "Keep your nose clean and your powder dry."
DATA "Let's do this again some time real soon."

' ----------End Screen Message-----------

DATA ""
DATA "   CLAUDE was written in 1991 by Brian McLaughlin."
DATA "   It was released into the public domain in 1994. "

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'                        END OF DATA SECTION
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

REM $STATIC
'=========================
 FUNCTION AdC$ (Sent$)
'=========================
  'adds a comma to a string
 
 AdC$ = RTRIM$(Sent$) + ", "

END FUNCTION

'===============================
 FUNCTION AdP$ (Sent$)
'===============================
  'adds a period to a string
 
  AdP$ = RTRIM$(Sent$) + ". "

END FUNCTION

'========================
 FUNCTION AdQ$ (Sent$)
'========================
  'adds a question mark to a string
 
 AdQ$ = RTRIM$(Sent$) + "? "

END FUNCTION

'==================
 SUB AdvAnswer
'==================
   'this SUB isn't quite foolproof, but it works 98% of the time
   'it attempts to identify adverbs by their "ly" ending and to
   'convert them into their adjectival form, which is used in the answer

    Word$ = LCASE$(UserWords$(Adverb%))      'Adverb% is globally shared
    Adj$ = LEFT$(Word$, LEN(Word$) - 2)      'removes "ly"
   
    IF LEN(Adj$) < 3 THEN Adj$ = CHR$(34) + Word$ + CHR$(34)
    LastLet% = ASC(LCASE$(RIGHT$(Adj$, 1)))
   
   SELECT CASE LastLet%
     CASE 105                                          ' an "i"
         Adj$ = LEFT$(Adj$, LEN(Adj$) - 1) + "y"
     CASE 98                                           ' a "b"
        Adj$ = Adj$ + "le"
     CASE 117                                          ' a "u"
        Adj$ = Adj$ + "e"   'as in truly/true
   END SELECT
  
  Choice% = FNRndNum%(1, 4)
 
  SELECT CASE Choice%
   CASE 1
    Ans$ = AdQ$(Cap$(Word$)) + "There's nothing " + Adj$ + " about it! "
   CASE 2
    Ans$ = "OK, " + AdP$(UserName$) + "If you say it's " + Adj$ + " it must be. "
   CASE 3
    Ans$ = "It may be " + Adj$ + " to you, but not to me! "
   CASE 4
    GetOne% = FNRndNum%(1, PersonAdjDim%)
    TempAdj$ = RTRIM$(Adjective(GetOne%).Word)
    Ans$ = Cap$(Word$) + " you're " + TempAdj$ + ", too! That's as " + Adj$ + " as anything else. "
  END SELECT

   Response$(1) = Ans$

END SUB

'=========================
 FUNCTION AdX$ (Sent$)
'=========================
  'adds exclamation point to a string

 AdX$ = RTRIM$(Sent$) + "! "

END FUNCTION

'========================
 FUNCTION Answer1$
'========================

A1$ = Cap$(AdC$(Bridg$)) + AdC$(UserName$)
A2$ = "I took care of " + SbA$ + Sb$ + "when I was in " + AdP$(Plac$)

IF SbPair% THEN
   A3$ = "That pair of " + Sb$
ELSEIF SubHuman% THEN
   SELECT CASE PronArtCode%(SbNum%)
     CASE 3, 4
        Name$ = Man$
     CASE 5, 6
        Name$ = Woman$
   END SELECT
   A3$ = Cap$(SbPPro$) + "name was " + AdP$(Name$) + Cap$(SbPro$)
ELSE
   A3$ = Cap$(This$) + Sb$
END IF

A4$ = Was$ + SbAdj$ + And$ + "one day " + SbPro$ + AdP$(PWInfVb$ + ObPlur$)

   IF ObNum% > 0 AND ObNum% <= NDim% THEN
      CALL SetNewWords(ObNum%)
   ELSE
      CALL SetNewWords(SbNum%)
   END IF

A5$ = Cap$(TimPas$) + SbAmt$ + SbPlur$ + AdP$(PPastVb$ + ObAm$ + ObPlur$)
A6$ = "The whole thing " + Was$ + AdX$(Adjective(FNRndNum%(1, GenAdjDim%)).Word)

Answer1$ = A1$ + A2$ + A3$ + A4$ + A5$ + A6$

END FUNCTION

'=====================
 FUNCTION Answer10$
'=====================

 DO: IF NoOb% THEN CALL SetNewWords(FoundNoun%) ELSE EXIT DO
 LOOP

An1$ = "I heard " + That$ + ObPlur$ + "won't associate with " + AdP$(SbPlur$)
An2$ = "Then again, I heard " + SbPlur$ + Frq$ + AdP$(P3PerVb$ + ObPlur$)
An3$ = Cap$(AdC$(Bridg$)) + "that probably explains a lot!"

 Answer10$ = An1$ + An2$ + An3$

END FUNCTION

'========================
 FUNCTION Answer11$
'========================

 IF FoundNoun% > People% THEN EXIT FUNCTION
 CALL SetNewWords(1)   'this answer doesn't use Sb$: (1) sets words as human
 
 A1$ = "Once, when I was back in " + Plac$ + " I used to " + InfVb$ + ObPlur$
 A2$ = "and it was just " + AdP$(AsAs$)
 A3$ = "Did you ever do that, " + AdQ$(UserName$)

  AskedUser% = TRUE
  Answer11$ = A1$ + A2$ + A3$

END FUNCTION

'=========================
 FUNCTION Answer12$
'=========================

 IF FoundNoun% > People% THEN EXIT FUNCTION

  DO UNTIL SubHuman%
     CALL SetNewWords(0)
  LOOP

 A1$ = "Hmmm..." + AdQ$(UserName$) + AdQ$(UserName$) + "... Weren't you "
 A2$ = SbA$ + Sb$ + "back in " + AdQ$(Plac$)

 Answer12$ = A1$ + A2$
 AskedUser% = TRUE

END FUNCTION

'=========================
 FUNCTION Answer13$
'=========================

DO WHILE NoOb% = TRUE
  CALL SetNewWords(FoundNoun%)
LOOP

 IF R2Q% THEN Response$(2) = Nul$

 IF FoundNoun% THEN
   A$ = "Did "
 ELSE
   A$ = "Hey, " + AdC$(UserName$) + "did "
 END IF

 IF ObNum% > Locations% THEN the$ = Nul$ ELSE the$ = "the "

 A1$ = "you know that the " + SbCmp$ + SbA$ + Sb$ + "is when " + SbPro$ + S3PerVb$
 A2$ = ObA$ + RTRIM$(Ob$) + ", the " + ObCmp$ + the$ + Ob$ + "becomes?"

 AskedUser% = TRUE
 Answer13$ = A$ + A1$ + A2$

END FUNCTION

'========================
 FUNCTION Answer14$
'========================

 IF FoundNoun% THEN EXIT FUNCTION               'since this won't use a Sb$
 IF SubHuman% = FALSE THEN CALL SetNewWords(1)  'now, force a human subject

 A1$ = "You know, " + AdC$(UserName$) + "I just can't "
 A2$ = InfVb$ + ObPlur$ + "like I used to. "
 A3$ = "But, it was fun while it lasted!"

 Answer14$ = A1$ + A2$ + A3$

END FUNCTION

'========================
 FUNCTION Answer15$
'========================

IF FoundNoun% THEN
   EXIT FUNCTION
ELSEIF NoOb% = TRUE OR SubHuman% = FALSE THEN
   Choice% = FNRndNum%(1, People%)
      DO: CALL SetNewWords(Choice%)
      LOOP WHILE NoOb% = TRUE
END IF

IF R2Q% THEN Response$(2) = Nul$

A1$ = RTRIM$(Resp2(2).Word) + " Every time I try to " + InfVb$ + SbA$
A2$ = AdC$(Sb$) + SbPro$ + "won't let me! I don't know why."

Answer15$ = A1$ + A2$

END FUNCTION

'=======================
 FUNCTION Answer16$
'=======================

IF NoOb% = TRUE THEN
   DO: CALL SetNewWords(FoundNoun%)
   LOOP WHILE NoOb% = TRUE
END IF

A1$ = "I heard that when " + SbA$ + AdC$(Sb$ + S3PerVb$ + ObA$ + Ob$)
A2$ = "the " + Ob$ + "becomes " + Int$ + AdP$(ObAdj$)

Answer16$ = A1$ + A2$

END FUNCTION

'=======================
 FUNCTION Answer17$
'=======================

Answer17$ = "To " + AdC$(InfVb$ + ObPlur$) + SbA$ + Sb$ + "must be " + AdP$(SbAdj$)

END FUNCTION

'========================
 FUNCTION Answer18$
'========================

 IF FoundNoun% THEN EXIT FUNCTION               'since this won't use Sb$
 IF SubHuman% = FALSE THEN CALL SetNewWords(1)  'force a human subject

 A1$ = "I " + AdC$(PPerfVb$ + ObPlur$) + "but I never once "

    CALL ChooseVb(SbNum%)

 A2$ = AdP$(PPerfVb$ + ObA$ + Ob$) + "Now, I kind of regret it."

 Answer18$ = A1$ + A2$

END FUNCTION

'=====================
 FUNCTION Answer19$
'=====================

 IF FoundNoun% THEN EXIT FUNCTION

 Choice% = FNRndNum%(People% + 1, Animals%)

 DO: CALL SetNewWords(Choice%)
 LOOP WHILE NoOb% = TRUE

 A1$ = "I used to have " + SbA$ + Sb$ + "named " + AdP$(Man$)
 A2$ = AdC$("The trouble was") + Man$ + Was$ + Int$ + SbAdj$ + "and only a bit "
 A3$ = ObCmp$ + "than " + AdP$(ObA$ + Ob$) + Cap$(Bridg$) + Man$ + "died a long time ago."

 Answer19$ = A1$ + A2$ + A3$

END FUNCTION

'=======================
 FUNCTION Answer2$
'=======================

Answer2$ = Cap$(SbEvry$) + Sb$ + S3PerVb$ + ObA$ + Ob$ + "sometime. "

END FUNCTION

'======================
 FUNCTION Answer20$
'======================

IF FoundNoun% THEN EXIT FUNCTION   'no Sb$ used here
CALL SetNewWords(1)                'force a "human subject" set of words

Answer20$ = "I hope you don't mind my asking, " + AdC$(UserName$) + "but have you ever " + AdQ$(PPerfVb$ + ObA$ + Ob$)
AskedUser% = TRUE

END FUNCTION

'======================
 FUNCTION Answer21$
'======================

Answer21$ = "I think " + SbPlur$ + SbAre$ + Int$ + AdC$(SbAdj$) + "don't you?"
AskedUser% = TRUE

END FUNCTION

'====================
 FUNCTION Answer22$
'====================

A1$ = AdC$(Cap$(Bridg$)) + SbA$ + Sb$ + "can't ever be " + SbCmp$ + "than "
 
 CALL SetNewWords(0)

A2$ = SbA$ + Sb$ + "is " + AdP$(SbAdj$)

 Answer22$ = A1$ + A2$

END FUNCTION

'====================
 FUNCTION Answer23$
'====================

 IF FoundNoun% THEN
    IF FoundNoun% < Clothes% + 1 OR FoundNoun% > Potables% THEN EXIT FUNCTION
 ELSE
    CALL SetNewWords(FNRndNum%(Clothes% + 1, Potables%))
 END IF

 A1$ = "I sure do love " + AdX$(SbPlur$) + "Just give me some " + SbPlur$ + "and I can "
   CALL SetNewWords(1)
 A2$ = InfVb$ + ObPlur$ + AdP$(TimDur$)

 Answer23$ = A1$ + A2$

END FUNCTION

'======================
 FUNCTION Answer24$
'======================

IF SbCollect% THEN Them$ = "it" ELSE Them$ = "them"
Rel$ = Nouns$(FNRndNum%(6, 27))

Answer24$ = "Some " + SbPlur$ + "might want to " + AdC$(InfVb$ + ObA$ + Ob$) + "but I'll be damned if I'll let " + AdX$(Them$) + "Not after what " + SbA$ + Sb$ + "did to my " + AdX$(Rel$)

END FUNCTION

'=====================
 FUNCTION Answer25$
'=====================

A1$ = Cap$(Bridg$) + "I " + AuxNeg$ + "ever do anything to harm " + SbA$ + AdP$(Sb$)
A2$ = Cap$(SbThey$) + SbAre$ + "so gosh-darned " + AdX$(SbAdj$)

Answer25$ = A1$ + A2$

END FUNCTION

'=========================
 FUNCTION Answer3$
'=========================

 A1$ = "I like " + SbA$ + Sb$ + SbWho$ + Frq$ + AdP$(S3PerVb$ + ObPlur$)
     
      IF ObNum% AND ObNum% <= NDim% THEN
         CALL SetNewWords(ObNum%)
         A2$ = "However, " + SbPlur$ + SbAre$ + Int$ + AdP$(SbAdj$)
      ELSE
         A2$ = Nul$
      END IF

  Answer3$ = A1$ + A2$

END FUNCTION

'========================
 FUNCTION Answer4$
'========================
  IF PronArtCode%(SbNum%) = 7 THEN EXIT FUNCTION 'it's a collective noun
 
  A1$ = Cap$(SbPlur$) + "find " + That$ + IngVb$ + ObPlur$
  A2$ = Is$ + SbCmp$ + "than "
     
      CALL ChooseVb(SbNum%)
 
  A3$ = AdP$(IngVb$ + ObAm$ + ObPlur$)
 
  Answer4$ = A1$ + A2$ + A3$

END FUNCTION

'=====================
 FUNCTION Answer5$
'=====================
  
   A1$ = "I knew " + SbA$ + Sb$ + "from " + Plac$ + SbWho$
   A2$ = AdP$(PWInfVb$ + ObA$ + Ob$)
   A3$ = AdP$(Cap$(SbPro$) + Was$ + SbAdj$)

   Answer5$ = A1$ + A2$ + A3$

END FUNCTION

'=======================
 FUNCTION Answer6$
'=======================

 A1$ = Cap$(SbA$ + Sb$) + "can " + AdP$(InfVb$ + ObA$ + Ob$)
    CALL ChooseVb(SbNum%)
 A2$ = Cap$(But$) + SbPro$ + "could just as easily " + AdX$(InfVb$ + ObPlur$)

 Answer6$ = A1$ + A2$

END FUNCTION

'=========================
 FUNCTION Answer7$
'=========================
 
  IF FoundNoun% > 0 AND SubHuman% = FALSE THEN
      EXIT FUNCTION
  ELSEIF SubHuman% = FALSE THEN      'if Sb$ isn't human, get new words
      DO: CALL SetNewWords(FoundNoun%)
      LOOP UNTIL SubHuman% = TRUE
  END IF
 
  A1$ = "I once knew " + SbA$ + Sb$ + "from " + Plac$ + SbWho$
     
      IF NoOb% OR Verb% = 0 THEN
          DO: CALL ChooseVb(SbNum%)
          LOOP WHILE NoOb% = TRUE OR Verb% = 0
      END IF
 
  A2$ = SPastVb$ + ObAm$ + ObPlur$
     
      DO: CALL ChooseOb(Verb%)
      LOOP WHILE NoOb%
 
  A3$ = And$ + ObAm$ + AdP$(ObPlur$)

  Answer7$ = A1$ + A2$ + A3$

END FUNCTION

'=========================
 FUNCTION Answer8$
'=========================
 
  IF FoundNoun% THEN EXIT FUNCTION
  Rel% = FNRndNum%(6, 27)    'a relative or associate
  CALL SetNewWords(Rel%)   'gets random words, Rel% is subject

 A1$ = "My " + Sb$ + AdP$(PWInfVb$ + ObPlur$)
 A2$ = "That's probably because " + SbPro$ + Was$ + AdP$(SbAdj$)
 A3$ = "The last I heard " + SbPro$ + "had moved to " + Plac$ + "and "

     CALL ChooseVb(Rel%)

 A4$ = Was$ + AdP$(IngVb$ + ObA$ + Ob$) + "But, it's like they say: "
 A5$ = Prov$

  Answer8$ = A1$ + A2$ + A3$ + A4$ + A5$
 
END FUNCTION

'=======================
 FUNCTION Answer9$
'=======================
 
A1$ = "People say " + SbPlur$ + AuxNeg$ + AdP$(RTRIM$(InfVb$ + ObPlur$))
A2$ = Cap$(But$) + "I bet " + SbThey$ + "could, if " + SbThey$ + "tried. "

 Answer9$ = A1$ + A2$

END FUNCTION

'=========================
 SUB BadHearing
'=========================
  'simulates Claude garbling what he hears

User$ = RTRIM$(UCASE$(UserInput$))
Original$ = "BFIKLMOSTV"
Switch$ = "PHECRNUZDW"

FOR A% = 1 TO LEN(Switch$)
  FOR C% = 1 TO 3                 'replaces the first 3 instances of a letter
   Count% = INSTR(User$, MID$(Original$, A%, 1))
      IF Count% = 0 THEN EXIT FOR    'exit inside loop
        NewChar$ = MID$(Switch$, A%, 1)
        MID$(User$, Count%, 1) = NewChar$
  NEXT C%
NEXT A%

Last% = ASC(RIGHT$(User$, 1))

IF Last% = 46 OR Last% = 33 OR Last% = 63 THEN   'period/ ex-mark/ ques-mark
   User$ = LEFT$(User$, LEN(User$) - 1)          'remove it
END IF

Response$(1) = AdX$(AdQ$("My hearing aid must be on the fritz again. It sounded like you said " + Q$ + User$))
AllRespMade% = TRUE   'flags CLAUDE to skip remaining response procedures

END SUB

'======================
 SUB BreakUp
'======================
   'this SUB breaks up User Input into "words" then tests each word.
  
 IF LEN(RTRIM$(UserInput$)) = 0 THEN   'no user input
   NoInput% = TRUE: EXIT SUB           'go no further
 END IF

 IF LEN(UserInput$) = 1 THEN           'only one character
   NoSense% = TRUE: EXIT SUB           'makes no sense, so exit
 END IF

 IF INSTR(LCASE$(UserInput$), "bye") THEN CALL SayBye  'user said goodbye

 CALL TestObscenity(UserInput$)        'next, test for obscenity
   IF Obscene% THEN EXIT SUB           'if it's there, exit

 Place% = 1
 Delimiters$ = " ,.;?!:()" + CHR$(34)
 Token$ = StrTok$(UserInput$, Delimiters$)

DO
   IF Place% > MaxUser% THEN           'more than 27 "words" in 79 keypresses
     NoSense% = TRUE: EXIT SUB         'probably not meaningful speech
   END IF
  
   UserWords$(Place%) = Token$

   IF LEN(Token$) > 18 THEN            'e.g. bigger than "conversationalists"
     NoSense% = TRUE: EXIT DO          'assume it's a nonsense word
   END IF
  
   IF ASC(Token$) > 47 AND ASC(Token$) < 58 THEN  'word starts with a number
      Count% = Count% + 1
      Word$ = Token$                     'make a copy
      NotNumber% = EvalNum%(Word$)       'function works on a COPY of Token$
        IF NotNumber% THEN               '  so it doesn't alter the original
           NoSense% = TRUE: EXIT DO      'it was mixed numeric/alphabetic
        ELSE                             'or, it was a number, so
           NonSense$ = Token$            'save it, in case of later need
           GOTO JumpAhead                'bypass the upcoming tests
        END IF                           'they don't work with numeric input
   END IF

   CALL TestVowelRatio(Token$)           'find ratio of vowels to consonants
      IF NoSense% THEN EXIT DO

JumpAhead:
   Place% = Place% + 1                   'increment place in UserWords$()
   Token$ = StrTok$(Nul$, Delimiters$)   'fetch next token (word)
LOOP WHILE LEN(Token$) > 0

IF UserWords$(Count% + 1) = Nul$ THEN NoSense% = TRUE

IF NoSense% THEN
 IF LEN(NonSense$) > 0 AND LEN(Token$) = 0 THEN EXIT SUB ELSE NonSense$ = Token$
END IF

END SUB

'===================
 SUB BreakUpLast (LastSent%)
'===================
  'breaks up last sentance into words; places words into LastWords() array
  'like BreakUp, but without branching into tests for nonsense or obscenity.
  'since all these words have already been tested before

 Delimiters$ = " ,.;?!:()" + CHR$(34)
 Place% = 1
 Token$ = StrTok$(EachSent$(LastSent%), Delimiters$)
 LastWords$(Place%) = Token$

   DO UNTIL LEN(Token$) = 0
      Place% = Place% + 1
      Token$ = StrTok$(Nul$, Delimiters$)
      LastWords$(Place%) = Token$
   LOOP

END SUB

'===================================
 FUNCTION Cap$ (Word$)
'===================================
   'Capitalizes the first letter of a string, if it isn't already capital
 
   IF LEN(Word$) < 2 THEN
      OutPut$ = UCASE$(Word$)
   ELSE
      Chopword$ = RIGHT$(Word$, (LEN(Word$) - 1))
      CapLetter$ = UCASE$(LEFT$(Word$, 1))
      OutPut$ = CapLetter$ + Chopword$
   END IF
  
   Cap$ = OutPut$

END FUNCTION

'=================
 SUB CheckAdj
'=================
  'this SUB finds out whether the user used an adjective Claude knows --
  'but it only checks the final sentance of user's input;
  'this differs from AdvAnswer in that it checks directly against CLAUDE's
  'own adjective-list, rather than guessing at the adjective involved

FOR Count% = 1 TO MaxUser%
    AdjWord$ = LCASE$(UserWords$(Count%))
       IF AdjWord$ = Nul$ THEN EXIT SUB
    FOR Count2% = 1 TO AdjDim%
      IF ASC(AdjWord$) = ASC(Adjective(Count2%).Word) THEN
         IF LEN(AdjWord$) = LEN(RTRIM$(Adjective(Count2%).Word)) THEN
            IF AdjWord$ = RTRIM$(Adjective(Count2%).Word) THEN GOTO OutaLoop
         END IF
      END IF
    NEXT Count2%
NEXT Count%

OutaLoop:
 
Response$(1) = "Whether something is " + AdjWord$ + " or not is purely a matter of opinion. "
  
END SUB

'===============================
 SUB ChooseOb (VNum%)
'=============================== 
 'sets which noun will be used as the verb's object, along with
 'all the words that will be associated with that object

 CALL NullOb                       'resets object variables to null strings

 REM Any object-variables not specifically given a value, will remain null

 DO
  ObCode% = VbObjCode%(VNum%)      'get the code that determines Object-type
    IF ObCode% THEN                'an object is required
       ObNum% = GetObject%(ObCode%)  'so, get one with GetObject FUNCTION
    ELSE                           'no object is required (ObCode = 0)
       NoOb% = TRUE                'set this flag
       EXIT SUB                    'cuz ob-variables are already set to null
    END IF
 LOOP WHILE ObNum% = SbNum%        'loop if object the same as subject

 IF ObNum% = NDim% + 1 THEN        'a gerund was requested as object
     NoOb% = TRUE                  'since a gerund is not a noun
     Ob$ = GetGerund$(SbNum%)      'assign a gerund to Ob$
     ObPlur$ = Ob$                 'gerunds have no plurals
     ObAre$ = Is$
     ObWere$ = Was$
     ObThey$ = "it "               'everything else stays null
 ELSE                              'a noun was chosen as the object
     NoOb% = FALSE                 'set flag to say so
     Ob$ = Nouns$(ObNum%) + Spac$  'assign noun to Ob$
     ObPlur$ = Plur$(ObNum%)       'get the plural
     ObAdj$ = GetAdj$(ObNum%)      'get the adjective
     ObCmp$ = GetCmpAdj$(Adject%)  'get comparative (Adject% set in GetAdj$)
     ObSup$ = GetSupAdj$(Adject%)  'get the superlative
     ObThey$ = They$               'this changes when ObProCode% is 0 or 7
     ObProCode% = PronArtCode%(ObNum%)   'a pronoun/article code number 0-8
      
       SELECT CASE ObProCode%
         CASE 1 TO 6                                   'it,he,she
            ObAm$ = RTRIM$(NumberAmount(FNRndNum%(1, AmDim%)).Word) + Spac$
            ObA$ = PronArt$(ObProCode%, 1) + Spac$     'a/an
            ObPro$ = PronArt$(ObProCode%, 2) + Spac$   'he/she
            ObPPro$ = PronArt$(ObProCode%, 3) + Spac$  'his/her
            ObAPro$ = PronArt$(ObProCode%, 4) + Spac$  'him/her
            ObAre$ = Are$
            ObWere$ = Were$
         CASE 7                                        'collective nouns
            ObAm$ = RTRIM$(NumberAmount(FNRndNum%(1, 10)).Word) + Spac$
            ObPro$ = PronArt$(1, 2) + Spac$            'it
            ObPPro$ = PronArt$(1, 3) + Spac$           'its
            ObAPro$ = ObPro$                           'it
            ObAre$ = Is$                               'is
            ObWere$ = Was$                             'was
            ObThey$ = ObPro$                           'it
         CASE 8                                        'paired nouns
            ObA$ = "a pair of "
            ObAm$ = RTRIM$(NumberAmount(FNRndNum%(1, 10)).Word) + Spac$
            ObPro$ = PronArt$(1, 2) + Spac$            'it
            ObPPro$ = PronArt$(1, 3) + Spac$           'its
            ObAPro$ = ObPro$                           'it
            ObAre$ = Are$
            ObWere$ = Were$
         CASE 0                                        'a city name
            ObPro$ = PronArt$(1, 2) + Spac$            'it
            ObPPro$ = PronArt$(1, 3) + Spac$           'its
            ObAPro$ = ObPro$                           'it
            ObAre$ = Is$
            ObWere$ = Was$
            ObThey$ = ObPro$                           'it
       END SELECT
 END IF
END SUB

'======================
 SUB ChooseOther
'======================
  'resets all auxilliary words and phrases, randomly

  Frq$ = RTRIM$(Frequency(FNRndNum%(1, FrqDim%)).Word) + Spac$
  Int$ = RTRIM$(Intensifier(FNRndNum%(1, IntDim%)).Word) + Spac$
  Exclam$ = RTRIM$(Exclamation(FNRndNum%(1, ExDim%)).Word) + Spac$
  Plac$ = Nouns$(FNRndNum%(Locations% + 1, Cities%)) + Spac$
  Man$ = RTRIM$(BoyName(FNRndNum%(1, BoyDim%)).Word) + Spac$
  Woman$ = RTRIM$(GirlName(FNRndNum%(1, GirlDim%)).Word) + Spac$
  Bridg$ = RTRIM$(Bridge(FNRndNum%(1, BrdgDim%)).Word) + Spac$
  Prov$ = RTRIM$(Proverb(FNRndNum%(1, ProvDim%)).Word) + Spac$
  TimPas$ = RTRIM$(TimePass(FNRndNum%(1, TimePassDim%)).Word) + Spac$
  TimDur$ = RTRIM$(TimeDur(FNRndNum%(1, TimeDurDim%)).Word) + Spac$
  AsAs$ = RTRIM$(AsPhrase(FNRndNum%(1, AsDim%)).Word) + Spac$

END SUB

'==============================
 SUB ChooseSb (NNum%)
'==============================
  'This SUB takes care of all the details of choosing a subject noun
  'and calls a routine to choose the other words associated with that subject
  
STATIC Repeat%  'tracks consecutive repetitions of NNum%

  Determine! = RND

  IF NNum% > 0 AND Repeat% < 7 THEN     'a non-random subject
      SbNum% = NNum%
      Repeat% = Repeat% + 1             'keep track of repetitions
  ELSEIF Determine! < .75 THEN
      SbNum% = FNRndNum%(1, People%)
      Repeat% = 0
  ELSEIF Determine! < .9 THEN
      SbNum% = FNRndNum%(1, Animals%)
      Repeat% = 0
  ELSE
      SbNum% = FNRndNum%(1, NDim%)   'locations and cities included
      Repeat% = 0
  END IF

  CALL ChooseSbWords(SbNum%)  'sets all the auxilliary words for Sb$

  IF SbNum% <= People% THEN SubHuman% = TRUE  'sets a flag used elsewhere

END SUB

'=====================
 SUB ChooseSbWords (Num%)
'=====================
  
  Sb$ = Nouns$(Num%) + Spac$
  SbPlur$ = Plur$(Num%)
  SbProCode% = PronArtCode%(Num%)  'code for pronoun/article (0-8)
  SbAdj$ = GetAdj$(Num%)
  SbCmp$ = GetCmpAdj$(Adject%)
  SbSup$ = GetSupAdj$(Adject%)
  SbThey$ = They$
  SbEvry$ = "every "
  SbCollect% = FALSE
  SbPair% = FALSE
 
 SELECT CASE SbProCode%
     CASE 0         'a proper noun (city name)
        SbAmt$ = Nul$
        SbA$ = Nul$
        SbPro$ = PronArt$(1, 2) + Spac$   'it
        SbPPro$ = PronArt$(1, 3) + Spac$  'its
        SbAPro$ = SbPro$
        SbWho$ = That$
        SbAre$ = Is$
        SbWere$ = Was$
        SbThey$ = "it "
        SbEvry$ = Nul$
     CASE 1, 2      'a neuter noun
        SbAmt$ = RTRIM$(NumberAmount(FNRndNum%(1, AmDim%)).Word) + Spac$
        SbA$ = PronArt$(SbProCode%, 1) + Spac$        'a/an
        SbPro$ = PronArt$(SbProCode%, 2) + Spac$      'it
        SbPPro$ = PronArt$(SbProCode%, 3) + Spac$     'its
        SbAPro$ = PronArt$(SbProCode%, 4) + Spac$     'it
        SbWho$ = That$
        SbAre$ = Are$
        SbWere$ = Were$
     CASE 3, 4, 5, 6    'a masculine/feminine noun
        SbAmt$ = RTRIM$(NumberAmount(FNRndNum%(1, AmDim%)).Word) + Spac$
        SbA$ = PronArt$(SbProCode%, 1) + Spac$        'a/an
        SbPro$ = PronArt$(SbProCode%, 2) + Spac$      'he/she
        SbPPro$ = PronArt$(SbProCode%, 3) + Spac$     'his/her
        SbAPro$ = PronArt$(SbProCode%, 4) + Spac$     'him/her
        SbWho$ = "who "
        SbAre$ = Are$
        SbWere$ = Were$
     CASE 7           ' a collective noun
        SbAmt$ = RTRIM$(NumberAmount(FNRndNum%(1, 10)).Word) + Spac$
        SbA$ = Nul$
        SbPro$ = PronArt$(1, 2) + Spac$   'it
        SbPPro$ = PronArt$(1, 3) + Spac$  'its
        SbAPro$ = SbPro$
        SbWho$ = That$
        SbAre$ = Is$
        SbWere$ = Was$
        SbThey$ = "it "
        SbEvry$ = "all "
        SbCollect% = TRUE
     CASE 8          ' a paired noun (e.g. shoes, scissors)
        SbAmt$ = RTRIM$(NumberAmount(FNRndNum%(1, AmDim%)).Word) + " pairs of "
        SbA$ = "a pair of "
        SbPro$ = PronArt$(1, 2) + Spac$   'it
        SbPPro$ = PronArt$(1, 3) + Spac$  'its
        SbAPro$ = SbPro$
        SbWho$ = That$
        SbAre$ = Are$
        SbWere$ = Were$
        SbEvry$ = "every pair of "
        SbPair% = TRUE
 END SELECT

END SUB

'===============================
 SUB ChooseVb (Subj%)
'===============================

STATIC Last%
IF Last% = 0 THEN Last% = VbDim% + 1  'last verb was passive (or nothing)
                                      ' by using VbDim% + 1, it assures
                                      ' no conflicts w/ other variables

SbCode% = PronArtCode%(Subj%)  'get code for Subject's pronoun/article (0-8)

DO
  Verb% = GetVerb%(Subj%)      'get a verb suited to Subject
LOOP WHILE Verb% = Last%       'but don't repeat the last one

  IF Verb% = 0 THEN            'if it's a passive verb
     Adj$ = GetAdj$(Subj%)     'go get an adjective to couple with "is"
     InfVb$ = "be " + Adj$
     IngVb$ = "being " + Adj$
     SbAdj$ = GetAdj$(Subj%)
     SPresVb$ = Is$ + Adj$
     SPastVb$ = Was$ + Adj$
     S3PerVb$ = SPresVb$
     PPerfVb$ = "have been " + Adj$
        IF SbCode% = 7 OR SbCode% = 0 THEN   'collective nouns or cities
           PPresVb$ = SPresVb$
           PPastVb$ = SPastVb$
           P3PerVb$ = SPresVb$
        ELSE                                 'other nouns
           PPresVb$ = Are$ + Adj$
           PPastVb$ = Were$ + Adj$
           P3PerVb$ = PPresVb$
        END IF
  ELSE
    SELECT CASE RTRIM$(VbInsep(Verb%).Word)
     CASE Nul$
       InfVb$ = RTRIM$(VbInfin(Verb%).Word) + Spac$
     CASE ELSE
       InfVb$ = RTRIM$(VbInfin(Verb%).Word) + Spac$ + RTRIM$(VbInsep(Verb%).Word) + Spac$
    END SELECT
    
    SPresVb$ = InfVb$
    PPresVb$ = InfVb$
    SPastVb$ = GetPast$(Verb%)
    PPastVb$ = SPastVb$
    PPerfVb$ = GetPastPerf$(Verb%)
    S3PerVb$ = Get3rdPerson$(Verb%)
      IF SbCode% = 7 THEN P3PerVb$ = S3PerVb$ ELSE P3PerVb$ = InfVb$
    IngVb$ = GetIng$(Verb%)
  END IF

'=========================
'   AUXILLIARY VERBS
'=========================
 ChooseWinf% = FNRndNum%(1, WInfinDim%)
 WInfVb$ = RTRIM$(WInfinitive(ChooseWinf%).Word) + Spac$ + "to " + InfVb$
 PWInfVb$ = RTRIM$(WInfinitivePast(ChooseWinf%).Word) + Spac$ + "to " + InfVb$

 ChooseAux% = FNRndNum%(1, 6)
 AuxVb$ = RTRIM$(AuxilliaryVb(ChooseAux%).Word) + Spac$
 AuxNeg$ = RTRIM$(AuxilliaryVb(ChooseAux% + 6).Word) + Spac$

'===========================
'  CHOOSING AN OBJECT
'===========================

IF Verb% THEN          'if was verb not passive
   Last% = Verb%       'then record it to prevent repeating it on next call
ELSE                   'but, if last verb was passive
   CALL NullOb         'make sure all object variables are nulled out
   EXIT SUB            'and bail out before ChooseOb SUB is called, below
END IF

CALL ChooseOb(Verb%)

END SUB

'===================
 SUB ColorMenu
'===================
 
 CLS
     FOR Count% = 1 TO ColorDim%
         PRINT RTRIM$(SetColorMenu(Count%).Word)
     NEXT Count%

 LOCATE 13, 1
 PRINT " To select current color, press <ENTER>.": PRINT

DO
  Choice% = Choice% + 1
  SELECT CASE Choice%
    CASE 1
      PRINT " Current foreground is Blue (1)."
      Fore% = GetColor%(Choice%, Fore%)
    CASE 2
      PRINT " Current background is White (7)."
      Back% = GetColor%(Choice%, Back%)
      IF Fore% = Back% THEN
         Choice% = Choice% - 1
         BEEP
      END IF
    CASE 3
      PRINT " Current Menu foreground is Black (0)."
      MenuFore% = GetColor%(Choice%, MenuFore%)
    CASE 4
      PRINT " Current Menu background is Light Red (12)."
      MenuBack% = GetColor%(Choice%, MenuBack%)
      IF MenuFore% = MenuBack% THEN
         Choice% = Choice% - 1
         BEEP
      END IF
    CASE 5
      PRINT " Current Help foreground is Black (0).      "
      HelpFore% = GetColor%(Choice%, HelpFore%)
    CASE 6
      PRINT " Current Help background is White (7)."
      HelpBack% = GetColor%(Choice%, HelpBack%)
      IF HelpFore% = HelpBack% THEN
         Choice% = Choice% - 1
         BEEP
      END IF
  END SELECT
  IF Choice% = 6 THEN EXIT SUB
LOOP

END SUB

'===================
 SUB Distract
'===================
  'like its name, this SUB gives distracted/distracting answers

 STATIC Last%        'prevents having the same answer twice in a row

DO
  Choice% = FNRndNum%(1, 12)
LOOP WHILE Choice% = Last%

SELECT CASE Choice%
   CASE 1
      A$ = "You must be awfully clever to say a thing like that! "
   CASE 2
      PRINT : IF Lpt% THEN LPRINT
       FOR Sneeze% = 1 TO 3
         SN$ = "ACHOOOO!      "
         PRINT SN$; : IF Lpt% THEN LPRINT SN$; : SLEEP 1
       NEXT Sneeze%
      PRINT : IF Lpt% THEN LPRINT
      A$ = "I'm sorry, " + AdP$(UserName$) + "Now I forgot what you said. "
   CASE 3
      CALL Phone
      Ex$ = "Excuse me, the phone's ringing."
      CALL WrapPrint(Ex$)
      SLEEP 2
      GetAnswer% = FNRndNum%(1, 3)
          SELECT CASE GetAnswer%
            CASE 1
              A$ = "Just a wrong number. "
              NoResp2% = TRUE
            CASE 2
              A$ = "It was for you. I told them to call back later. "
            CASE 3
              A$ = "It was some kind of opinion poll. I was undecided. "
          END SELECT
    CASE 4
      CALL DoorKnock
      Rx$ = "Excuse me, somebody's at the door."
      CALL WrapPrint(Rx$)
      SLEEP 3
      GetAnswer% = FNRndNum%(1, 3)
         SELECT CASE GetAnswer%
            CASE 1
              A$ = "Just a guy selling encyclopedias. "
            CASE 2
              A$ = "It was your mom. I told her to come back later. "
            CASE 3
              A$ = "That's really weird. I didn't order a pizza!! "
              AllRespMade% = TRUE
          END SELECT
    CASE 5
      Sx$ = "Excuse me, I'll be right back."
      CALL WrapPrint(Sx$)
      SLEEP 2
      A$ = "Ahhh. That's better. So what we were talking about? I forgot. "
      AllRespMade% = TRUE
    CASE 6
      A$ = "You're so smart, " + AdX$(UserName$) + "I never say any good stuff like that. "
    CASE 7
      Hx$ = "Hey! Wait a sec! What's that hanging off your nose??"
      CALL WrapPrint(Hx$)
      SLEEP 3
      A$ = "Just kidding! HA! HA! "
      NoResp2% = TRUE
    CASE 8
      Ox$ = "Excuse me. My head itches like crazy!"
      CALL WrapPrint(Ox$)
      SLEEP 2
      A$ = "Dang it! Now I can't remember what we were talking about. "
    CASE 9
      A$ = Exclam$ + "That's incredible! Did you think it up all by yourself? "
      AllRespMade% = TRUE
      AskedUser% = TRUE
    CASE 10
      A$ = "That's a perfectly wonderful thing to say, " + AdP$(UserName$)
    CASE 11
      A$ = "I take my hat off to you. It's rare to meet someone as imaginative and eloquent as you. "
    CASE 12
      A$ = "That, and a token, will get you a ride on the bus. "
END SELECT
  
   Last% = Choice%
   Response$(1) = A$

END SUB

'=================
 SUB DoorKnock
'=================
     'soundeffects -- vaguely like knocking on a door

 IF INSTR(COMMAND$, "Q") THEN EXIT SUB   '/quiet option on the command line?

 FOR X% = 1 TO 3
   SOUND 400, .1
   SOUND 80, .2
   SOUND 37, .3
      K = TIMER
      DO: J = TIMER: LOOP UNTIL J - K > .35  'puts a pause between knocks
 NEXT

END SUB

'========================================
 SUB EasyAnswer (FirstWord$, NextWord$)
'========================================
  'makes answers for questions starting "are you"/"was that"/"can I",  etc.
  'answers follow the model of "you are"/"it was not"/"you can",  etc.

SELECT CASE NextWord$
   CASE "that", "this"
       NextWord$ = "it"
   CASE "you"
       NextWord$ = "I"
           IF FirstWord$ = RTRIM$(Are$) THEN
                FirstWord$ = "am"
           ELSEIF FirstWord$ = "aren't" THEN
                FirstWord$ = "am not"
           END IF
   CASE "i"
       NextWord$ = "you"
           IF FirstWord$ = "am" THEN FirstWord$ = RTRIM$(Are$)
END SELECT

   A$ = NextWord$ + Spac$ + FirstWord$
   Num! = RND
 
  IF INSTR(A$, "n't") > 0 AND Num! > .6 THEN
     A$ = LEFT$(A$, LEN(A$) - 3)              'removes n't
  ELSEIF INSTR(A$, "n't") = 0 AND INSTR(A$, "not") = 0 AND Num! > .6 THEN
     A$ = A$ + " not"
  END IF

  Value% = FNRndNum%(1, EZPhraseDim%)
  Phras$ = Cap$(RTRIM$(EZPhrase(Value%).Word)) + Spac$

  A$ = Phras$ + A$
  Response$(1) = Cap$(AdP$(A$))

END SUB

'==========================
 SUB EchoBigWord (BigWord$)
'==========================
  'creates an answer based on the longest word in user input

IF LEN(BigWord$) > 10 THEN
  A$ = AdX$(Cap$(BigWord$)) + AdQ$("You're quite the genius today, aren't you")
  AskedUser% = TRUE
  AllRespMade% = TRUE
ELSE
  A$ = AdX$(Cap$(BigWord$)) + "Boy, you said it, " + AdP$(UserName$)
END IF
 
  Response$(1) = A$

END SUB

'==============================
 SUB EchoLastWord
'==============================
     'echoes last word of UserWords$() in an answer

 DO
   Counter% = Counter% + 1
   Word$ = UserWords$(Counter%)
 LOOP UNTIL LEN(Word$) = 0

 Word$ = Cap$(UserWords$(Counter% - 1))
   
 IF Word$ = "You" THEN Word$ = "Me"
 IF Word$ = "Me" THEN Word$ = "You"

 Response$(1) = AdQ$(Word$) + AdX$("I see what you mean")

END SUB

'=========================
 SUB EndScreen
'=========================

  VIEW PRINT: CLS   'turns off viewport; restores full-screen printing

  FOR Count% = 1 TO EndDim%
      PRINT EndMessage(Count%).Word
  NEXT Count%

  PRINT : PRINT
  END          'message stays on screen and program exits to DOS prompt
END SUB

'===========================
 FUNCTION EvalNum% (Test$)
'===========================
  'evaluates if a word is a number, by testing each character.
  'It sets flag and exits at the first alphabetical character.
  'If all ends well, the flag remains zero.

FOR Count% = 1 TO LEN(Test$)
    SELECT CASE ASC(Test$)
       CASE IS < 48
           NotNumber% = TRUE: EXIT FOR
       CASE IS > 57
           NotNumber% = TRUE: EXIT FOR
    END SELECT
  Test$ = RIGHT$(Test$, LEN(Test$) - 1)
NEXT Count%
            
EvalNum% = NotNumber%

END FUNCTION

'=============================
 FUNCTION EvalPro% (Word$)
'=============================
  'evaluates the word passed to it against an array of pronouns
  'if a match is found, the position in the array is returned

IF LEN(Word$) = 0 THEN EXIT FUNCTION

FOR Count% = 1 TO TestProDim%
   IF ASC(Word$) = ASC(TestPro(Count%).Word) THEN
       IF Word$ = RTRIM$(TestPro(Count%).Word) THEN
         Found% = TRUE
         EXIT FOR
       END IF
   END IF
NEXT Count%

IF Found% = TRUE THEN EvalPro% = Count% ELSE EvalPro% = FALSE

END FUNCTION

'==========================
 FUNCTION EvalVb% (Word$)
'==========================
  'evaluates the passed word against a specific array containing verbs
  ' If a match is found the position in the array is returned

 IF LEN(Word$) = 0 THEN EXIT FUNCTION

 FOR Count% = 1 TO TestVbDim%
    IF ASC(Word$) = ASC(TestVb(Count%).Word) THEN
       IF Word$ = RTRIM$(TestVb(Count%).Word) THEN
         Found% = TRUE: EXIT FOR
       END IF
    END IF
 NEXT Count%

 IF Found% = TRUE THEN EvalVb% = Count% ELSE EvalVb% = FALSE

END FUNCTION

'=============================
 FUNCTION EvalWord% (Word$)
'=============================
  'this is a dorky function, the vestige of a grander plan that never
  'bore fruit. It acquires a lot of information about the word passed
  'to it, but little is ever done with the information.
 
IF FoundNoun% THEN Noun% = FoundNoun% ELSE Noun% = 1

  SELECT CASE Word$
    CASE Nul$
       Ans% = 0
    CASE "a", "an", "the"
       Ans% = 1
    CASE Nouns$(Noun%), Plur$(Noun%)
       Ans% = 2
    CASE "my", "your", "his", "her", "its", "their", "our"
       Ans% = 3
    CASE "me", "them", "him", "us"
       Ans% = 4
    CASE "it", "you", "this", "that", "something", "anything", "nothing"
       Ans% = 5
    CASE ELSE
       Ans% = 0
  END SELECT
         
  EvalWord% = Ans%

END FUNCTION

'==============================
 FUNCTION ExpndCont$ (Cont$)
'==============================
   'accepts a contraction (i.e. "ve") and expands it (i.e. "have")

SELECT CASE Cont$
  CASE "m"
    Word$ = "am"
  CASE "re"
    Word$ = "are"
  CASE "s"
    Word$ = "is"
  CASE "ve"
    Word$ = "have"
  CASE "ll"
    Word$ = "will"
  CASE "d"
    Word$ = "would"
  CASE ELSE
    Word$ = Nul$
END SELECT

ExpndCont$ = Word$

END FUNCTION

'================
 SUB FdNounAnswer
'================
  'when user refers to a noun Claude knows, this SUB puts an appropriate
  'comment into Response$(1), refering to that noun

STATIC Last%
Plural$ = Plur$(FoundNoun%)

DO
  Choose% = FNRndNum%(1, 8)
LOOP WHILE Choose% = Last%

SELECT CASE Choose%
 CASE 1
   Ans$ = AdX$(Cap$(Plural$)) + "I can tell you all about " + AdX$(Plural$)
 CASE 2
   Ans$ = "I have my own opinion about " + AdP$(Plural$)
 CASE 3
   Ans$ = Exclam$ + "I never knew any " + Plural$ + "that amounted to much! "
 CASE 4
   Ans$ = Exclam$ + "Don't talk to me about " + AdX$(Plural$)
 CASE 5
   Ans$ = "So you want to talk about " + AdC$(Plural$) + "huh? Well, I've just about had my fill of " + AdP$(Plural$)
 CASE 6
   Ans$ = "I'll bet you know all about " + RTRIM$(Plural$) + ", don't you, " + UserName$ + "? Well listen to me. "
 CASE 7
   Ans$ = "Let me tell you a thing or two about " + AdP$(Plural$)
 CASE 8
   Ans$ = Cap$(Plural$) + "can be pretty irritating if you ask me. "
END SELECT

Last% = Choose%
Response$(1) = Ans$

END SUB

'==========================
 FUNCTION FindPad% (Start%)
'==========================
 'checks UserWords() against a key-list of "padding" words (i.e. "well")
 'also detects any (presumed) adverbs ending in "ly", or numbers.
 'function returns position of first non-pad word, starting at the
 'UserWords$() position passed to the function when called.
 'Count% initializes as 0.

DO
  Word$ = LCASE$(UserWords$(Count% + Start%))
  IF LEN(Word$) = 0 THEN EXIT DO ELSE Padding% = FALSE

  FOR Look% = 1 TO PadDim%
    IF ASC(Word$) = ASC(PadWord(Look%).Word) THEN
       IF Word$ = RTRIM$(PadWord(Look%).Word) THEN
          Padding% = TRUE
          GOTO PadTrue
       END IF
    END IF
  NEXT Look%
 
  IF RIGHT$(Word$, 2) = "ly" THEN
     Padding% = TRUE
     Adverb% = Count% + Start%
     GOTO PadTrue
  END IF
  
  SELECT CASE ASC(Word$)
    CASE 48 TO 57         'the digits 0 to 9
      Padding% = TRUE
  END SELECT

PadTrue:
  IF Padding% THEN Count% = Count% + 1
LOOP WHILE Padding% = TRUE

  FindPad% = Start% + Count%   'returns position of first NON-padding word

END FUNCTION

'=========================
 SUB FlagReset
'=========================
 
  AllRespMade% = FALSE  'flag set by RespondToProfanity/ToNoInput,etc.
  NoResp2% = FALSE      'flag set when Resp2 not wanted
  NoSense% = FALSE      'flag set by BreakUp/TestAllPunc/other
  NonSense$ = Nul$      'string saved by BreakUp SUB when NoSense% is TRUE
  Obscene% = FALSE       'flag set by TestObscenity SUB
  NoInput% = FALSE      'flag set by BreakUp SUB
  Question% = FALSE     'flag set by TestAllPunc SUB
  NoOb% = FALSE         'flag set by ChooseVrb SUB
  SubHuman% = FALSE     'flag set by ChooseSb SUB
  MultiSent% = FALSE    'flag set by GetLastSent SUB
  Adverb% = FALSE       'flag set by FindPad FUNCTION
  Phony% = FALSE        'flag set by TestForNoun SUB
  R2Q% = FALSE          'flag set by Response2ndPart SUB
 
  ERASE EachSent$       'some housecleaning
  ERASE UserWords$

END SUB

'===================================
 FUNCTION Get3rdPerson$ (Passed%)
'===================================
   'accepts a numeric pointer toward a verb in VbInfin() array and
   'returns its third person singular present tense

 Test$ = RTRIM$(VbInfin(Passed%).Word)
 Insep$ = RTRIM$(VbInsep(Passed%).Word)

   SELECT CASE ASC(RIGHT$(Test$, 1))     'last letter
     CASE 121                            'ends in y
       SELECT CASE ASC(RIGHT$(Test$, 2)) 'next to last letter
           CASE 97, 101, 105, 111, 117   'aeiou
              Return$ = Test$ + S$
           CASE ELSE                     'a consonant
              Return$ = LEFT$(Test$, LEN(Test$) - 1) + "ies "
       END SELECT
     CASE 104                            'ends in h
       SELECT CASE ASC(RIGHT$(Test$, 2)) 'next to last letter
         CASE 103                        'ends in gh
            Return$ = Test$ + S$
         CASE ELSE
            Return$ = Test$ + ES$
       END SELECT
     CASE 111, 115                       'ends in o or s
       Return$ = Test$ + ES$
     CASE ELSE
       IF Test$ = "have" THEN
          Return$ = "has "
       ELSE
          Return$ = Test$ + S$
       END IF
   END SELECT

   Get3rdPerson$ = RTRIM$(Return$ + Insep$) + Spac$

END FUNCTION

'============================
 FUNCTION GetAdj$ (NounNum%)
'============================
  'returns an adjective from Adjective() array suitable to indicated noun

STATIC LastChosen%

DO
 SELECT CASE NounNum%
   CASE 1 TO People%                              'it's a person
      X% = FNRndNum%(1, PersonAdjDim%)            'get a general/personal adj
   CASE (People% + 1) TO Clothes%                 'it's an object
      X% = FNRndNum%(1, GenAdjDim%)               'get a general adjective
   CASE (Clothes% + 1) TO Potables%               'it's a food or drink
      IF RND > .75 THEN                           'consult luck of the draw
         X% = FNRndNum%(PersonAdjDim% + 1, FoodAdjDim%) 'get a food adjective
      ELSE
         X% = FNRndNum%(1, GenAdjDim%)            'or a general adjective
      END IF
   CASE (Potables% + 1) TO Cities%                'it's a place
      X% = FNRndNum%(1, GenAdjDim%)               'get a general adjective
  END SELECT

  Adj$ = RTRIM$(Adjective(X%).Word) + Spac$
 
LOOP WHILE X% = LastChosen%      'prevents repetition

Adject% = X%               'a shared variable used elsewhere
LastChosen% = X%           'STATIC variable within this Function
GetAdj$ = Adj$

END FUNCTION

'=======================
 FUNCTION GetBig$
'=======================
  'Big$ is initially a null string and Test$ is the first UserWord.
  'When Test$ is longer than the current Big$, then Test$
  'becomes the new Big$, and each subsequent Test$ is tested against it

  FOR Index% = 1 TO MaxUser%
    Test$ = UserWords$(Index%)
    IF LEN(Test$) THEN
       IF LEN(Test$) > LEN(Big$) THEN Big$ = Test$
    ELSE
       EXIT FOR        'this happens when Test$ is a null string
    END IF
  NEXT Index%

  GetBig$ = Big$

END FUNCTION

'=================================
 FUNCTION GetCmpAdj$ (Adjective%)
'=================================
  'returns the comparative form of the indicated adjective

  Code% = AdjCode%(Adjective%)               'gets code number from array
  Word$ = RTRIM$(Adjective(Adjective%).Word)

  SELECT CASE Code%
    CASE 0           'add "er"
      SELECT CASE RIGHT$(Word$, 1)
       CASE "y"
         Cmp$ = LEFT$(Word$, LEN(Word$) - 1) + "ier"
       CASE "e"
         Cmp$ = Word$ + "r"
       CASE ELSE
         Cmp$ = Word$ + "er"
      END SELECT
    CASE 1           'add "more"
      Cmp$ = "more " + Word$
    CASE IS > 1               'aha! an irregular comparative (good/better)
      Cmp$ = RTRIM$(IrrCmp(Code% - 1).Word)
  END SELECT

  GetCmpAdj$ = Cmp$ + Spac$

END FUNCTION

'==========================================
 FUNCTION GetColor% (Choice%, OldColor%)
'==========================================
  'used to help set the screen colors, when /c used on command line
  'controls the keyed input by the user when selecting new colors and
  'returns the number of the color selected

 LOCATE 19, 1
 PRINT STRING$(80, 32)
 LOCATE 20, 6, 1
 PRINT RTRIM$(ColorPrompt(Choice%).Word); Spac$;
 ColorNum% = OldColor%

DO
   IF NumPress% < 3 THEN NumPress% = NumPress% + 1
     
      DO: Press$ = INKEY$
      LOOP UNTIL LEN(Press$)

   IF LEN(Press$) = 1 THEN
      Ky% = ASC(Press$)
        SELECT CASE Ky%
           CASE 13                             'ENTER key
                GetColor% = ColorNum%
                LOCATE 15, 1
                EXIT FUNCTION
           CASE 48 TO 57                       '0-key to 9-key
                IF NumPress% = 1 THEN
                   FirstDigit% = Ky% - 48      'converts to 0-9 integer
                   ColorNum% = FirstDigit%
                   PRINT Press$;
                ELSEIF NumPress% = 2 THEN
                   IF FirstDigit% = 1 THEN
                      IF Ky% > 47 AND Ky% < 54 THEN  'from 0-5
                         ColorNum% = (FirstDigit% * 10) + (Ky% - 48)
                         PRINT Press$;
                      ELSE
                         NumPress% = 1
                      END IF
                   ELSE
                      NumPress% = 1
                   END IF
                END IF
           CASE 8                              'backspace key
                IF NumPress% > 1 THEN
                  IF NumPress% = 2 THEN
                     ColorNum% = OldColor%
                  ELSEIF NumPress% = 3 THEN
                     ColorNum% = FirstDigit%
                  END IF
                   NumPress% = NumPress% - 2
                   Row% = POS(0)
                   LOCATE CSRLIN, Row% - 1
                   PRINT Spac$;
                   LOCATE CSRLIN, Row% - 1
                ELSE
                   NumPress% = 0
                END IF
           CASE ELSE
                NumPress% = NumPress% - 1
       END SELECT
   END IF
LOOP

END FUNCTION

'============================
 FUNCTION GetGerund$ (Subj%)
'============================
    'returns a gerund (i.e. "running after - dogs")
    'and avoids nesting of gerunds as objects of one another:
    '(i.e. "starting - thinking about - running after - dogs")
   
OverAgain:                              'where to jump to start over
    GVerb% = GetVerb%(Subj%)            'get a verb to make a gerund out of
     
      IF GVerb% THEN                    'if it isn't a passive verb (0)
         Code% = VbObjCode%(GVerb%)     'then fetch the verb's object code
         IF Code% = 1 THEN              'if gerund only available object
            GOTO OverAgain              'then try, try again
         ELSE                           'or, if gerund is not the only object
            IF Code% MOD 2 = 1 THEN     'but, a gerund is a possible object
               Code% = Code% - 1        'then eliminate the possiblity
            END IF                      'and move along to next step
         END IF
         ObjNum% = GetObject%(Code%)                  'fetch object of GVerb
         IF ObjNum% THEN
          Gerund$ = GetIng$(GVerb%) + Plur$(ObjNum%)  'form the gerund
         ELSE
          Gerund$ = GetIng$(GVerb%)
         END IF
      ELSE                                            'it was a passive verb
         Gerund$ = "being " + GetAdj$(Subj%)          'so form it this way
      END IF

    GetGerund$ = Gerund$

END FUNCTION

'==================================
 FUNCTION GetIng$ (Passed%)
'==================================
  'accepts pointer to an infinitive and returns present participle ("ing")
  'most of the fuss in this code is to determine whether the final
  'consonant of the verb must be doubled before adding "ing"

  Test$ = RTRIM$(VbInfin(Passed%).Word)
  Length% = LEN(Test$)
  AllReg$ = Test$ + "ing "
  Doubled$ = Test$ + CHR$(ASC(RIGHT$(Test$, 1))) + "ing "

  SELECT CASE ASC(RIGHT$(Test$, 1))        'the last letter
     CASE 101                              'an e
        SELECT CASE ASC(RIGHT$(Test$, 2))  'next to last letter
          CASE 105                         'an i
             Return$ = LEFT$(Test$, Length% - 2) + "ying "
          CASE 101                         'an e
             Return$ = AllReg$
          CASE ELSE
             Return$ = LEFT$(Test$, Length% - 1) + "ing "
        END SELECT
     CASE 98, 100, 103, 108, 109, 110, 112, 114, 115, 116 'b,d,g,l,m,n,p,r,s,t
        IF Length% > 4 THEN                         '5 letter or more words
           IF Test$ = "begin" THEN
              Return$ = Doubled$
           ELSE
              Return$ = AllReg$
           END IF
           GOTO OutOfLoop                           'skip to end of function
        ELSE                                        '3 or 4 letter words
          SELECT CASE ASC(RIGHT$(Test$, 2))         'test next to last letter
              CASE 97, 101, 105, 111, 117           'if it's a vowel THEN
                  SELECT CASE ASC(RIGHT$(Test$, 3)) 'test third to last letter
                    CASE 97, 101, 105, 111, 117     'if it's a vowel THEN
                       Return$ = AllReg$            'it had VVC pattern
                    CASE ELSE                       'if it's a consonant THEN
                      IF Length% = 4 THEN           'is it a 4 letter word?
                        SELECT CASE ASC(Test$)      'if yes, test first letter
                          CASE 97, 101, 105, 111, 117  'is first a vowel?
                             Return$ = AllReg$      ' IF YES THEN add "ing"
                          CASE ELSE                 'OTHERWISE double last
                             Return$ = Doubled$
                        END SELECT
                      END IF
                     
                      Return$ = Doubled$      'was a 3-letter CVC pattern
                 END SELECT
              CASE ELSE                       'ends with two consonants
                 Return$ = AllReg$            'THEN don't double last letter
            END SELECT
        END IF
     CASE ELSE                   'last letter not  b,d,g,l,m,n,p,r,s,t
        Return$ = AllReg$        'so DON'T double the last letter
  END SELECT

OutOfLoop:
  Insep$ = RTRIM$(VbInsep(Passed%).Word)
  GetIng$ = RTRIM$(Return$ + Insep$) + Spac$

END FUNCTION

'============================================
 SUB GetInput (Row%, Col%, EndCol%)
'============================================
  'this code has been modified for CLAUDE, but the original code
  'came from the book QUICKBASIC ADVANCED TECHNIQUES, by AITKEN, Que Books
  'a similar piece of code has also appeared in PC Magazine.
 
  CONST ENTER = 13
 
  DO WHILE INKEY$ <> Nul$: LOOP     ' empties keyboard buffer
  LOCATE Row%, Col%, 1, 0, 7        ' turns on a big cursor
 
  SHOW$ = STRING$(EndCol%, CHR$(176))   'squares
  PRINT SHOW$;
  LOCATE Row%, Col%

' -----------------------------
' START OF MAIN PROCEDURE LOOP
' -----------------------------

DO
      DO
        K$ = INKEY$          ' wait for some kind of input
      LOOP UNTIL K$ <> Nul$

      IF LEN(K$) = 2 THEN
        Extnd% = TRUE
        Ky% = ASC(RIGHT$(K$, 1))   ' drops the extended code from K$
      ELSE
        Extnd% = FALSE
        Ky% = ASC(K$)
      END IF

      IF (Extnd% = FALSE) AND (Ky% = ENTER) THEN
        UserInput$ = LTRIM$(RTRIM$(OutPut$))
        PRINT                      ' print empty line above next output
        IF Lpt% THEN LPRINT UserInput$
        EXIT DO                    ' then go to the end of this main loop
     
      ELSEIF (Extnd% = TRUE) AND (Ky% = 59) THEN   'an F1 keypress
        CALL HelpControl                           'help screen procedure
     
      ELSEIF (Extnd% = TRUE) AND (Ky% = 63) THEN   'an F5 keypress
        Down% = CSRLIN: Over% = POS(0)             'save cursor position
        VIEW PRINT                                 'turn off viewport
         IF Lpt% THEN
           Lpt% = FALSE                            'toggle printout mode
           LOCATE 24, 44: PRINT Spac$              'show it on status line
         ELSE
           Lpt% = TRUE                             'toggle printout mode
           LOCATE 24, 44: PRINT CHR$(254)          'show it on status line
         END IF
        VIEW PRINT 4 TO 21                         'restore viewport
        IF Lpt% THEN
           PrnOK% = PrnChk%                        'check printer-ready
           IF PrnOK% = FALSE THEN                  'if not ready
              BEEP                                 'beep
              CALL PrnWarning                      'and warn the user
           END IF
        END IF
        LOCATE Down%, Over%, 1                     'restore cursor
     
      ELSEIF (Extnd% = TRUE) AND (Ky% = 68) THEN   'an F10 keypress
        CALL EndScreen                             'end program

      ELSEIF (Extnd% = TRUE) AND (Ky% = 75) AND (Cpos% > 0) THEN
        Cpos% = Cpos% - 1
        LOCATE Row%, Col% + Cpos%   ' on LEFT ARROW move left one position

      ELSEIF (Extnd% = TRUE) AND (Ky% = 77) AND (Cpos% < Length%) THEN
        Cpos% = Cpos% + 1
        LOCATE Row%, Col% + Cpos%   ' on RIGHT ARROW move right

      ELSEIF (Extnd% = TRUE) AND (Ky% = 79) THEN
        Cpos% = Length%
        LOCATE Row%, Col% + Cpos%    ' on END go to end of line

      ELSEIF (Extnd% = TRUE) AND (Ky% = 71) THEN
        Cpos% = 0
        LOCATE Row%, Col% + Cpos%     ' on HOME go to start of line
     
      ELSEIF (Extnd% = TRUE) AND (Ky% = 83) AND (Length% > 0) AND (Cpos% < Length%) THEN
        Temp1$ = LEFT$(OutPut$, Cpos%)
        Temp2$ = RIGHT$(OutPut$, Length% - Cpos% - 1)
        OutPut$ = Temp1$ + Temp2$        ' on a DEL keypress, divide string in
        Length% = Length% - 1         ' two halves, but without the character
        LOCATE Row%, Col%             ' at the cursor, rejoin the two halves
        PRINT OutPut$ + CHR$(176);       ' add a box at end of input to keep
        LOCATE Row%, Col% + Cpos%     ' things neat

      ELSEIF (Ky% = 8) AND (Length% > 0) AND (Cpos% > 0) THEN
        Temp1$ = LEFT$(OutPut$, Cpos% - 1)
        Temp2$ = RIGHT$(OutPut$, (Length% - Cpos%))
        OutPut$ = Temp1$ + Temp2$        ' on BACKSPACE, divide string in two
        Length% = Length% - 1         ' but without the character to left of
        Cpos% = Cpos% - 1             ' cursor, rejoin halves, put box at
        LOCATE Row%, Col%             ' end, as above, & reposition cursor
        PRINT OutPut$ + CHR$(176);
        LOCATE Row%, Col% + Cpos%

      ELSEIF (Extnd% = FALSE) AND (Ky% > 31) AND (Ky% < 127) AND (Length% < EndCol%) THEN
        Temp1$ = LEFT$(OutPut$, Cpos%)
        Temp2$ = RIGHT$(OutPut$, Length% - Cpos%)
        OutPut$ = Temp1$ + CHR$(Ky%) + Temp2$
        Length% = Length% + 1
        Cpos% = Cpos% + 1
        LOCATE Row%, Col%
        PRINT OutPut$;
        LOCATE Row%, Col% + Cpos%
    
      END IF
LOOP

END SUB

'===========================
 SUB GetLastSent
'===========================
   'CALLed by TestAllPunc. It finds last "good" sentance, sets a pointer
   'to it in EachSent$() and sets MultiSent% flag as TRUE

  LastSent% = 7                   'set the variable to highest possible + 1
 
  DO
    LastSent% = LastSent% - 1     'decrement it
    Test$ = EachSent$(LastSent%)  'assign Test$ out of array
  LOOP WHILE Test$ = Nul$         'if Test$ is null, do it over again
    
DO
  REM  This for/next loop is designed to find the first alphabetic character
  REM  in Test$ and then truncates Test$ up to that character

  FOR Count% = 1 TO LEN(Test$)
       SELECT CASE ASC(Test$)
          CASE 65 TO 90, 97 TO 122            'is it ALPHABETIC?
               EachSent$(LastSent%) = Test$   'put Test$ back into EachSent()
                   IF LastSent% > 1 THEN      'were there other sentances?
                      MultiSent% = TRUE       'if so, set flag
                      CALL BreakUpLast(LastSent%)  'take care of business
                   END IF
               EXIT SUB                       'mission accomplished!
          CASE ELSE                           'no, not alphabetic yet
               Test$ = RIGHT$(Test$, LEN(Test$) - 1) 'truncate Test$ by one
          END SELECT
  NEXT Count%                                 'and loop back for another try
                 
  IF LEN(Test$) = 0 THEN LastSent% = LastSent% - 1  'there were no alphabetic
  Test$ = EachSent$(LastSent%)                     'characters; so, try again
LOOP

END SUB

'================================
 FUNCTION GetObject% (ObCode%)
'================================
                       'only called from ChooseOb or GetGerund
GetOb% = ObCode%       'make a copy to work on (just in case)
DIM TempObj%(1 TO 12)
  
   IF GetOb% > 2047 THEN
      A% = FNRndNum%(Locations% + 1, Cities%): Filled% = Filled% + 1
      TempObj%(Filled%) = A%: GetOb% = GetOb% - 2048
   END IF
  
   IF GetOb% > 1023 THEN
      B% = FNRndNum%(Liquids% + 1, Locations%): Filled% = Filled% + 1
      TempObj%(Filled%) = B%: GetOb% = GetOb% - 1024
   END IF

   IF GetOb% > 511 THEN
      C% = FNRndNum%(Potables% + 1, Liquids%): Filled% = Filled% + 1
      TempObj%(Filled%) = C%: GetOb% = GetOb% - 512
   END IF

   IF GetOb% > 255 THEN
      D% = FNRndNum%(Edibles% + 1, Potables%): Filled% = Filled% + 1
      TempObj%(Filled%) = D%: GetOb% = GetOb% - 256
   END IF

   IF GetOb% > 127 THEN
      E% = FNRndNum%(Clothes% + 1, Edibles%): Filled% = Filled% + 1
      TempObj%(Filled%) = E%: GetOb% = GetOb% - 128
   END IF

   IF GetOb% > 63 THEN
      F% = FNRndNum%(Containers% + 1, Clothes%): Filled% = Filled% + 1
      TempObj%(Filled%) = F%: GetOb% = GetOb% - 64
   END IF

   IF GetOb% > 31 THEN
      G% = FNRndNum%(Objects% + 1, Containers%): Filled% = Filled% + 1
      TempObj%(Filled%) = G%: GetOb% = GetOb% - 32
   END IF

   IF GetOb% > 15 THEN
     H% = FNRndNum%(BodyParts% + 1, Objects%): Filled% = Filled% + 1
     TempObj%(Filled%) = H%: GetOb% = GetOb% - 16
   END IF

   IF GetOb% > 7 THEN
      II% = FNRndNum%(Animals% + 1, BodyParts%): Filled% = Filled% + 1
      TempObj%(Filled%) = II%: GetOb% = GetOb% - 8
   END IF

   IF GetOb% > 3 THEN
      J% = FNRndNum%(People% + 1, Animals%): Filled% = Filled% + 1
      TempObj%(Filled%) = J%: GetOb% = GetOb% - 4
   END IF

   IF GetOb% > 1 THEN
      K% = FNRndNum%(1, People%): Filled% = Filled% + 1
      TempObj%(Filled%) = K%: GetOb% = GetOb% - 2
   END IF

   IF GetOb% > 0 THEN
      L% = NDim% + 1: Filled% = Filled% + 1
      TempObj%(Filled%) = L%
   END IF

 Chosen% = FNRndNum%(1, Filled%)
 GetObject% = TempObj%(Chosen%)    'returns a pointer into Nouns array
 ERASE TempObj%                    'make certain old data is erased

END FUNCTION

'====================================
 FUNCTION GetPast$ (Passed%)
'====================================
  'a complex FUNCTION to return the simple past tense of the indicated verb
 
Insep$ = RTRIM$(VbInsep(Passed%).Word)
 
IF Passed% <= IrrDim% THEN
 GetPast$ = RTRIM$(RTRIM$(VbIrrPast(Passed%).Word) + Spac$ + Insep$) + Spac$
 EXIT FUNCTION
END IF
 
  Test$ = RTRIM$(VbInfin(Passed%).Word)
  Length% = LEN(Test$)
  LastLet% = ASC(RIGHT$(Test$, 1))   'Test$ will always be lower case
  AllReg$ = Test$ + "ed "
  Doubled$ = Test$ + CHR$(LastLet%) + "ed "

  SELECT CASE LastLet%
     CASE 101                     'an e
        Return$ = Test$ + "d "    'notice the space after the d
     CASE 121                     'a y
        IF Test$ = "play" THEN
           Return$ = Test$ + "ed" + Spac$
        ELSE
           Return$ = LEFT$(Test$, Length% - 1) + "ied "
        END IF
     CASE 98, 100, 103, 108, 109, 110, 112, 114, 115, 116 'b,d,g,l,m,n,p,r,s,t
        IF Length% > 4 THEN
           Return$ = AllReg$
           GOTO NoMore            'skip to end of function
        END IF
       
        IF Length% <= 4 THEN      'continue tests only on 3 & 4 letter words
            SELECT CASE ASC(RIGHT$(Test$, 2))       'test next to last letter
              CASE 97, 101, 105, 111, 117           'if it's a vowel THEN
                  SELECT CASE ASC(RIGHT$(Test$, 3)) 'test third to last letter
                    CASE 97, 101, 105, 111, 117     'if it's a vowel THEN
                       Return$ = AllReg$            'it had VVC pattern
                    CASE ELSE                       'if it's a consonant THEN
                      IF Length% = 4 THEN           'is it a 4 letter word?
                        SELECT CASE ASC(Test$)      'if yes, test first letter
                          CASE 97, 101, 105, 111, 117  'is first a vowel?
                             Return$ = AllReg$      ' IF YES THEN add "ed"
                          CASE ELSE                 'OTHERWISE double last
                             Return$ = Doubled$
                        END SELECT
                      END IF
                      
                      Return$ = Doubled$      'was a 3-letter CVC pattern
                 END SELECT
              CASE ELSE                       'ends with two consonants
                 Return$ = AllReg$            'THEN don't double last letter
            END SELECT
        END IF
     CASE ELSE                   'last letter not  b,d,g,l,m,n,p,r,s,t
        Return$ = AllReg$        'so DON'T double the last letter
  END SELECT

NoMore:
  GetPast$ = RTRIM$(Return$ + Insep$) + Spac$
END FUNCTION

'=================================
 FUNCTION GetPastPerf$ (Vb%)
'=================================
   'a function that returns the singular past perfect tense of verb
   'which consists of the past participle, preceded by "have" or "has".
   'regularly, the past participle is the same as the simple past tense
   'as in "have looked"; an example of an irregular P.P. is "have seen"

 SELECT CASE Vb%
   CASE IS <= IrrDim%
     Pre$ = RTRIM$(VbIrrParticiple(Vb%).Word) + Spac$ + VbInsep(Vb%).Word
     PPerf$ = RTRIM$(Pre$) + Spac$
   CASE ELSE
     PPerf$ = SPastVb$
 END SELECT

 GetPastPerf$ = "have " + PPerf$

END FUNCTION

'=================================
 FUNCTION GetSupAdj$ (Adject%)
'=================================
  'returns the superlative form of the indicated adjective

  Code% = AdjCode%(Adject%)    'gets adjcode from code array
  Word$ = RTRIM$(Adjective(Adject%).Word)

  SELECT CASE Code%
    CASE 0           'add "est"
      SELECT CASE RIGHT$(Word$, 1)
       CASE "y"
         Sup$ = LEFT$(Word$, LEN(Word$) - 1) + "iest"
       CASE "e"
         Sup$ = Word$ + "st"
       CASE ELSE
         Sup$ = Word$ + "est"
      END SELECT
    CASE 1           'add "most"
      Sup$ = "most " + Word$
    CASE IS > 1           'irregular comparative (good/better)
      Sup$ = RTRIM$(IrrSup(Code% - 1).Word)
  END SELECT

  GetSupAdj$ = Sup$ + Spac$


END FUNCTION

'===============================
 FUNCTION GetVerb% (Subj%)
'===============================
   'returns a Verb% suited to an indicated Sb$
   'when GetVerb% returns a zero then ChooseVb will form a passive verb
   'from a form of "to be" and an adjective

Determine! = RND
     
      SELECT CASE Subj%
         CASE IS <= People%
            VerbIrr% = FNRndNum%(1, BodIrr% - 1)
            VerbReg% = FNRndNum%(IrrDim% + 1, BodReg% - 1)
              IF Determine! < .08 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .63 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= Animals%
            VerbIrr% = FNRndNum%(HumIrr% + 1, AnimIrr%)
            VerbReg% = FNRndNum%(HumReg% + 1, AnimReg%)
              IF Determine! < .08 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .6 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= BodyParts%
            VerbIrr% = FNRndNum%(AnimIrr% + 1, BodIrr%)
            VerbReg% = FNRndNum%(AnimReg% + 1, BodReg%)
              IF Determine! < .3 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .75 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= Containers%
            VerbIrr% = FNRndNum%(BodIrr% + 1, ObjIrr%)
            VerbReg% = FNRndNum%(BodReg% + 1, ObjReg%)
              IF Determine! < .3 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .5 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= Clothes%
            VerbIrr% = FNRndNum%(ObjIrr% + 1, ClothIrr%)
            VerbReg% = FNRndNum%(ObjReg% + 1, ClothReg%)
              IF Determine! < .3 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .8 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= Edibles%
            VerbIrr% = FNRndNum%(ClothIrr% + 1, FoodIrr%)
            VerbReg% = FNRndNum%(ClothReg% + 1, FoodReg%)
              IF Determine! < .3 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .63 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= Potables%
            VerbIrr% = FNRndNum%(ClothIrr% + 1, LiqIrr%)
            VerbReg% = FNRndNum%(ClothReg% + 1, LiqReg%)
              IF Determine! < .3 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .5 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE IS <= Liquids%
            VerbIrr% = FNRndNum%(FoodIrr% + 1, LiqIrr%)
            VerbReg% = FNRndNum%(FoodReg% + 1, LiqReg%)
              IF Determine! < .3 THEN
                 GotVerb% = 0
              ELSEIF Determine! <= .35 THEN
                 GotVerb% = VerbIrr%
              ELSE
                 GotVerb% = VerbReg%
              END IF
         CASE ELSE
            GotVerb% = 0     'indicates a passive verb
      END SELECT
  
    IF GotVerb% = 0 THEN NoOb% = TRUE    'a flag used elsewhere
    GetVerb% = GotVerb%

END FUNCTION

'=====================
 SUB HelpControl
'=====================
  'this routine is called by an F1 keypress during GetInput SUB
  'it controls the help-window menu

  Over% = POS(0)           'save current cursor position to restore later
  Down% = CSRLIN           'save current cursor position to restore later
  LOCATE , , 0             'turn visible cursor off

  TRow% = 2                'top row
  BRow% = TRow% + 7        'bottom row
  LeftEdge% = 4
  RightEdge% = LeftEdge% + 17

CALL MenuPrint(TRow%, LeftEdge%, BRow%, RightEdge%)

Choice% = 1

DO
  Row% = TRow% + Choice%
  COLOR MenuBack%, MenuFore%                      'set menu colors
  Prompt$ = LEFT$(MenuWinText(Choice%).Word, 14)
  LOCATE Row%, LeftEdge% + 2
  PRINT Prompt$

  DO                             'waits for a key-press
    Key$ = INKEY$
  LOOP WHILE Key$ = Nul$
  
    IF ASC(Key$) = 13 THEN       'if Enter pressed
       IF Choice% = 6 THEN       'if Exit Help chosen
          CALL MemCopy(VARSEG(UnderMenu%(1)), MonSeg%, 2000)
          CALL SetRegScreen      'this restores normal video, too
          EXIT DO
       ELSE
          CALL MemCopy(VARSEG(UnderMenu%(1)), MonSeg%, 2000)
          CALL PrintHelpWin(Choice%)
          CALL MenuPrint(TRow%, LeftEdge%, BRow%, RightEdge%)
          Choice% = 6             'pre-select EXIT HELP on restored menu
       END IF
    ELSEIF LEN(Key$) = 2 THEN     'if an extended-code key is pressed
    
       SELECT CASE ASC(RIGHT$(Key$, 1))
         CASE &H48                              'an up-arrow
             COLOR MenuFore%, MenuBack%
             LOCATE TRow% + Choice%, LeftEdge% + 2
             PRINT LEFT$(MenuWinText(Choice%).Word, 14)
                IF Choice% = 1 THEN
                   Choice% = 6
                ELSE
                   Choice% = Choice% - 1
                END IF
         CASE &H50                              'a down-arrow
             COLOR MenuFore%, MenuBack%
             LOCATE TRow% + Choice%, LeftEdge% + 2
             PRINT LEFT$(MenuWinText(Choice%).Word, 14)
                IF Choice% = 6 THEN             'can't go down
                   Choice% = 1                  'so go up, instead
                ELSE
                   Choice% = Choice% + 1
                END IF
      END SELECT
    END IF
LOOP

LOCATE Down%, Over%, 1               'restores cursor as it was before
                           
END SUB                              'return to GetInput SUB

'========================================
 SUB ImpAnswer (Imp$, Second$, Third$)
'========================================
  'forms an answer when the user has input a command (imperative)

IF LCASE$(Imp$) = "thank" THEN
   IF LCASE$(Second$) = "you" THEN
      Response$(1) = "You're welcome! "
   END IF
   EXIT SUB
END IF

IF LEN(Second$) THEN SecWord% = EvalWord%(Second$)
IF LEN(Third$) THEN ThirdWord% = EvalWord%(Third$)
Together% = (SecWord% * 10) + ThirdWord%

SELECT CASE SecWord%
  CASE 3
   IF Second$ = "my" THEN
      Second$ = "your"
   ELSEIF Second$ = "your" THEN
      Second$ = "my"
   END IF
  CASE 4
   IF Second$ = "me" THEN Second$ = "you"
  CASE 5
   IF Second$ = "you" THEN Second$ = "me"
END SELECT

SELECT CASE ThirdWord%
  CASE 3
   IF Third$ = "my" THEN
      Third$ = "your"
   ELSEIF Third$ = "your" THEN
      Third$ = "my"
   END IF
  CASE 4
   IF Third$ = "me" THEN Third$ = "you"
  CASE 5
   IF Third$ = "you" THEN Third$ = "me"
END SELECT

IF SecWord% = 2 OR ThirdWord% = 2 THEN
   CALL ChooseSb(FoundNoun%)
   Ans$ = "Are you sure " + Plur$(FoundNoun%) + SbAre$ + "good for that? "
   AllRespMade% = TRUE
   AskedUser% = TRUE
ELSEIF SecWord% = 3 OR ThirdWord% = 3 THEN
   Ans$ = Cap$(Second$) + " WHAT?? Come on, " + UserName$ + AdX$(", get real")
ELSEIF Together% = 10 THEN
   Ans$ = "I'll " + Imp$ + " one when I'm good and ready. "
ELSEIF SecWord% = 4 THEN
   Ans$ = "Who, " + UCASE$(Second$) + "?? Don't make me laugh. "
   NoResp2% = TRUE
ELSEIF ThirdWord% = 4 THEN
   Ans$ = "Who, " + UCASE$(Third$) + "?? I wouldn't dream of it. "
   NoResp2% = TRUE
ELSEIF Together% = 45 THEN
   Ans$ = "Why should I " + Imp$ + Second$ + AdQ$(Third$)
   AllRespMade% = TRUE
ELSE
   Target% = FNRndNum%(1, 6)
   Ans$ = RTRIM$(ImpAns(Target%).Word) + Spac$
END IF

   Response$(1) = Ans$
END SUB

'============================
 FUNCTION IrrPlur$ (Word%)
'============================
  'called by Plur$ FUNCTION to see if a noun has an irregular plural
  'some irregulars are taken care of in Plur$ (i.e. man/men, wife/wives)
 
  SELECT CASE Word%
    CASE 1                     'thief
        Ans$ = "thieves "
    CASE People% + 1           'mouse
        Ans$ = "mice "
    CASE Animals% + 1          'foot
        Ans$ = "feet "
    CASE Containers% + 1       'scarf
        Ans$ = "scarves "
  END SELECT

  IrrPlur$ = Ans$

END FUNCTION

'============================
 SUB LoadAllArrays
'============================
   'This SUB controls the loading of all of CLAUDE's arrays
   'It is absolutely critical that the order in which these CALLS
   'are made corresponds exactly to the order of the DATA statements
   'in the main module of CLAUDE beneath the main loop

CALL LoadFixed16(VbInfin(), VbDim%)
CALL LoadFixed32(VbInsep(), VbDim%)
CALL LoadIntArray(VbObjCode%(), VbDim%)
CALL LoadFixed16(VbIrrPast(), IrrDim%)
CALL LoadFixed16(VbIrrParticiple(), IrrDim%)

CALL LoadFixed16(WInfinitive(), WInfinDim%)
CALL LoadFixed16(WInfinitivePast(), WInfinDim%)
CALL LoadFixed16(AuxilliaryVb(), AuxVerbDim%)

CALL LoadArray(Nouns$(), NDim%)
CALL LoadIntArray(PronArtCode%(), NDim%)
CALL LoadFixed16(Adjective(), AdjDim%)
CALL LoadIntArray(AdjCode%(), AdjDim%)
CALL LoadFixed16(IrrCmp(), IrrAdjDim%)
CALL LoadFixed16(IrrSup(), IrrAdjDim%)
CALL LoadFixed16(Frequency(), FrqDim%)
CALL LoadFixed16(Intensifier(), IntDim%)
CALL LoadFixed16(NumberAmount(), AmDim%)
CALL LoadDoubArray(PronArt$(), CodeNum%, PronList%)
CALL LoadFixed32(Exclamation(), ExDim%)
CALL LoadFixed32(Bridge(), BrdgDim%)
CALL LoadFixed64(InitResp(), InitDim%)
CALL LoadFixed64(AsPhrase(), AsDim%)
CALL LoadFixed64(Proverb(), ProvDim%)

CALL LoadFixed16(BoyName(), BoyDim%)
CALL LoadFixed16(GirlName(), GirlDim%)
CALL LoadFixed16(TimePass(), TimePassDim%)
CALL LoadFixed32(TimeDur(), TimeDurDim%)
CALL LoadFixed16(EZPhrase(), EZPhraseDim%)

CALL LoadFixed16(TestVb(), TestVbDim%)
CALL LoadFixed16(TestPro(), TestProDim%)
CALL LoadFixed16(WhyHow(), WhyHowDim%)
CALL LoadArray(NotNoun$(), NotNDim%)
CALL LoadFixed16(PadWord(), PadDim%)

CALL LoadFixed16(MenuWinText(), 6)
CALL LoadFixed64(HelpWinText(), 20)

CALL LoadFixed128(NoInp(), 6)
CALL LoadFixed64(Obscen(), 5)
CALL LoadFixed128(Gibber(), 15)
CALL LoadFixed64(WHowAns(), 22)
CALL LoadFixed64(ImpAns(), 6)
CALL LoadFixed64(Resp2(), Resp2Dim%)
CALL LoadFixed64(ByePhrase(), 5)
CALL LoadFixed64(EndMessage(), EndDim%)

END SUB

'===========================
 SUB LoadArray (Array$(), HowLong%)
'===========================
   'Accepts a string array and loads it to specified length

  FOR TimeAround% = 1 TO HowLong%
   READ Array$(TimeAround%)
  NEXT TimeAround%

END SUB

'===================================================
 SUB LoadDoubArray (Array$(), HowLong%, HowLong2%)
'===================================================
   'Accepts a two-dim string array and loads it to specified length

  FOR TimeAround% = 1 TO HowLong%
   FOR NextAround% = 1 TO HowLong2%
     READ Array$(TimeAround%, NextAround%)
   NEXT NextAround%
  NEXT TimeAround%

END SUB

'==================================================
 SUB LoadFixed128 (Array() AS Leng128, HowLong%)
'==================================================
   'Loads DATA into a 128 character fixed-length string array

  FOR TimeAround% = 1 TO HowLong%
   READ Array(TimeAround%).Word
  NEXT TimeAround%

END SUB

'==============================================
 SUB LoadFixed16 (Array() AS Leng16, HowLong%)
'==============================================
   'Loads DATA into a 16 character fixed-length string array

  FOR TimeAround% = 1 TO HowLong%
   READ Array(TimeAround%).Word
  NEXT TimeAround%

END SUB

'==============================================
 SUB LoadFixed32 (Array() AS Leng32, HowLong%)
'==============================================
   'Loads DATA into a 32 character fixed-length string array

  FOR TimeAround% = 1 TO HowLong%
   READ Array(TimeAround%).Word
  NEXT TimeAround%

END SUB

'==============================================
 SUB LoadFixed64 (Array() AS Leng64, HowLong%)
'==============================================
   'Loads DATA into a 64 character fixed-length string array

  FOR TimeAround% = 1 TO HowLong%
   READ Array(TimeAround%).Word
  NEXT TimeAround%

END SUB

'==============================================
 SUB LoadIntArray (IntArray%(), HowLong%)
'==============================================
   'Accepts an integer array and loads it to specified length

  FOR A% = 1 TO HowLong%
        READ IntArray%(A%)
  NEXT A%
 
END SUB

'====================================
 SUB MakeAnswer (Pron$, Vb$, Neg%)
'====================================
  'answers user input when the form -- pronoun/verb, (i.e. "he eats...")
  '(or "they knew...") was detected.

STATIC Last%

IF FNRndNum%(1, 6) = 6 THEN EXIT SUB    'helps to prevent predictability

SELECT CASE Pron$
   CASE "i"
      Pro$ = "you"
         IF Vb$ = "am" THEN Vb$ = "are"
         IF Vb$ = "was" THEN Vb$ = "were"
   CASE "you"
      Pro$ = "I"
         IF Vb$ = "are" THEN Vb$ = "am"
         IF Vb$ = "were" THEN Vb$ = "was"
   CASE "that"
      Pro$ = "it"
   CASE "this"
      Pro$ = "it"
   CASE ELSE
      Pro$ = Pron$
END SELECT

IF Neg% THEN
   SELECT CASE Vb$
     CASE "am", "shall"
        Vb$ = Vb$ + " not"
     CASE "can"
        Vb$ = "can't"
     CASE "will"
        Vb$ = "won't"
     CASE ELSE
        Vb$ = Vb$ + "n't"
   END SELECT
END IF

PVb$ = Pro$ + Spac$ + Vb$

DO
  Which% = FNRndNum%(1, 10)
LOOP WHILE Which% = Last%

SELECT CASE Which%
 CASE 1
   Ans$ = "It's good of you to notice that. "
 CASE 2
   Ans$ = "I'm not so sure " + PVb$ + ". "
 CASE 3
   Ans$ = "Well, maybe " + PVb$ + "! So big deal! "
 CASE 4
   Ans$ = "OK. If " + PVb$ + " then " + AdP$(PVb$)
 CASE 5
   Ans$ = Cap$(PVb$) + ", huh? Well, I bet you can't prove it! "
 CASE 6
   Ans$ = AdP$("Maybe you're right")
 CASE 7
   Ans$ = AdP$("You might be right, but I doubt it")
 CASE 8
   Ans$ = AdQ$(Cap$(PVb$)) + AdQ$("Are you sure")
   AllRespMade% = TRUE
   AskedUser% = TRUE
 CASE 9
   Ans$ = AdX$(Cap$(PVb$)) + AdX$("Well, imagine that")
 CASE 10
   Ans$ = AdQ$(Cap$(PVb$)) + AdP$("That's nice")
END SELECT

Last% = Which%
Response$(1) = Ans$

END SUB

'==========================================================
 SUB MenuPrint (TRow%, LEdge%, BRow%, REdge%)
'==========================================================
   'saves what's on the screen underneath the menu
   'then puts the menu on the screen, inside a window/box

CALL MemCopy(MonSeg%, VARSEG(UnderMenu%(1)), 2000)

VIEW PRINT           'resets text viewport to entire screen

  COLOR Fore%, Back%
  LOCATE 1, 20
  PRINT STRING$(40, 205)

  COLOR MenuBack%, MenuFore%
  LOCATE 1, 1
  PRINT "    Use <" + CHR$(25) + CHR$(24) + "> and <ENTER>    "
 
  COLOR MenuFore%, MenuBack%
  CALL PopWindow(LEdge%, TRow%, REdge%, BRow%, Nul$)

  FOR Num% = 1 TO 6
    Text$ = LEFT$(MenuWinText(Num%).Word, 13)
    LOCATE TRow% + Num%, LEdge% + 2
    PRINT Text$
  NEXT Num%
   
END SUB

'====================================================
 SUB NextAnswer (Pron$, Infinitive%, Third$, Index%)
'====================================================
 
Action$ = Get3rdPerson$(Infinitive%)
Isolate% = INSTR(Action$, Spac$)
V$ = LEFT$(Action$, Isolate%)

IF UserWords$(Index% + 6) = Nul$ THEN      'if the phrase is < 4 words long
  FOR X% = Index% + 2 TO MaxUser%
     IF UserWords$(X%) = Nul$ THEN EXIT FOR
     Phrase$ = Phrase$ + Spac$ + UserWords$(X%)
  NEXT X%
END IF

Every$ = "Everyone "
So$ = "So"

SELECT CASE Pron$
  CASE "i"
     Pron$ = "you"
     Vrb$ = "do"
  CASE "you"
     Pron$ = "I"
     Vrb$ = "do"
  CASE "they", "we"
     Vrb$ = "do"
  CASE "he", "she"
     Vrb$ = "does"
  CASE "it", "that", "this"
     Pron$ = "it"
     Vrb$ = "does"
     Every$ = "Everything "
END SELECT

SELECT CASE Third$
  CASE "me"
     VObj$ = "you"
  CASE "him", "her", "them", "us"
     VObj$ = Third$
  CASE ELSE
     VObj$ = Nul$
END SELECT

IF LEN(VObj$) THEN GOTO Yonder

Pick% = FNRndNum%(1, 5)

SELECT CASE Pick%
 CASE 1
   Ans$ = Cap$(Pron$) + Spac$ + AdQ$(Vrb$) + "Wow! That's great! "
 CASE 2
   Ans$ = "Oh, " + Pron$ + Spac$ + AdC$(Vrb$) + Vrb$ + Spac$ + AdQ$(Pron$) + "Then that's fine with me. "
 CASE 3
   Ans$ = "Why would " + Pron$ + " do something stupid like that? "
 CASE 4
   Ans$ = "Maybe " + Pron$ + Spac$ + AdC$(Vrb$) + But$ + "not often enough to suit me. "
 CASE 5
   Ans$ = "Yes. " + Cap$(Pron$) + " should do that whenever " + Pron$ + " can find the time. "
END SELECT

Response$(1) = Ans$: EXIT SUB

Yonder:

IF LEN(Phrase$) THEN
  Response$(1) = AdQ$(So$) + Every$ + V$ + AdP$(VObj$ + Phrase$)
ELSE
  Response$(1) = AdQ$(So$) + Every$ + AdP$("else does, too")
END IF

END SUB

'================
 SUB NullAll
'================
  'I added this routine while tracking a very stubborn bug
  'and I failed to remove it once I found that bug. Oops!

InfVb$ = Nul$
IngVb$ = Nul$
SPresVb$ = Nul$
PPresVb$ = Nul$
SPastVb$ = Nul$
PPastVb$ = Nul$
PPerfVb$ = Nul$
S3PerVb$ = Nul$
P3PerVb$ = Nul$
WInfVb$ = Nul$
PWInfVb$ = Nul$
AuxVb$ = Nul$
AuxNeg$ = Nul$

Sb$ = Nul$
SbPlur$ = Nul$
SbAdj$ = Nul$
SbCmp$ = Nul$
SbSup$ = Nul$
SbAmt$ = Nul$
SbWho$ = Nul$

CALL NullOb

Frq$ = Nul$
Int$ = Nul$
Exclam$ = Nul$
Plac$ = Nul$
Man$ = Nul$
Woman$ = Nul$
Bridg$ = Nul$
AsAs$ = Nul$
Prov$ = Nul$
TimPas$ = Nul$

SbA$ = Nul$
SbPro$ = Nul$
SbPPro$ = Nul$
SbAPro$ = Nul$
SbAre$ = Nul$
SbWere$ = Nul$

END SUB

'=====================
 SUB NullOb
'=====================
 
  Ob$ = Nul$
  ObPlur$ = Nul$
  ObA$ = Nul$
  ObPro$ = Nul$
  ObPPro$ = Nul$
  ObAPro$ = Nul$
  ObAm$ = Nul$
  ObAdj$ = Nul$
  ObCmp$ = Nul$
  ObSup$ = Nul$
  ObAre$ = Nul$
  ObWere$ = Nul$
  ObNum% = 0

END SUB

'================================
 SUB OneWordQuery (Word$)
'================================
  'called when Question% is TRUE and only one non-padding word was detected
  'it tests the word against a key-list and answers according to what's found
  'if the user used words which are considered padding by FindPad FUNCTION,
  'then First$ will not equal the Word$ which was passed as a parameter
  'the SUB tests this condition and adjusts for it.

First$ = LCASE$(UserWords$(1))

IF First$ = Word$ THEN
 SELECT CASE Word$
  CASE "me"
     Sent$ = "Yes, you! "
  CASE "what", "huh"
   IF LEN(Response$(3)) THEN
     Sent$ = "I distinctly said, " + CHR$(34) + Response$(3) + CHR$(34)
   ELSE
     Sent$ = "I could loan you my hearing aid, but it doesn't work very well. "
   END IF
   AllRespMade% = TRUE
  CASE "yeah", "yah", "ya"
     Sent$ = "Yeah! "
  CASE ELSE
   IF INSTR(Response$(2) + Response$(3), Word$) > 0 THEN
     Sent$ = "You heard me, pal. I said " + AdP$(Word$)
   ELSE
     CALL OtherAnswer: EXIT SUB
   END IF
 END SELECT

ELSE                      'First$ <> Word$
 SELECT CASE Word$
   CASE "what", "huh"
     SELECT CASE First$
       CASE "so"
         Sent$ = "So, stick it in your ear, " + AdX$(UserName$)
       CASE "then"
         Sent$ = "Then nothing much, really. "
       CASE "really"
         Sent$ = "I wouldn't lie to you, " + AdP$(UserName$)
       CASE ELSE
         IF LEN(Response$(2)) THEN
           Sent$ = "I distinctly said, " + CHR$(34) + Response$(2) + CHR$(34)
         ELSE
           Sent$ = "I could loan you my hearing aid, but it doesn't work very well. "
         END IF
     END SELECT
  CASE Nul$
     SELECT CASE First$
       CASE "yes", "no"
         Sent$ = AdP$(Cap$(First$))
       CASE "so"
         Sent$ = "So like it or lump it, " + AdX$(UserName$)
       CASE "and", "then"
         Sent$ = Cap$(First$) + " nothing. That's everything. "
       CASE "really", "honestly"
         Sent$ = "I wouldn't lie to you, " + AdP$(UserName$)
       CASE ELSE
         A$ = Cap$(UserWords$(1)) + "? Yes, " + AdX$(UserWords$(1))
         B$ = "I can see your point. "
         Sent$ = A$ + B$
     END SELECT
  CASE ELSE
     IF INSTR(Response$(2) + Response$(3), Word$) > 0 THEN
       Sent$ = "You heard me, pal. I said " + AdP$(Word$)
     ELSE
       CALL OtherAnswer: EXIT SUB
     END IF
 END SELECT
END IF

Response$(1) = Sent$

END SUB

'=============================
 SUB Opening
'=============================
   'sets opening screen; gets user's name; greets user by name

CALL SetRegScreen
CALL WrapPrint("My name is Claude. What should I call you?")

DO
  PRINT " YOUR NAME --> ";
 
  Lin% = CSRLIN
  CALL GetInput(Lin%, 15, 20)
  CALL BreakUp                'tests for nonsense, profanity, no input

  IF NoSense% = TRUE OR Obscene% = TRUE OR NoInput% = TRUE THEN
     CALL WrapPrint("Very funny. Now, let's try again.")
     CALL FlagReset
  ELSE
     UserName$ = Cap$(LCASE$(UserWords$(1)))
     Response$(1) = "Hi, " + UserName$ + "! I'm pleased to meet you. "
     AllRespMade% = TRUE
     ERASE UserWords$
     EXIT DO
  END IF
LOOP

END SUB

'============================
 SUB OtherAnswer
'============================
  'whenever CLAUDE doesn't know how to answer a question, this SUB is called

STATIC Last%

DO
 Pick% = FNRndNum%(1, 14)
LOOP WHILE Pick% = Last%
   
SELECT CASE Pick%
   CASE 1
      Sent$ = "What do YOU think, " + UserName$ + "? "
   CASE 2
      Sent$ = "What makes you think I can answer that? "
   CASE 3
      Sent$ = "How should I know? "
   CASE 4
      Sent$ = "That beats the heck out of me, " + AdP$(UserName$)
   CASE 5
      Sent$ = "Your guess is as good as mine, " + AdP$(UserName$)
   CASE 6
      Sent$ = "I don't know. "
   CASE 7
      Sent$ = "I'm not a know-it-all. Go find out for yourself, " + AdP$(UserName$)
   CASE 8
      Sent$ = "Don't bother me with foolish questions. "
   CASE 9
      Sent$ = Cap$(Exclam$) + "Let me mull that one over for a while. "
   CASE 10
      Sent$ = "You ask the darnedest stuff! I admire that in you. "
   CASE 11
      Sent$ = "I often ask myself that same question, " + AdP$(UserName$)
   CASE 12
      Sent$ = "Believe me. You wouldn't want to know! "
   CASE 13
      Sent$ = "I don't think that's any of your business! "
   CASE 14
      Sent$ = "That's for me to know and you to find out. "
END SELECT

Response$(1) = Sent$
Last% = Pick%

END SUB

'===================
 SUB Phone
'===================
  'mimics sound of phone. Taken from a Crescent Software newsletter.

IF INSTR(COMMAND$, "Q") THEN EXIT SUB  'was /q command line option used?

FOR X% = 1 TO 15
   SOUND 600, .5
   SOUND 500, .5
NEXT

END SUB

'==========================
 FUNCTION Plur$ (Word%)
'==========================
  'returns the plural form of any noun in Nouns$() array

Irr$ = IrrPlur$(Word%)           'check for an irregular plural

IF LEN(Irr$) THEN                'did IrrPlur return a null string?
   Plur$ = Irr$: EXIT FUNCTION   'if not, then the work is done
END IF
 
TheNoun$ = Nouns$(Word%)
 
  SELECT CASE PronArtCode%(Word%)
    CASE 0, 7                        'collective nouns and cities
       Plur$ = TheNoun$ + Spac$      'do not pluralize
       EXIT FUNCTION
    CASE 8                                     'paired nouns
       Plur$ = "pairs of " + TheNoun$ + Spac$  'are simple to pluralize
       EXIT FUNCTION
  END SELECT

  SELECT CASE ASC(RIGHT$(TheNoun$, 1))         'the last letter
    CASE 110                                   'an n
       IF RIGHT$(TheNoun$, 3) = "man" THEN
          Plural$ = LEFT$(TheNoun$, LEN(TheNoun$) - 2) + "en "
       ELSE                                    'not a "man" ending, so
          Plural$ = TheNoun$ + S$              'add s
       END IF
    CASE 121                                   'a y
         SELECT CASE ASC(RIGHT$(TheNoun$, 2))  'check next to last letter
            CASE 97, 101, 111, 117             'is it an A,E,O,U?
               Plural$ = TheNoun$ + S$         'then add an s
            CASE ELSE                          'no?
               Plural$ = LEFT$(TheNoun$, LEN(TheNoun$) - 1) + "ies "
         END SELECT
    CASE 104                                   'an h
       IF ASC(RIGHT$(TheNoun$, 2)) = 115 THEN  'if it's an sh ending
          Plural$ = TheNoun$ + ES$             'add es
       ELSE                                    'otherwise
          Plural$ = TheNoun$ + S$              'add s
       END IF
    CASE 115, 120                              'an s or x
       Plural$ = TheNoun$ + ES$                'add es
    CASE 101                                   'an e
       IF ASC(RIGHT$(TheNoun$, 2)) = 102 THEN  'if it's an fe ending
          Plural$ = LEFT$(TheNoun$, LEN(TheNoun$) - 2) + "ves "
       ELSE
          Plural$ = TheNoun$ + S$              'otherwise, add s
       END IF
    CASE ELSE                                  'not n,y,h,s,x or e
       Plural$ = TheNoun$ + S$                 'so add s
  END SELECT

  Plur$ = Plural$

END FUNCTION

'===================================================
 SUB PopWindow (LCol%, TRow%, RCol%, BRow%, Msg$)
'===================================================
    'prints a window onto the screen, according to passed parameters
    'uses a double-lined border and current COLOR statement

FillLines% = BRow% - TRow% - 1
BarLong% = RCol% - LCol% - 1
SideBar$ = CHR$(186)
LongBar$ = STRING$(BarLong%, 205)
MsgLen% = LEN(Msg$)

LOCATE TRow%, LCol%, 0     'cursor is off
PRINT CHR$(201) + LongBar$ + CHR$(187)

FOR X% = 1 TO FillLines%
    LOCATE TRow% + X%, LCol%
    PRINT SideBar$ + STRING$(BarLong%, 32) + SideBar$
NEXT X%
    
LOCATE BRow%, LCol%
PRINT CHR$(200) + LongBar$ + CHR$(188);

IF MsgLen% THEN
   IF MsgLen% < BarLong% - 2 THEN
      LOCATE TRow%, LCol% + 2
      PRINT Spac$ + Msg$ + Spac$
   END IF
END IF

END SUB

'====================
 SUB PrintHelpWin (Choice%)
'====================

LOCATE 1, 1
COLOR Fore%, Back%
PRINT STRING$(79, 205)

  TRow% = 3
  BRow% = TRow% + 7
  LEdge% = 5
  REdge% = LEdge% + 66
  Msg$ = "PRESS A KEY WHEN DONE"

CALL MemCopy(MonSeg%, VARSEG(UnderHelp%(1)), 2000)
COLOR HelpFore%, HelpBack%
CALL PopWindow(LEdge%, TRow%, REdge%, BRow%, Msg$)
    
  FirstLine% = (Choice% - 1) * 4    'Choice% is from 1-5
 
     FOR X% = 1 TO 4
       LOCATE (TRow% + X% + 1), LEdge% + 1
       PRINT HelpWinText(FirstLine% + X%).Word
     NEXT

DO
  Key$ = INKEY$
LOOP WHILE Key$ = Nul$      'waits for keystroke

 COLOR Fore%, Back%
 CALL MemCopy(VARSEG(UnderHelp%(1)), MonSeg%, 2000)

END SUB

'=====================
 FUNCTION PrnChk%
'=====================
  'this checks status of input port for the EPSON printer-ready code
  'this code was lifted from USING QUICKBASIC 4, by FELDMAN & RUGG

DEF SEG = &H40
Status& = PEEK(9) * 256 + PEEK(8) + 1

IF INP(Status&) = 223 THEN State% = 1   'printer ready
PrnChk% = State%                        'State% is zero if printer not ready
DEF SEG                                 'restore default segment

END FUNCTION

'===================
 SUB PrnWarning
'===================
  'saves screen under warning window, then prints window with
  'warning message for user to check printer readiness

  TRow% = 15
  BRow% = 19
  LEdge% = 17
  REdge% = LEdge% + 48
  Msg$ = "WHEN READY - PRESS A KEY"

CALL MemCopy(MonSeg%, VARSEG(UnderHelp%(1)), 2000)
COLOR HelpFore%, HelpBack%
CALL PopWindow(LEdge%, TRow%, REdge%, BRow%, Msg$)
   
  LOCATE TRow% + 2, LEdge% + 3, 0
  PRINT "Please check your printer. Is it READY?";

DO
  Key$ = INKEY$
LOOP WHILE Key$ = Nul$      'waits for keystroke

 COLOR Fore%, Back%
 CALL MemCopy(VARSEG(UnderHelp%(1)), MonSeg%, 2000)

END SUB

'=============================
 SUB QuesAnswer
'=============================
   'tests first few words of a question; branches to appropriate SUBs
    
   Num% = FindPad%(1)
   First$ = LCASE$(UserWords$(Num%))
   Next$ = LCASE$(UserWords$(FindPad%(Num% + 1)))
 
   IF EvalVb%(First$) = FALSE THEN
     AlsoVb% = EvalVb%(Next$)
     IF AlsoVb% = FALSE THEN CALL WhyHowQuery(First$, Next$)
     IF LEN(Response$(1)) THEN EXIT SUB
     IF Next$ = Nul$ THEN CALL OneWordQuery(First$): EXIT SUB
     IF AlsoVb% = FALSE THEN CALL OtherAnswer: EXIT SUB
   END IF
     
   IF AlsoVb% THEN SWAP First$, Next$
  
   IF EvalPro%(Next$) THEN
     CALL EasyAnswer(First$, Next$)
   ELSE
    SELECT CASE Next$
      CASE RTRIM$(Sb$), RTRIM$(SbPlur$), RTRIM$(Ob$), RTRIM$(ObPlur$)
         CALL EasyAnswer(First$, Next$)
      CASE "a", "an", "another"
         CALL EasyAnswer(First$, "it")
      CASE ELSE
         CALL OtherAnswer
     END SELECT
   END IF

END SUB

'===========================
 SUB RespondToNoInput
'===========================
STATIC Value%
Value% = Value% + 1      'keeps track of how many times this SUB is called

SELECT CASE Value%
  CASE 1
    Counter% = FNRndNum%(1, 4)
    Sent$ = RTRIM$(NoInp(Counter%).Word) + Spac$
  CASE 2
    Sent$ = RTRIM$(NoInp(5).Word) + Spac$
  CASE 3
    PRINT : PRINT RTRIM$(NoInp(6).Word) + Spac$
    SLEEP 6
    CALL EndScreen
END SELECT

 Response$(1) = Sent$
 AllRespMade% = TRUE       'sets flag for whole response being done

END SUB

'===========================
 SUB RespondToNoSense
'===========================
    'creates a response when the NoSense% flag is set to TRUE
STATIC Last%

DO
  Value% = FNRndNum%(1, 15)
LOOP WHILE Value% = Last%      'don't repeat last value

 Sent$ = RTRIM$(Gibber(Value%).Word)
 IF LEN(RTRIM$(NonSense$)) THEN
   IF INSTR(LCASE$(NonSense$), "hmm") THEN
     Sent$ = "Hmmm!!? Are you humming or talking?"
     AskedUser% = TRUE
   ELSE
     Sent$ = AdX$(Cap$(NonSense$)) + Sent$
   END IF
 END IF

 Last% = Value%
 Response$(1) = Sent$
 AllRespMade% = TRUE

END SUB

'===============================
 SUB RespondToProfanity
'===============================

 STATIC HowOften%           'keeps track of how often this sub called
 HowOften% = HowOften% + 1  'on first call sets variable to 1

 SELECT CASE HowOften%
   CASE 1
     Counter% = FNRndNum%(1, 3)
     Sent$ = RTRIM$(Obscen(Counter%).Word)
   CASE 2
     Sent$ = RTRIM$(Obscen(4).Word)
   CASE 3
     PRINT : PRINT RTRIM$(Obscen(5).Word)
     SLEEP 6
     CALL EndScreen
 END SELECT

Response$(1) = Sent$
AllRespMade% = TRUE

END SUB

'============================
 SUB Response1stPart
'============================
  'Controls branching into other SUBS where actual responses are generated.

STATIC Last%, Previous%, Prior%   'used to prevent consecutive calls

Some% = FNRndNum%(1, 100)
IF Some% MOD 3 = 0 AND FoundNoun% = 0 THEN AllRespMade% = TRUE
 
  IF NoInput% THEN
     CALL RespondToNoInput: EXIT SUB
  ELSEIF Obscene% THEN
     CALL RespondToProfanity: EXIT SUB
  ELSEIF NoSense% THEN
     CALL RespondToNoSense: EXIT SUB
  ELSEIF Some% >= 6 AND Question% = TRUE THEN
     CALL QuesAnswer: EXIT SUB
  ELSEIF Some% < 6 AND Last% = FALSE THEN
     CALL BadHearing
     Last% = TRUE: EXIT SUB
  ELSE
     Last% = FALSE
  END IF

  IF AskedUser% THEN CALL TestUserAnswer

  IF Response$(1) = Nul$ THEN CALL TestFirstWords
  
  IF LEN(Response$(1)) THEN
     EXIT SUB
  ELSEIF FoundNoun% > 0 AND Phony% = FALSE THEN
     CALL FdNounAnswer: EXIT SUB
  ELSEIF Adverb% THEN
     CALL AdvAnswer: EXIT SUB
  ELSE
     CALL CheckAdj
     IF LEN(Response$(1)) THEN EXIT SUB
  END IF

   SELECT CASE Some%
     CASE IS < 18
       BigWord$ = GetBig$
        IF LEN(BigWord$) < 5 THEN
           CALL EchoLastWord
        ELSE
           CALL EchoBigWord(BigWord$)
        END IF
     CASE 18 TO 40
        DO
          Fetch% = FNRndNum%(1, ExDim%)
        LOOP WHILE Fetch% = Previous%
         Response$(1) = RTRIM$(Exclamation(Fetch%).Word) + " Really? "
         IF AllRespMade% THEN AskedUser% = TRUE
         Previous% = Fetch%
     CASE 41 TO 65
        DO
          Fetch% = FNRndNum%(1, InitDim%)
        LOOP WHILE Fetch% = Prior%
         Response$(1) = RTRIM$(InitResp(Fetch%).Word) + Spac$
         IF Fetch% = 5 AND AllRespMade% = TRUE THEN AskedUser% = TRUE
         Prior% = Fetch%
     CASE IS > 65
        CALL Distract
   END SELECT

END SUB

'=========================
 SUB Response2ndPart
'=========================
  STATIC Last%

  IF NoResp2% THEN EXIT SUB   'flag set during some Resp1 procedures

  DO
    Choice% = FNRndNum%(1, Resp2Dim%)
  LOOP WHILE Choice% = Last%

  Response$(2) = RTRIM$(Resp2(Choice%).Word) + Spac$
  Last% = Choice%
  IF Choice% < 6 THEN R2Q% = TRUE  'flag shows a question asked in Resp2

END SUB

'=============================
 SUB Response3rdPart
'=============================
 
  STATIC LastAnswer%

  IF AllRespMade% THEN EXIT SUB          'a fail-safe
  CALL SetNewWords(FoundNoun%)           'gets initial set of random words

DO                                       'the LOOP comes after SELECT CASE
  DO: Answer% = FNRndNum%(1, 25)
  LOOP WHILE Answer% = LastAnswer%       'don't repeat last answer

 SELECT CASE Answer%
  CASE 1
     Sentance$ = Answer1$
  CASE 2
     Sentance$ = Answer2$
  CASE 3
     Sentance$ = Answer3$
  CASE 4
     Sentance$ = Answer4$
  CASE 5
     Sentance$ = Answer5$
  CASE 6
     Sentance$ = An3wer6$
  CASE 7
     Sentance$ = Answer7$
  CASE 8
     Sentance$ = Answer8$
  CASE 9
     Sentance$ = Answer9$
  CASE 10
     Sentance$ = Answer10$
  CASE 11
     Sentance$ = Answer11$
  CASE 12
     Sentance$ = Answer12$
  CASE 13
     Sentance$ = Answer13$
  CASE 14
     Sentance$ = Answer14$
  CASE 15
     Sentance$ = Answer15$
  CASE 16
     Sentance$ = Answer16$
  CASE 17
     Sentance$ = Answer17$
  CASE 18
     Sentance$ = Answer18$
  CASE 19
     Sentance$ = Answer19$
  CASE 20
     Sentance$ = Answer20$
  CASE 21
     Sentance$ = Answer21$
  CASE 22
     Sentance$ = Answer22$
  CASE 23
     Sentance$ = Answer23$
  CASE 24
     Sentance$ = Answer24$
  CASE 25
     Sentance$ = Answer25$
 END SELECT

LOOP WHILE Sentance$ = Nul$
 
  LastAnswer% = Answer%
  Response$(3) = Sentance$

END SUB

'================
 SUB SayBye
'================
    'if user says "goodbye" then this SUB is called
    'it chooses one of five exiting phrases and calls EndScreen

Pick% = FNRndNum%(1, 5)
Bye$ = "So long, " + AdX$(UserName$) + RTRIM$(ByePhrase(Pick%).Word)

CALL WrapPrint(Bye$)

SLEEP 4
CALL EndScreen

END SUB

'=======================
 SUB SetColor
'=======================
  'the routine for detecting a monochrome monitor came from
  'a magazine distributed by Crescent Software

IF INSTR(COMMAND$, "M") THEN Mono% = TRUE

  DEF SEG = 0                 'go to the bottom of memory
 
  IF PEEK(&H463) = &HB4 THEN  'this routine detects monochrome monitor
     MonSeg% = &HB000         'it's monochrome
     Mono% = TRUE
  ELSE
     MonSeg% = &HB800         'it's color
  END IF

IF Mono% THEN
   Fore% = 7       'white
   Back% = 0       'black
   MenuFore% = 7   'white
   MenuBack% = 0   'black
   HelpFore% = 0   'black
   HelpBack% = 7   'white
ELSE
   Fore% = 1       'blue
   Back% = 7       'white
   MenuFore% = 0   'black
   MenuBack% = 12  'light red
   HelpFore% = 0   'black
   HelpBack% = 7   'white
   IF INSTR(COMMAND$, "C") THEN CALL ColorMenu
END IF

END SUB

'===========================
 SUB SetNewWords (NNum%)
'===========================
  'This SUB called when an all-new, complete set of words is needed
  'If NNum% = 0 then SbNum% will be randomly chosen, otherwise it is NNum%
 
  CALL ChooseSb(NNum%)   'chooses Sb$ and associated words, sets SbNum%
  CALL ChooseVb(SbNum%)  'returns a verb/object pair matched to Sb$,
  CALL ChooseOther       'a complete set of adverbs, aux. words and phrases

END SUB

'========================
 SUB SetRegScreen
'========================
   'creates a text viewport, with messages above and below

VIEW PRINT       'turn off viewport (if it's on) before printing messages
 
  Above$ = "  CLAUDE, THE TALKING COMPUTER  "
    IF Lpt% THEN Indicator$ = CHR$(254) ELSE Indicator$ = Spac$
    Y$ = STRING$(16, 205) + " F1 HELP " + STRING$(7, 205) + " F5 PRINT ["
    Z$ = Indicator$ + "] " + STRING$(7, 205) + " F10 QUIT " + STRING$(16, 205)
 
   LOCATE 1, 1
     COLOR Fore%, Back%      'normal video
     PRINT STRING$(79, 205)
  
   LOCATE 1, 24
     COLOR Back%, Fore%      'reverse video
     PRINT Above$
  
   LOCATE 24, 1
     COLOR Fore%, Back%      'normal video restored
     PRINT Y$; Z$
  
VIEW PRINT 4 TO 21           'viewport redefined

END SUB

'=====================
 SUB ShrinkWords
'=====================
   'this transfers contents of LastWords$() array into UserWords$() array
   'then erases LastWords$() and EachSent$() arrays

IF MultiSent% THEN
   ERASE UserWords$                               'empty it
       FOR X% = 1 TO MaxUser%                     'now refill it
          UserWords$(X%) = LastWords$(X%)
          IF LastWords$(X%) = Nul$ THEN EXIT FOR
       NEXT X%
END IF

ERASE LastWords$
ERASE EachSent$

END SUB

'=================================
 FUNCTION StrTok$ (Srce$, Delim$)
'=================================
   'I copied this function from the code distributed by Microsoft
   'as part of the QuickBASIC 4.5 package. That's why it's so peculiar.
  
   STATIC Start%, SaveStr$
     IF LEN(Srce$) THEN
      Start% = 1: SaveStr$ = Srce$
     END IF

   BegPos% = Start%: Ln% = LEN(SaveStr$)
     WHILE BegPos% <= Ln% AND INSTR(Delim$, MID$(SaveStr$, BegPos%, 1)) <> 0
      BegPos% = BegPos% + 1
     WEND

     IF BegPos% > Ln% THEN
      StrTok$ = Nul$: EXIT FUNCTION
     END IF

   EndPos% = BegPos%
     WHILE EndPos% <= Ln% AND INSTR(Delim$, MID$(SaveStr$, EndPos%, 1)) = 0
      EndPos% = EndPos% + 1
     WEND
  
   StrTok$ = MID$(SaveStr$, BegPos%, EndPos% - BegPos%)
   Start% = EndPos%

END FUNCTION

'=============================
 SUB TestAllPunc
'=============================
  'takes user input, evaluates punctuation and seperates sentances/questions
   
Full$ = LTRIM$(RTRIM$(UserInput$))
Test$ = LTRIM$(RTRIM$(UserInput$))
Leng% = LEN(Test$)

IF Leng% = 0 THEN EXIT SUB             'shouldn't happen; a fail/safe
  
 FOR Count% = 1 TO Leng%
   Value% = ASC(Test$)
    
    SELECT CASE Value%
       CASE 58, 59, 34, 39             'colon/semicolon/quotemark/apostrophe
            Punc% = Punc% + 1
       CASE 33, 46, 63                 'exclam point/period/question mark
            Punc% = Punc% + 1
            IF Count% > Last% + 2 THEN
               Sent% = Sent% + 1
               IF Count% = Leng% AND ASC(Test$) = 63 THEN Question% = TRUE
                 IF Sent% <= 6 THEN
                    EachSent$(Sent%) = LEFT$(Full$, (Count% - Last%))
                    Full$ = RIGHT$(Full$, Leng% - Count%)
                    Last% = Count%
                 ELSE
                    NoSense% = TRUE     'seven or more sentances??
                    EXIT SUB            'go no further
                 END IF
            END IF
    END SELECT
 
    Test$ = RIGHT$(Test$, LEN(Test$) - 1)   'remove leftmost character
NEXT Count%                                 'loop back to test again

IF Leng% >= 6 AND Punc% / Leng% > .4 THEN   'too much punctuation
   NoSense% = TRUE
   EXIT SUB
END IF

IF Sent% > 1 THEN
   CALL GetLastSent
END IF

END SUB

'============================
 SUB TestFirstWords
'============================
  'this tests the first few words of the user's last sentance for patterns
  'then calls SUBS that fit answers to the patterns, if possible
 
 Count% = FindPad%(1)
   First$ = LCASE$(UserWords$(Count%))
 Index% = FindPad%(Count% + 1)
   Next$ = LCASE$(UserWords$(Index%))
   Third$ = LCASE$(UserWords$(Index% + 1))

 IF LEN(First$) = 0 THEN EXIT SUB
   
    GotPro% = EvalPro%(First$)
    IF GotPro% THEN
       FoundPro% = TRUE
    ELSE
       GotApos% = INSTR(First$, "'")   'is the word a contraction?
       IF GotApos% THEN
            Test$ = MID$(First$, 1, GotApos% - 1)
            NewLook% = EvalPro%(Test$)
            IF NewLook% THEN
                FoundPro% = TRUE
                Contraction$ = RIGHT$(First$, LEN(First$) - GotApos%)
                First$ = Test$
                Third$ = Next$
                Next$ = ExpndCont$(Contraction$)
            END IF
       END IF
    END IF
  
  IF FoundPro% = FALSE THEN
     FOR Count% = 1 TO VbDim%
          IF ASC(First$) = ASC(VbInfin(Count%).Word) THEN
              IF First$ = RTRIM$(VbInfin(Count%).Word) THEN
                CALL ImpAnswer(First$, Next$, Third$): EXIT SUB
              END IF
          END IF
     NEXT Count%
  ELSE
    GotVb% = EvalVb%(Next$)
    IF GotVb% THEN
       IF GotVb% > 18 AND GotVb% < 36 THEN
          Neg% = TRUE
          Next$ = RTRIM$(TestVb(GotVb% - 18).Word)
       ELSEIF GotVb% = 36 THEN
          Neg% = TRUE
          Next$ = "can"
       END IF
       IF Third$ = "not" OR Third$ = "never" THEN Neg% = TRUE
       CALL MakeAnswer(First$, Next$, Neg%): EXIT SUB
    END IF
  END IF
  
  IF FoundPro% THEN
     FOR Count% = 1 TO VbDim%
         IF ASC(Next$) = ASC(VbInfin(Count%).Word) THEN
            IF Next$ = RTRIM$(VbInfin(Count%).Word) THEN
               CALL NextAnswer(First$, Count%, Third$, Index%)
               EXIT SUB
            END IF
         END IF
     NEXT Count%
   END IF
END SUB

'===========================
 SUB TestForNoun
'===========================
   'tests each Userword against Nouns$() array, at first match sets pointer
   'it will not recognize city names, although they are among the "nouns"
   
FoundNoun% = 0                      'reset pointer to zero
Index% = 1                          'a counter into UserWords$() array
User$ = LCASE$(UserWords$(Index%))  'sets variable to first UserWord

DO
  IF LEN(User$) > 2 THEN    'words of 1 or 2 letters not tested
     
      FOR Count% = 1 TO NotNDim%
          IF ASC(User$) = ASC(NotNoun$(Count%)) THEN
             IF User$ = NotNoun$(Count%) THEN
                GOTO NoNoun
             END IF
          END IF
      NEXT Count%

    FOR Counter% = 1 TO Locations%
       Test$ = Nouns$(Counter%)
      
         IF ASC(User$) = ASC(Test$) THEN
            SecondWord% = INSTR(3, Test$, Spac$)      'is Test$ two words?

            IF SecondWord% THEN                       'if it is then
               TestA$ = LEFT$(Test$, SecondWord% - 1) 'seperate first word
              
               IF LEN(User$) = LEN(TestA$) THEN       'and compare lengths
                  IF User$ = TestA$ THEN              'check for exact  match
                     TestB$ = RIGHT$(Test$, LEN(Test$) - SecondWord%)
                     NextUser$ = LCASE$(UserWords$(Index% + 1))
                       IF TestB$ = NextUser$ THEN
                         FoundNoun% = Counter%: EXIT SUB
                       ELSEIF TestB$ + "s" = NextUser$ THEN
                         FoundNoun% = Counter%: EXIT SUB
                       END IF
                  END IF
               END IF
            ELSE                                      'Test$ is one word
              IF LEN(User$) = LEN(Test$) THEN
                  IF User$ = Test$ THEN
                     FoundNoun% = Counter%: EXIT SUB
                  ELSEIF RIGHT$(User$, 3) = "men" THEN
                     IF User$ = LEFT$(Test$, LEN(Test$) - 2) + "en" THEN
                        FoundNoun% = Counter%: EXIT SUB
                     END IF
                  END IF
              ELSEIF LEN(User$) = LEN(Test$) + 1 THEN
                  IF User$ = Test$ + "s" THEN
                     FoundNoun% = Counter%: EXIT SUB
                  END IF
              END IF
            END IF
         END IF
    NEXT Counter%
  END IF
NoNoun:
  Index% = Index% + 1              'increments for next User word
  User$ = LCASE$(UserWords$(Index%))
LOOP UNTIL LEN(User$) = 0

'If execution reaches here, no noun was actually recognized in UserWords
'However, Claude will randomly treat the old SbNum% as if the user had
'mentioned it.

 IF FNRndNum%(1, 8) = 1 THEN  'use a random quantity to....
   FoundNoun% = SbNum%       '  identify the old SbNum% with FoundNoun%
   Phony% = TRUE             'it's phony, since there wasn't a found noun
 END IF

END SUB

'==============================
 SUB TestObscenity (Word$)
'==============================

Leng% = LEN(Word$)
IF Leng% < 4 THEN EXIT SUB
Test$ = LCASE$(Word$)

Check% = INSTR(Test$, "fuck")
  IF Check% THEN
   Obscene% = TRUE
   EXIT SUB
  END IF
Check% = INSTR(Test$, "shit")
  IF Check% THEN
   Obscene% = TRUE
   EXIT SUB
  END IF
Check% = INSTR(Test$, "cunt")
  IF Check% THEN
   Obscene% = TRUE
   EXIT SUB
  END IF
Check% = INSTR(Test$, "prick")
  IF Check% THEN
   Obscene% = TRUE
   EXIT SUB
  END IF

IF Leng% < 8 THEN EXIT SUB

Check% = INSTR(Test$, "cocksuck")
  IF Check% THEN
    Obscene% = TRUE
    EXIT SUB
  END IF

END SUB

'=====================
 SUB TestUserAnswer
'=====================
    'this is called when AskedUser% flag is set TRUE, which indicates
    'the user has been asked a yes/no question. This tests to see
    'whether the user has responded with a yes/no answer.
   
  FOR Count% = 1 TO 5                    'tests only first five words
    Test$ = LCASE$(UserWords$(Count%))
    IF LEN(Test$) = 0 THEN EXIT FOR
   
    SELECT CASE ASC(Test$)
      CASE 110    'small n
        SELECT CASE Test$
          CASE "no", "never", "nope", "not", "nah"
             No% = TRUE: EXIT FOR
        END SELECT
      CASE 121    'small y
        SELECT CASE Test$
          CASE "yes", "yup", "yeah"
             Yes% = TRUE: EXIT FOR
        END SELECT
      CASE 97   'small a
        SELECT CASE Test$
          CASE "always", "almost"
             Yes% = TRUE: EXIT FOR
        END SELECT
    END SELECT
   
    IF INSTR(Test$, "n't") THEN
       No% = TRUE: EXIT FOR
    END IF

  NEXT Count%

  IF No% THEN
     Response$(1) = "No. I suppose not. "
  ELSEIF Yes% THEN
     Response$(1) = "Yes. That makes a lot of sense. "
  END IF

  AskedUser% = FALSE    'resets flag for next go-around

END SUB

'====================================
 SUB TestVowelRatio (Word$)
'====================================
  'counts vowels and consonants in "words" to see if their ratio
  'makes some kind of sense, compared to real words
 
  Leng% = LEN(Word$)
  Test$ = LCASE$(Word$)

 FOR Count% = 1 TO Leng%
     SELECT CASE ASC(MID$(Test$, Count%))
       CASE 97, 101, 105, 111, 117, 121       'a/e/i/o/u/y
         Vowel% = Vowel% + 1                  'count it
       CASE 39, 45                            'an apostrophe/hyphen, so
         Leng% = Leng% - 1                    'eliminate it from ratio calc
       CASE 98 TO 122                         'it's a consonant: do nothing
       CASE ELSE                              'it's not, so
         NoSense% = TRUE                      'it's nonsense
         EXIT SUB                             'case dismissed
     END SELECT
 NEXT Count%

IF Vowel% = 0 THEN
  NoSense% = TRUE: EXIT SUB
END IF

IF ASC(Word$) = 121 OR ASC(Word$) = 89 THEN   'word begins with Y
  Ratio! = (Vowel% - 1) / Leng%               'initial Y isn't a vowel
ELSE
  Ratio! = Vowel% / Leng%
END IF

SELECT CASE Ratio!
   CASE IS < .165                  'fewer than 1 vowel per 6 characters
      NoSense% = TRUE: EXIT SUB
   CASE IS > .75
      IF LEN(Word$) > 3 THEN       'more than 3 vowels per 4 characters
          NoSense% = TRUE: EXIT SUB
      END IF
END SELECT

END SUB

'=========================
 FUNCTION TestWhyHow% (Word$)
'=========================
  'tests Word$ for a match. It returns position of match or FALSE%.

IF LEN(Word$) = 0 THEN EXIT FUNCTION

FOR Counter% = 1 TO WhyHowDim%
  IF ASC(Word$) = ASC(WhyHow(Counter%).Word) THEN
     IF Word$ = RTRIM$(WhyHow(Counter%).Word) THEN
        GotIt% = TRUE: EXIT FOR
     END IF
  END IF
NEXT Counter%

IF GotIt% = TRUE THEN TestWhyHow% = Counter% ELSE TestWhyHow% = FALSE

END FUNCTION

'=============================
 SUB TitleUp
'=============================
   'spells "CLAUDE" on opening screen with block-characters

CLS

G$ = STRING$(2, 219)
B$ = "   "             'some spaces

C1$ = STRING$(9, 219)
C2$ = G$ + STRING$(5, " ") + G$
C3$ = G$ + STRING$(7, " ")
C4$ = C3$: C5$ = C2$: C6$ = C1$

L1$ = C3$: L2$ = L1$: L3$ = L1$: L4$ = L1$: L5$ = L1$: L6$ = C1$

A1$ = B$ + STRING$(3, 219) + B$
A2$ = "  " + G$ + " " + G$ + "  "
A3$ = " " + G$ + CHR$(221) + " " + CHR$(222) + G$ + " "
A4$ = " " + STRING$(7, 219) + " "
A5$ = CHR$(222) + CHR$(219) + CHR$(221) + "   " + CHR$(222) + CHR$(219) + CHR$(221)
A6$ = G$ + "     " + G$

U1$ = A6$: U2$ = U1$: U3$ = U1$: U4$ = U1$: U5$ = U1$: U6$ = C1$

D1$ = STRING$(8, 219) + CHR$(221)
D2$ = A6$: D3$ = A6$: D4$ = A6$: D5$ = A6$: D6$ = D1$

E1$ = C1$: E2$ = C3$: E3$ = G$ + G$ + G$
E4$ = C3$: E5$ = C3$: E6$ = E1$

LOCATE 6, 5: PRINT C1$ + B$ + L1$ + B$ + A1$ + B$ + U1$ + B$ + D1$ + B$ + E1$
LOCATE 7, 5: PRINT C2$ + B$ + L2$ + B$ + A2$ + B$ + U2$ + B$ + D2$ + B$ + E2$
LOCATE 8, 5: PRINT C3$ + B$ + L3$ + B$ + A3$ + B$ + U3$ + B$ + D3$ + B$ + E3$
LOCATE 9, 5: PRINT C4$ + B$ + L4$ + B$ + A4$ + B$ + U4$ + B$ + D4$ + B$ + E4$
LOCATE 10, 5: PRINT C5$ + B$ + L5$ + B$ + A5$ + B$ + U5$ + B$ + D5$ + B$ + E5$
LOCATE 11, 5: PRINT C6$ + B$ + L6$ + B$ + A6$ + B$ + U6$ + B$ + D6$ + B$ + E6$

LOCATE 16, 27, 0
PRINT "THE TALKING COMPUTER"

CALL Twiddlesound                             'a sound routine

IF INSTR(COMMAND$, "P") THEN                  'parameter for printing ON
   PrnOK% = PrnChk%                           'check printer status
   IF PrnOK% = FALSE THEN CALL PrnWarning     'if status not OK, warn user
   Lpt% = TRUE                                'set flag for printing ON
END IF

LOCATE 22, 28
Message$ = "CLAUDE is loading."
PRINT Message$

END SUB

'====================
 SUB Twiddlesound
'====================
  'this sound routine taken from a newsletter put out by Crescent Software

IF INSTR(COMMAND$, "Q") THEN EXIT SUB

FOR X% = 1 TO 55
  SOUND RND * 1500 + 100, RND
NEXT

END SUB

'=============================
 SUB WhyHowQuery (First$, Next$)
'=============================
    ' a SUB called by QuesAnswer when Question% is TRUE
    ' it looks for a why/how/when type question and answers it

GotIt% = TestWhyHow%(First$)

SELECT CASE GotIt%
  CASE 0
    EXIT SUB               'no why/how/when word found
  CASE 1
    IF Next$ = "not" THEN
       Response$(1) = "Yes, " + UserName$ + "... why not? "
       EXIT SUB
    END IF
  CASE 2
    IF LEN(Next$) THEN      'makes sure Next$ isn't a null string
         FOR Count% = 1 TO AdjDim%
           IF ASC(Next$) = ASC(Adjective(Count%).Word) THEN
              IF Next$ = RTRIM$(Adjective(Count%).Word) THEN
                 SELECT CASE FNRndNum%(1, 2)
                   CASE 1
                    Ans$ = Cap$(Int$ + AdX$(Next$)) + "That's how " + AdX$(Next$)
                   CASE 2
                    Ans$ = Cap$(GetCmpAdj$(Count%)) + "than you think. "
                 END SELECT
                 Response$(1) = Ans$
                 EXIT SUB
              END IF
           END IF
         NEXT Count%
    END IF
    IF LEN(Next$) = 4 THEN
         SELECT CASE Next$
           CASE "much"
              GotIt% = 8
           CASE "many"
              GotIt% = 9
           CASE "long"
              GotIt% = 10
           CASE "come"
              GotIt% = 1   ' how come is equivalent to why
         END SELECT
    END IF
  CASE 5
    IF Next$ = "cares" THEN GotIt% = 11
  CASE 6
    IF Next$ = Nul$ THEN EXIT SUB
END SELECT

Add% = FIX(RND * 2)               'Add% will equal 1 or 0
GotIt% = (GotIt% * 2) + Add%      'GotIt% will equal 2 to 23
Answer$ = RTRIM$(WHowAns(GotIt% - 1).Word)

Response$(1) = Answer$ + Spac$

END SUB

'==========================
 SUB WrapPrint (ToPrint$)
'==========================
 'prints a long string to the display (or printer) with word wrap

 Row% = 65
 PRINT                    'an empty line above
 IF Lpt% THEN LPRINT

DO
  LengNow% = LEN(ToPrint$)
 
  FOR X% = 1 TO 15
    Temp$ = MID$(ToPrint$, (Row% + X%), 1)  'Temp$ is always one letter long
    IF LEN(Temp$) = 0 THEN EXIT DO
   
    IF ASC(Temp$) = 32 THEN           'looks for first space
      Printable$ = LTRIM$(LEFT$(ToPrint$, (Row% + X%)))
      PRINT Printable$
      IF Lpt% THEN LPRINT Printable$
      ToPrint$ = MID$(ToPrint$, (Row% + X%), (LengNow% - ((Row% + X%) - 1)))
      EXIT FOR
    ELSEIF X% = 15 THEN
      Printable$ = LEFT$(ToPrint$, (Row% + X%))
      PRINT Printable$
      IF Lpt% THEN LPRINT Printable$
      ToPrint$ = MID$(ToPrint$, (Row% + X%), (LengNow% - ((Row% + X%) - 1)))
    END IF
 
  NEXT X%
LOOP WHILE LEN(ToPrint$) > Row%

PRINT RTRIM$(LTRIM$(ToPrint$))
PRINT                                    'an empty line below

IF Lpt% THEN
  LPRINT RTRIM$(LTRIM$(ToPrint$)): LPRINT
END IF

END SUB

